; Resourced version of A4000 bonus (40.1) from Amiga ROM 3.1 for Amiga68k ROM 1.0
; For easy recognition all changes are done using lower cases and ";" signs
; Original code is removed with ";" signs
; New code is added using lower cases only

; We made it...
; OS Group: Bryce Nesbitt, Michael Sinz, Peter Cherna, Darren Greenwald, Randell Jesup, Jerry Horanoff
; GFX: Allan Havemose, Barry 'Bart' Whitebook, Spence Shanson, Steve Beats, Chris Green, Ray Brand, Jim Barkley
; Special Projects: Eric Cotton, Martin Hunt, Bill Koester, Martin Taillefer, Brian Jackson, Kaori Kuwata, David Junod, Palmyra Pawlik, Kevin Klop
; NET: Brian Jackson, Greg Miller, Kenneth Dyke
; GUI: Peter Cherna, Martin Taillefer, David Junod, Kaori Kuwata
; Others: Andy Finkel, Dale 'Duck' Luck, Jim 'Jimm' Mackraz, Bob 'Kodiak' Burns, Jeff Porter, Carolyn Scheppner, David Haynie,
; Lauren Brown, CATS (Commodore Amiga Technical Support), QA (Quality Assurance), SA (Software Assurance)
; Thanks to: Bill Hawes, Software Distillery
; Better than ever.

MatchTag
	ILLEGAL				; match word
	dc.l	MatchTag		; match tag
	dc.l	EndSkip			; end skip
	dc.b	1			; flags
	dc.b	$28			; version
	dc.b	0			; type
	dc.b	$65			; priority
	dc.l	A4000bonus.MSG		; name
	dc.l	bonus40115293.MSG	; id string
	dc.l	Init			; init code

Init
	BTST	#2,$129(A6)		; 68030+ CPU check
	BEQ.B	Quit
	MOVEM.L	D2-D7/A2-A5,-(SP)
	MOVEQ	#$66,D0
	MOVEQ	#2,D1			; chipmem
	JSR	-$C6(A6)		; AllocMem
	TST.L	D0
	BEQ.B	Quit
	MOVEA.L	D0,A1
	MOVEA.L	D0,A5
	LEA	userFunc(PC),A0
	MOVEQ	#$32,D0
Copy
	MOVE.W	(A0)+,(A1)+
	DBF	D0,Copy
	JSR	-$27C(A6)		; CacheClearU (no input)
	BTST	#3,$129(A6)		; 68040 CPU check
	SEQ	D3			; D3 input
	MOVEQ	#0,D0
	MOVEQ	#-1,D1
	JSR	-$288(A6)		; CacheControl (D0/D1 input)
	MOVE.L	D0,-(SP)		; output
	JSR	-$1E(A6)		; Supervisor (A5 input)
	MOVE.L	(SP)+,D0
	MOVE.L	D0,D1
	JSR	-$288(A6)		; CacheControl (D0/D1 input)
	MOVEA.L	A5,A1
	MOVEQ	#$66,D0
	JSR	-$D2(A6)		; FreeMem
	MOVEM.L	(SP)+,D2-D7/A2-A5
Quit
	MOVEQ	#0,D0
	RTS

* Register usage:
*    a4    - pointer to the RAMSEY register...
*    a3    - pointer at memory under test...
*    a2    - temp pointer...
*    d4-d7    - saved memory...  (memory under test)
*    d3    - the 68040 flag... (set from above)
*    d2    - General flag mask for RAMSEY...
*    d0-d1    - scrap...
*
* This is the test for Static Column Dynamic RAM (aka "SCRAM").   Quite
* magic and messy, and that's after improvements.  You basically turn on
* the feature, and if all ram stops working, you've got a system without
* SCRAM.  Since the OS may be running from FAST memory we have this
* problem of the code going away if you don't have SCRAM memory so we
* also copy the test to CHIP memory first.  What a pain!
*
* For future compatiblity, Ramsey registers must be accessed in supervisor
* mode.  This code must run DISABLED, and not cause any MMU table searches.
* Chip ram is ok, chip registers or funny timing is not.  Test must be
* complete before the next refresh cycle.  Must never write while in
* "SCRAM" mode on an A4000 or may fry the hardware.  Must restore
* any values that may have been trashed in the test.  Must not turn on
* "WRAP TERMINATION" if running a 68040.  I'm trapped in a fortune cookie
* factory and can't wake up.

userFunc
	ORI.W	#$700,SR
	LEA	$DE0003,A4	; A3000_RamControl
	LEA	$7F7FFF0,A3
	MOVEQ	#7,D2
	CMPI.B	#$7F,$40(A4)	; A3000_RamseyVersion, ANCIENT_RAMSEY = $7F
	BEQ.B	Exit
	MOVEM.L	(A3),D4-D7
	MOVEA.L	A3,A2
	MOVE.L	A2,(A2)+
	MOVE.L	A2,(A2)+
	MOVE.L	A2,(A2)+
	MOVE.L	A2,(A2)+
	MOVE.L	D2,D0
	OR.B	(A4),D0
	NOP	              ; Sync the bus...
	MOVE.B	D0,(A4)
Loop1	NOP	              ; Sync the bus...
	MOVE.B	(A4),D1
	AND.B	D2,D1
	CMP.B	D2,D1
	BNE.B	Loop1
	MOVE.L	D2,D0
	MOVEQ	#3,D1
Compare	CMPA.L	-(A2),A2
	DBNE	D1,Compare
	BNE.B	Skip
	MOVEQ	#4,D0
	AND.B	D3,D0
	ADDQ.L	#1,D0
Skip	NOT.L	D0
	AND.B	(A4),D0
	NOP	              ; Sync the bus...
	MOVE.B	D0,(A4)
	AND.B	D2,D0
Loop2	NOP	              ; Sync the bus...
	MOVE.B	(A4),D1
	AND.B	D2,D1
	CMP.B	D0,D1
	BNE.B	Loop2
	MOVEM.L	D4-D7,(A3)
Exit	RTE

A4000bonus.MSG	dc.b	'A4000 bonus',0
bonus40115293.MSG	dc.b	'bonus 40.2 (8.9.93)',$D,$A,0
	cnop	0,4
EndSkip
