; Resourced version of battmem.resource (39.2) from Amiga ROM 3.1 for Amiga68k ROM 1.0
; For easy recognition all changes are done using lower cases and ";" signs
; Original code is removed with ";" signs
; New code is added using lower cases only

; Originally written by:
; rsbx
; spence (Spence Shanson)
; mks (Michael Sinz)
; jesup (Randell Jesup)
; peter (Peter Cherna)

; We made it...
; OS Group: Bryce Nesbitt, Michael Sinz, Peter Cherna, Darren Greenwald, Randell Jesup, Jerry Horanoff
; GFX: Allan Havemose, Barry 'Bart' Whitebook, Spence Shanson, Steve Beats, Chris Green, Ray Brand, Jim Barkley
; Special Projects: Eric Cotton, Martin Hunt, Bill Koester, Martin Taillefer, Brian Jackson, Kaori Kuwata, David Junod, Palmyra Pawlik, Kevin Klop
; NET: Brian Jackson, Greg Miller, Kenneth Dyke
; GUI: Peter Cherna, Martin Taillefer, David Junod, Kaori Kuwata
; Others: Andy Finkel, Dale 'Duck' Luck, Jim 'Jimm' Mackraz, Bob 'Kodiak' Burns, Jeff Porter, Carolyn Scheppner, David Haynie,
; Lauren Brown, CATS (Commodore Amiga Technical Support), QA (Quality Assurance), SA (Software Assurance)
; Thanks to: Bill Hawes, Software Distillery (Dave Baker, Ed Burnette, Stan Chow,
; Alan Beale, Bruce Drake, Andy Mercier, Mary Ellen Toebes, Jim Cooper, Mike Witcher,
; Jay Denebeim, John Mainwaring, Gordon Keener, Jack Rouse, John Toebes, Doug Walker)
; Better than ever.

;lbC03FB50	ILLEGAL
;	dc.l	lbC03FB50
;	dc.l	lbC03FD34
;	dc.l	$1270845
;	dc.l	battmemresour.MSG
;	dc.l	battmem392639.MSG
;	dc.l	lbC03FBD4
;battmemresour.MSG	dc.b	'battmem.resource',0,0
;battclockreso.MSG1	dc.b	'battclock.resource',0,0
;battmem392639.MSG	dc.b	'battmem 39.2 (6.3.92)',$D,$A,0
;lbW03FBA8	dc.w	$FFFF
;	dc.w	lbC03FC2C-lbW03FBA8
;	dc.w	lbC03FC3E-lbW03FBA8
;	dc.w	lbC03FC50-lbW03FBA8
;	dc.w	lbC03FCC2-lbW03FBA8
;	dc.w	$FFFF
;lbW03FBB4	dc.w	$A008
;	dc.w	$800
;	dc.w	$800A
;	dc.l	battmemresour.MSG
;	dc.l	$A00E0600
;	dc.l	$90140027
;	dc.l	$90160002
;	dc.w	$8018
;	dc.l	battmem392639.MSG
;	dc.l	0

*****i* battmem.resource/internal/InitCode ***************************
*
*   NAME
*	InitCode -- Initialize the resource from nothing.
*
*   SYNOPSIS
*	InitCode()
*
*	void InitCode( );
*
*   FUNCTION
*	This routine initializes the battmem.resource from nothing.
*
*   INPUTS
*
*   RESULTS
*
*   NOTES
*
*   SEE ALSO
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*   REGISTER USAGE
*
*	A3 -- battclock.resource pointer
*	A2 -- battmem.resource pointer
*

;lbC03FBD4	MOVEM.L	D2/A2/A3/A6,-(SP)
;	SUBA.L	A2,A2				; for no resource case
;	LEA	battclockreso.MSG1(PC),A1	; find the clock
;	JSR	-$1F2(A6)
;	TST.L	D0
;	BEQ.S	lbC03FC24
;	MOVEA.L	D0,A3			; battclockLib base
;	LEA	lbW03FBA8(PC),A0	; point to correct set of offsets
;	LEA	lbW03FBB4(PC),A1	; initialize the library node
;	SUBA.L	A2,A2
;	MOVEQ	#$5A,D0
;	JSR	-$54(A6)		; make us a playpen
;	MOVEA.L	D0,A2			; save the base
;	TST.L	D0			; was there a hitch?
;	BEQ.S	lbC03FC24		; damn
;	MOVE.L	#0,$22(A2)	; for BattMem, bug !!! must be move.w
;	MOVE.L	A6,$24(A2)	; set our data
;	MOVE.L	A3,$28(A2)
;	LEA	$2C(A2),A0	; to prevent conflicts
;	JSR	-$22E(A6)
;	MOVEA.L	A2,A1
;	JSR	-$1E6(A6)	; yea! we made it
;	MOVEA.L	A2,A6		; a6 now has BattClockBase
;	MOVEQ	#0,D1
;	MOVEQ	#1,D2
;	BSR.S	lbC03FC50	; do a read so to set checksum
;lbC03FC24	MOVE.L	A2,D0	; battclockbase or NULL
;	MOVEM.L	(SP)+,D2/A2/A3/A6
;	RTS


******* battmem.resource/ObtainBattSemaphore *************************
*
*   NAME
*	ObtainBattSemaphore -- Obtain access to nonvolatile ram. (V36)
*
*   SYNOPSIS
*	ObtainBattSemaphore( )
*
*	void ObtainBattSemaphore( void );
*
*   FUNCTION
*	Aquires exclusive access to the system nonvolatile ram.
*
*   INPUTS
*
*   RESULTS
*
*   NOTES
*
*   SEE ALSO
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*   REGISTER USAGE
*
*

;lbC03FC2C	LEA	$2C(A6),A0	; grab the semaphore
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$24(A6),A6
;	JSR	-$234(A6)
;	MOVEA.L	(SP)+,A6
;	RTS

******* battmem.resource/ReleaseBattSemaphore ************************
*
*   NAME
*	ReleaseBattSemaphore -- Allow nonvolatile ram to others.  (V36)
*
*   SYNOPSIS
*	ReleaseBattSemaphore( )
*
*	void ReleaseBattSemaphore( void );
*
*   FUNCTION
*	Relinquish exclusive access to the system nonvolatile ram.
*
*   INPUTS
*
*   RESULTS
*
*   NOTES
*
*   SEE ALSO
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*   REGISTER USAGE
*
*

;lbC03FC3E	LEA	$2C(A6),A0	; grab the semaphore
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$24(A6),A6
;	JSR	-$23A(A6)
;	MOVEA.L	(SP)+,A6
;	RTS

******* battmem.resource/ReadBattMem *********************************
*
*   NAME
*	ReadBattMem -- Read a bitstring from nonvolatile ram.  (V36)
*
*   SYNOPSIS
*	Error = ReadBattMem( Buffer, Offset, Len )
*	D0                   A0      D0      D1
*
*	ULONG ReadBattMem( APTR, ULONG, ULONG );
*
*   FUNCTION
*	Read a bitstring from nonvolatile ram.
*
*   INPUTS
*	Buffer          Where to put the bitstring.
*	Offset          Bit offset of first bit to read.
*	Len             Length of bitstring to read.
*
*   RESULTS
*	Error           Zero if no error.
*
*   NOTES
*	The battery-backed memory is checksummed. If a checksum error
*	is detected, all bits in the battery-backed memory are
*	silently set to zero.
*
*	Bits in the battery-backed memory that do not exist are read
*	as zero.
*
*	Partial byte reads (less than 8 bits) result in the bits read
*	being put in the low-order bits of the destination byte.
*
*   SEE ALSO
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*   REGISTER USAGE
*
*

;lbC03FC50	MOVEM.L	D0/D1/A0,-(SP)
;	LEA	$2C(A6),A0		; grab the semaphore
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$24(A6),A6
;	JSR	-$234(A6)
;	MOVEA.L	(SP)+,A6
;	MOVEM.L	(SP)+,D0/D1/A0
;	MOVEM.L	D2-D5/A2,-(SP)
;	MOVEA.L	A0,A2			; buffer
;	MOVE.L	D0,D5			; offset
;	MOVE.L	D1,D3
;	MOVE.L	D1,D4
;	ANDI.L	#7,D4			; len%8
;	LSR.L	#3,D3			; len/8 (byte count)
;	BEQ.S	lbC03FC96
;	MOVEQ	#8,D2
;lbC03FC80	MOVE.L	D5,D1		; offset
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$28(A6),A6
;	JSR	-$18(A6)
;	MOVEA.L	(SP)+,A6
;	MOVE.B	D0,(A2)+
;	ADDQ.L	#8,D5			; offset
;	SUBQ.L	#1,D3			; len (byte)
;	BNE.S	lbC03FC80
;lbC03FC96	MOVE.L	D4,D2		; len (bit)
;	BEQ.S	lbC03FCAA
;	MOVE.L	D5,D1			; offset
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$28(A6),A6
;	JSR	-$18(A6)
;	MOVEA.L	(SP)+,A6
;	MOVE.B	D0,(A2)+
;lbC03FCAA	MOVEM.L	(SP)+,D2-D5/A2
;	LEA	$2C(A6),A0		; grab the semaphore
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$24(A6),A6
;	JSR	-$23A(A6)
;	MOVEA.L	(SP)+,A6
;	MOVEQ	#0,D0
;	RTS

******* battmem.resource/WriteBattMem ********************************
*
*   NAME
*	WriteBattMem -- Write a bitstring to nonvolatile ram.  (V36)
*
*   SYNOPSIS
*	Error = WriteBattMem( Buffer, Offset, Len )
*	D0                    A0      D0      D1
*
*	ULONG WriteBattMem( APTR, ULONG, ULONG );
*
*   FUNCTION
*	Write a bitstring to the nonvolatile ram.
*
*   INPUTS
*	Buffer          Where to get the bitstring.
*	Offset          Bit offset of first bit to write.
*	Len             Length of bitstring to write.
*
*   RESULTS
*	Error           Zero if no error.
*
*   NOTES
*	The battery-backed memory is checksummed. If a checksum error
*	is detected, all bits in the battery-backed memory are
*	silently set to zero.
*
*	Partial byte writes (less than 8 bits) result in the bits
*	written being read from the low-order bits of the source byte.
*
*   SEE ALSO
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*   REGISTER USAGE
*
*

;lbC03FCC2	MOVEM.L	D0/D1/A0,-(SP)
;	LEA	$2C(A6),A0		; grab the semaphore
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$24(A6),A6
;	JSR	-$234(A6)
;	MOVEA.L	(SP)+,A6
;	MOVEM.L	(SP)+,D0/D1/A0
;	MOVEM.L	D2-D5/A2,-(SP)
;	MOVEA.L	A0,A2			; buffer
;	MOVE.L	D0,D5			; offset
;	MOVE.L	D1,D3
;	MOVE.L	D1,D4
;	ANDI.L	#7,D4			; len%8
;	LSR.L	#3,D3			; len/8 (byte count)
;	BEQ.S	lbC03FD08
;	MOVEQ	#8,D2
;lbC03FCF2	MOVE.L	D5,D1		; offset
;	MOVE.B	(A2)+,D0
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$28(A6),A6
;	JSR	-$1E(A6)
;	MOVEA.L	(SP)+,A6
;	ADDQ.L	#8,D5			; offset
;	SUBQ.L	#1,D3
;	BNE.S	lbC03FCF2		; len (byte)
;lbC03FD08	MOVE.L	D4,D2		; len (bit)
;	BEQ.S	lbC03FD1C
;	MOVE.L	D5,D1			; offset
;	MOVE.B	(A2)+,D0
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$28(A6),A6
;	JSR	-$1E(A6)
;	MOVEA.L	(SP)+,A6
;lbC03FD1C	MOVEM.L	(SP)+,D2-D5/A2
;	LEA	$2C(A6),A0		; grab the semaphore
;	MOVE.L	A6,-(SP)
;	MOVEA.L	$24(A6),A6
;	JSR	-$23A(A6)
;	MOVEA.L	(SP)+,A6
;	MOVEQ	#0,D0
;	RTS

;lbC03FD34				; For the EndSkip

MatchTag
	ILLEGAL				; match word
	dc.l	MatchTag		; match tag
	dc.l	EndSkip			; end skip
	dc.b	1			; flags
	dc.b	$28			; version
	dc.b	8			; type
	dc.b	$45			; priority
	dc.l	battmemresour.MSG	; name
	dc.l	battmem392639.MSG	; id string
	dc.l	InitResource		; init code
Vectors
	dc.w	$FFFF
	dc.w	ObtainBattSemaphore-Vectors	;  -6 _LVOObtainBattSemaphore
	dc.w	ReleaseBattSemaphore-Vectors	; -12 _LVOReleaseBattSemaphore
	dc.w	ReadBattMem-Vectors		; -18 _LVOReadBattMem
	dc.w	WriteBattMem-Vectors		; -24 _LVOWriteBattMem
	dc.w	$FFFF
Structure
	dc.w	$A008			; base offset $8
	dc.w	$0800			; type
	dc.w	$800A			; base offset $A
	dc.l	battmemresour.MSG	; name
	dc.w	$A00E			; base offset $E
	dc.w	$0600			; flags
	dc.w	$9014			; base offset $14
	dc.w	$0028			; version
	dc.w	$9016			; base offset $16
	dc.w	$0000			; revision
	dc.w	$8018			; base offset $18
	dc.l	battmem392639.MSG	; id string
	dc.w	0			; no more

InitResource
	movem.l	D2/A2/A3/A6,-(SP)
	lea	battclockreso.MSG1(PC),A1
	jsr	-$1F2(A6)		; OpenResource
	tst.l	D0
	beq.b	Quit
	move.l	D0,A3
	lea	Vectors(PC),A0
	lea	Structure(PC),A1
	sub.l	A2,A2
	moveq	#$5A,D0			; dSize
	jsr	-$54(A6)		; MakeLibrary
	tst.l	D0
	beq.b	Quit
	move.l	D0,A2
	lea	$22(A2),A0
	clr.w	(A0)+			; possible bug here
	move.l	A6,(A0)+		; exec base
	move.l	A3,(A0)+		; battclock base, set A0
	jsr	-$22E(A6)		; InitSemaphore
	move.l	A2,A1
	jsr	-$1E6(A6)		; AddResource
	move.l	A2,A6
	moveq	#0,D1
	moveq	#1,D2
	bsr.b	ReadBattMem
	move.l	A2,D0			; resource base
Quit
	movem.l	(SP)+,D2/A2/A3/A6
	rts

ObtainBattSemaphore
	lea	-$234.W,A1
	bra.b	SemaphoreMain		; ObtainSemaphore

ReleaseBattSemaphore
	lea	-$23A.W,A1
SemaphoreMain
	lea	$2C(A6),A0
	move.l	A6,-(SP)
	move.l	$24(A6),A6		; exec base
	jsr	(A6,A1.W)		; ReleaseSemaphore
	move.l	(SP)+,A6
	rts

; D1 - input
; D2 - input
; A0 - input
; A6 - resource base

ReadBattMem
	lea	ReadBatt(PC),A1
	bra.b	BattMain

; D1 - input
; D2 - input
; A0 - input
; A6 - resource base

WriteBattMem
	lea	WriteBatt(PC),A1
BattMain
	movem.l	D2-D7/A2/A3/A6,-(SP)
	move.l	A0,A2
	move.l	A1,A3
	move.l	D0,D5
	move.l	D1,D3
	lea	$24(A6),A0
	move.l	(A0)+,A6		; exec base
	move.l	(A0)+,D6		; battclock base, set A0
	move.l	A0,D7			; backup A0
	jsr	-$234(A6)		; ObtainSemaphore
	exg	D6,A6			; battclock base
	moveq	#7,D4
	and.l	D3,D4
	lsr.l	#3,D3
	beq.b	SkipBatt
	moveq	#8,D2
LoopBatt
	jsr	(A3)
	addq.l	#8,D5
	subq.l	#1,D3
	bne.b	LoopBatt
SkipBatt
	move.l	D4,D2
	beq.b	LastBatt
	jsr	(A3)
LastBatt
	exg	D6,A6			; exec base
	move.l	D7,A0
	jsr	-$23A(A6)		; ReleaseSemaphore
	movem.l	(SP)+,D2-D7/A2/A3/A6
	moveq.l	#0,D0
	rts

WriteBatt
	move.l	D5,D1
	move.b	(A2)+,D0		; write
	jmp	-$1E(A6)		; _LVOWriteBattClockMem

ReadBatt
	move.l	D5,D1
	jsr	-$18(A6)		; _LVOReadBattClockMem
	move.b	D0,(A2)+		; read
	rts

battmemresour.MSG	dc.b	'battmem.resource',0
battclockreso.MSG1	dc.b	'battclock.resource',0
battmem392639.MSG	dc.b	'battmem 40.0 (25.1.2012)',$D,$A,0

	cnop	0,4
EndSkip
