; Resourced version of cia.resource (39.1) from Amiga ROM 3.1 for Amiga68k ROM 1.0
; For easy recognition all changes are done using lower cases and ";" signs
; Original code is removed with ";" signs
; New code is added using lower cases only

; We made it...
; OS Group: Bryce Nesbitt, Michael Sinz, Peter Cherna, Darren Greenwald, Randell Jesup, Jerry Horanoff
; GFX: Allan Havemose, Barry 'Bart' Whitebook, Spence Shanson, Steve Beats, Chris Green, Ray Brand, Jim Barkley
; Special Projects: Eric Cotton, Martin Hunt, Bill Koester, Martin Taillefer, Brian Jackson, Kaori Kuwata, David Junod, Palmyra Pawlik, Kevin Klop
; NET: Brian Jackson, Greg Miller, Kenneth Dyke
; GUI: Peter Cherna, Martin Taillefer, David Junod, Kaori Kuwata
; Others: Andy Finkel, Dale 'Duck' Luck, Jim 'Jimm' Mackraz, Bob 'Kodiak' Burns, Jeff Porter, Carolyn Scheppner, David Haynie,
; Lauren Brown, CATS (Commodore Amiga Technical Support), QA (Quality Assurance), SA (Software Assurance)
; Thanks to: Bill Hawes, Software Distillery
; Better than ever.

MatchTag
	ILLEGAL				; match word
	dc.l	MatchTag		; match tag
	dc.l	EndSkip			; end skip
	dc.b	1			; flags
;	dc.b	$27			; version

	dc.b	$28			; new version

	dc.b	8			; type
	dc.b	$50			; priority
	dc.l	ciaresource.MSG		; name
	dc.l	cia39110392.MSG		; id string
	dc.l	InitResource		; init code
;ciaresource.MSG	dc.b	'cia.resource',0,0
;ciaaresource.MSG1	dc.b	'ciaa.resource',0
;ciabresource.MSG0	dc.b	'ciab.resource',0
;cia39110392.MSG	dc.b	'cia 39.1 (10.3.92)',$D,$A,0
;	dc.b	0
;	dc.b	0
;	dc.b	0
Vectors
	dc.w	$FFFF
	dc.w	AddICRVector-Vectors	;  -6 _LVOAddICRVector
	dc.w	RemICRVector-Vectors	; -12 _LVORemICRVector
	dc.w	AbleICR-Vectors		; -18 _LVOAbleICR
	dc.w	SetICR-Vectors		; -24 _LVOSetICR
	dc.w	$FFFF

InitResource
	MOVEM.L	A2/A3,-(SP)
	MOVEQ	#$20,D0
	MOVE.L	#$10001,D1
	JSR	-$C6(A6)		; AllocMem
	MOVEA.L	D0,A3			; resource base, no error code
;	BSR.L	MakeLib

	bsr.b	MakeLib

	MOVE.L	A2,4(A3)
	MOVEQ	#0,D0
	MOVEQ	#3,D1
	MOVEM.L	D0/D1/A2,8(A3)
	BSET	D0,$86(A2)
	MOVE.L	#$BFE001,$22(A2)
	MOVE.L	A6,$7C(A2)		; exec base
	MOVE.W	#8,$26(A2)
	MOVE.L	#IO_PortsInt,$12(A1)
	MOVEQ	#3,D0			; I/O Ports and timers
	JSR	-$A8(A6)		; AddIntServer
	LEA	ciaaresource.MSG1(PC),A0
	BSR.S	AddResource
	BSR.S	MakeLib
	MOVE.L	A2,(A3)
	LEA	$BFD000,A0
	MOVE.L	A0,$22(A2)
	MOVE.L	A6,$7C(A2)		; exec base
	MOVEQ	#-$40,D0
	OR.B	D0,$200(A0)
	OR.B	D0,(A0)
	MOVE.W	#$2000,$26(A2)
	MOVE.L	#ExternalInt,$12(A1)
	MOVEQ	#13,D0			; External interrupt
	JSR	-$A8(A6)		; AddIntServer
	LEA	ciabresource.MSG0(PC),A0
	BSR.S	AddResource
	MOVEM.L	(SP)+,A2/A3
	RTS

MakeLib	LEA	Vectors(PC),A0
	SUBA.L	A1,A1
	SUBA.L	A2,A2
;	MOVEQ	#$11,D0
;	ROL.L	#3,D0

	moveq	#136/2,D0
	add.w	D0,D0

	JSR	-$54(A6)		; MakeLibrary
	MOVEA.L	D0,A2			; again, no error check
;	MOVE.B	#8,8(A2)
;	CLR.B	9(A2)

	move.w	#$800,8(A2)

	LEA	$2A(A2),A1
;	MOVE.B	#2,8(A1)
;	MOVE.B	#$78,9(A1)

	move.w	#$278,8(A1)

	MOVE.L	A2,14(A1)
	MOVE.L	A3,$80(A2)
	RTS

AddResource	MOVE.L	A0,10(A1)
	MOVE.L	A0,10(A2)
	MOVEA.L	A2,A1			; A1 input
;	JSR	-$1E6(A6)		; AddResource
;	RTS

	jmp	-$1E6(A6)		; AddResource

IO_PortsInt	MOVEM.L	D2/A2,-(SP)
	MOVEA.L	A1,A2
lbC03F6FC	BCLR	#0,$87(A2)
	BEQ.S	lbC03F710
	MOVEA.L	$80(A2),A1
	MOVEM.L	$18(A1),A1/A5
	JSR	(A5)
lbC03F710	MOVE.W	SR,D0
	ORI.W	#$700,SR
;	MOVE.B	$BFED01,D2
;	BCLR	#7,D2

	moveq	#127,D2
	and.b	$BFED01,D2

	OR.B	$29(A2),D2
	MOVE.B	D2,$29(A2)
	AND.B	$28(A2),D2
	MOVE.B	D2,$84(A2)
	BEQ.S	lbC03F75E
	EOR.B	D2,$29(A2)
	MOVE.W	D0,SR
	MOVEA.L	$7C(A2),A6		; set exec base in A6
	LEA	$DFF000,A0		; set chip register in A0
	LSR.B	#1,D2
;	BCS.S	lbC03F768

	bcc.b	lbC03F746
	movem.l	$40(A2),A1/A5
	jsr	(A5)

lbC03F746	LSR.B	#1,D2
	BCS.S	lbC03F772
	BEQ.S	lbC03F6FC
lbC03F74C	LSR.B	#1,D2
	BCS.S	lbC03F77C
	BEQ.S	lbC03F6FC
lbC03F752	LSR.B	#1,D2
	BCS.S	lbC03F786
	BEQ.S	lbC03F6FC
lbC03F758	LSR.B	#1,D2
	BCS.S	lbC03F790
	BRA.S	lbC03F6FC

lbC03F75E	MOVE.W	D0,SR
	MOVEM.L	(SP)+,D2/A2
	MOVEQ	#0,D0
	RTS

lbC03F790	MOVEM.L	$70(A2),A1/A5
	JSR	(A5)
;	BRA.L	lbC03F6FC

	bra.b	lbC03F6FC


;lbC03F768	MOVEM.L	$40(A2),A1/A5
;	JSR	(A5)
;	BRA.S	lbC03F746

lbC03F772	MOVEM.L	$4C(A2),A1/A5
	JSR	(A5)
	BRA.S	lbC03F74C

lbC03F77C	MOVEM.L	$58(A2),A1/A5
	JSR	(A5)
	BRA.S	lbC03F752

lbC03F786	MOVEM.L	$64(A2),A1/A5
	JSR	(A5)
	BRA.S	lbC03F758


; A0 and A6 are not set for ExternalInt handler

ExternalInt
;	MOVEM.L	D2/A2,-(SP)
;	MOVE.B	$BFDD00,D2
;	BCLR	#7,D2

	move.l	D2,-(SP)
	moveq	#127,D2
	and.b	$BFDD00,D2

	OR.B	$29(A1),D2
	MOVE.B	D2,$29(A1)
	AND.B	$28(A1),D2
	BEQ.S	lbC03F7E0
	MOVE.B	D2,$84(A1)

	move.l	A2,-(SP)

	MOVEA.L	A1,A2
	EOR.B	D2,$29(A2)
	LSR.B	#1,D2
;	BCS.S	lbC03F7E8

	bcc.b	lbC03F7C6
	movem.l	$40(A2),A1/A5
	jsr	(A5)

lbC03F7C6	LSR.B	#1,D2
	BCS.S	lbC03F7F2
	BEQ.S	lbC03F7DC
lbC03F7CC	LSR.B	#1,D2
	BCS.S	lbC03F7FC
	BEQ.S	lbC03F7DC
lbC03F7D2	LSR.B	#1,D2
	BCS.S	lbC03F806
	BEQ.S	lbC03F7DC
lbC03F7D8	LSR.B	#1,D2
	BCS.S	lbC03F810
lbC03F7DC	CLR.B	$84(A2)

	move.l	(SP)+,A2

lbC03F7E0
;	MOVEM.L	(SP)+,D2/A2

	move.l	(SP)+,D2

	MOVEQ	#0,D0
	RTS

;lbC03F7E8	MOVEM.L	$40(A2),A1/A5
;	JSR	(A5)
;	BRA.S	lbC03F7C6

lbC03F7F2	MOVEM.L	$4C(A2),A1/A5
	JSR	(A5)
	BRA.S	lbC03F7CC

lbC03F7FC	MOVEM.L	$58(A2),A1/A5
	JSR	(A5)
	BRA.S	lbC03F7D2

lbC03F806	MOVEM.L	$64(A2),A1/A5
	JSR	(A5)
	BRA.S	lbC03F7D8

lbC03F810	MOVEM.L	$70(A2),A1/A5
	JSR	(A5)
	BRA.S	lbC03F7DC

; D0 - input
; A1 - input
; A6 - resource base
; D0 - output

AddICRVector	MOVEQ	#0,D1
	MOVE.B	D0,D1
	MULU.W	#12,D1
	MOVEA.L	$7C(A6),A0
	MOVE.W	#$4000,$DFF09A
	ADDQ.B	#1,$126(A0)
;	LEA	$40(A6,D1.W),A0
;	MOVE.L	8(A0),D1
;	BNE.S	lbC03F914

	lea	$40+8(A6,D1.W),A0
	move.l	(A0),D1
	beq.b	lbC03F8E4

;lbC03F914				; code moved
	BTST	D0,$86(A6)
	BEQ.S	lbC03F910
	MOVEM.L	D0-D3/A0-A3/A6,-(SP)
	BSR.S	lbC03F978
	BNE.S	lbC03F950
	BSR.S	lbC03F992
	MOVEM.L	(SP)+,D0-D3/A0-A3/A6
;	BRA.S	lbC03F8E4

lbC03F8E4
;	MOVE.L	A1,8(A0)
;	MOVE.L	$12(A1),4(A0)
;	MOVE.L	14(A1),(A0)

	move.l	A1,(A0)
	move.l	$12(A1),-(A0)
	move.l	14(A1),-(A0)

	BSET	D0,$85(A6)
;	MOVE.W	#$80,D1
;	BSR.S	lbC03F96C

	moveq	#-128,D1			; only byte is used
	bsr.w	lbC03F96C

lbC03F8FC	MOVEA.L	$7C(A6),A0
	SUBQ.B	#1,$126(A0)
	BGE.S	lbC03F90E
	MOVE.W	#$C000,$DFF09A
lbC03F90E	RTS

; D0 - input
; A1 - input
; A6 - resource base

RemICRVector	MOVEA.L	$7C(A6),A0
	MOVE.W	#$4000,$DFF09A
	ADDQ.B	#1,$126(A0)
	BSR.S	lbC03F956
	MOVEM.L	D0-D3/A0-A3/A6,-(SP)
	BSR.S	lbC03F978
	MOVEM.L	8(A1),D0/D1/A6
	CMP.B	D1,D3
	BLE.S	lbC03F950
	BSR.S	lbC03F956
	BSR.S	lbC03F992
lbC03F950	MOVEM.L	(SP)+,D0-D3/A0-A3/A6
;	BRA.S	lbC03F910

lbC03F910	MOVE.L	D1,D0			; code moved
	BRA.S	lbC03F8FC

lbC03F978	MOVEA.L	$80(A6),A1		; code moved
	MOVEM.L	(A1),A2/A3
	MOVEQ	#3,D3
	MOVEQ	#$40,D2
lbC03F984	EXG	A3,A2
	LSR.B	#3,D2
	BTST	D2,$85(A2)
	DBEQ	D3,lbC03F984
	RTS

lbC03F992	AND.B	#1,D2			; code moved
	MOVEM.L	D2/D3/A2,8(A1)
	CLR.B	$86(A3)
	CLR.B	$86(A2)
	BSET	D2,$86(A2)
	MOVEA.L	$14(A1),A0
	JMP	(A0)

lbC03F956	MOVEQ	#0,D1
	MOVE.B	D0,D1
	MULU.W	#12,D1
;	LEA	$40(A6,D1.W),A0
;	CLR.L	8(A0)

	clr.l	$40+8(A6,D1.W)

	MOVEQ	#0,D1
	BCLR	D0,$85(A6)
lbC03F96C	BSET	D0,D1
	MOVE.W	D1,D0
;	BSR.L	AbleICR

	bsr.b	AbleICR

	MOVEQ	#0,D0
	RTS


; D0 - input
; A6 - resource base
; D0 - output

AbleICR
;	MOVEA.L	$7C(A6),A0
;	MOVE.W	#$4000,$DFF09A
;	ADDQ.B	#1,$126(A0)
;	MOVEA.L	$22(A6),A0		; timer

	bsr.b	SetMe

	MOVE.B	D0,$D00(A0)
	MOVEQ	#0,D1
	MOVE.B	$28(A6),D1
	TST.B	D0
	BEQ.S	lbC03F85E
	BCLR	#7,D0
	BNE.S	lbC03F8BC
	NOT.B	D0
	AND.B	D0,$28(A6)
	BRA.S	lbC03F85E

lbC03F8BC	OR.B	D0,$28(A6)
	BRA.S	lbC03F85E

SetMe
	move.l	$7C(A6),A0
	move.w	#$4000,$DFF09A
	addq.b	#1,$126(A0)
	move.l	$22(A6),A0		; timer
	rts

; D0 - input
; A6 - resource base
; D0 - output

SetICR
;	MOVEA.L	$7C(A6),A0		; exec base
;	MOVE.W	#$4000,$DFF09A
;	ADDQ.B	#1,$126(A0)
;	MOVEA.L	$22(A6),A0		; timer

	bsr.b	SetMe

;	MOVE.B	$D00(A0),D1
;	BCLR	#7,D1

	moveq	#127,D1
	and.b	$D00(A0),D1

	OR.B	D1,$29(A6)
	MOVEQ	#0,D1
	MOVE.B	$29(A6),D1
	OR.B	$84(A6),D1
	TST.B	D0
	BEQ.S	lbC03F85E
	BCLR	#7,D0
	BNE.S	lbC03F85A
	NOT.B	D0
	AND.B	D0,$29(A6)
	AND.B	D0,$84(A6)
	BRA.S	lbC03F85E

lbC03F85A	OR.B	D0,$29(A6)
lbC03F85E	MOVE.B	$28(A6),D0
	AND.B	$29(A6),D0
	BEQ.S	lbC03F876
	MOVE.W	$26(A6),D0
	OR.W	#$8000,D0
	MOVE.W	D0,$DFF09C
lbC03F876	MOVEA.L	$7C(A6),A0		; exec base
	SUBQ.B	#1,$126(A0)
	BGE.S	lbC03F888
	MOVE.W	#$C000,$DFF09A
lbC03F888	MOVE.L	D1,D0
	RTS

ciaresource.MSG	dc.b	'cia.resource',0
;		dc.b	0
ciaaresource.MSG1	dc.b	'ciaa.resource',0
ciabresource.MSG0	dc.b	'ciab.resource',0
cia39110392.MSG	dc.b	'cia 40.0 (9.12.2013)',$D,$A,0

	cnop	0,4
EndSkip
