; Resourced version of disk.resource (37.2) from Amiga ROM 3.1 for Amiga68k ROM 1.0
; For easy recognition all changes are done using lower cases and ";" signs
; Original code is removed with ";" signs
; New code is added using lower cases only

; Originally written by:

; jesup (Randell Jesup)
; bryce (Bryce Nesbitt)
; neil

; We made it...
; OS Group: Bryce Nesbitt, Michael Sinz, Peter Cherna, Darren Greenwald, Randell Jesup, Jerry Horanoff
; GFX: Allan Havemose, Barry 'Bart' Whitebook, Spence Shanson, Steve Beats, Chris Green, Ray Brand, Jim Barkley
; Special Projects: Eric Cotton, Martin Hunt, Bill Koester, Martin Taillefer, Brian Jackson, Kaori Kuwata, David Junod, Palmyra Pawlik, Kevin Klop
; NET: Brian Jackson, Greg Miller, Kenneth Dyke
; GUI: Peter Cherna, Martin Taillefer, David Junod, Kaori Kuwata
; Others: Andy Finkel, Dale 'Duck' Luck, Jim 'Jimm' Mackraz, Bob 'Kodiak' Burns, Jeff Porter, Carolyn Scheppner, David Haynie,
; Lauren Brown, CATS (Commodore Amiga Technical Support), QA (Quality Assurance), SA (Software Assurance)
; Thanks to: Bill Hawes, Software Distillery (Dave Baker, Ed Burnette, Stan Chow,
; Alan Beale, Bruce Drake, Andy Mercier, Mary Ellen Toebes, Jim Cooper, Mike Witcher,
; Jay Denebeim, John Mainwaring, Gordon Keener, Jack Rouse, John Toebes, Doug Walker)
; Better than ever.

MatchTag
	ILLEGAL				; match word
	dc.l	MatchTag		; match tag
	dc.l	EndSkip			; end skip
	dc.b	1			; flags
	dc.b	$26			; version
	dc.b	8			; type
	dc.b	$46			; priority
	dc.l	diskName		; name
	dc.l	diskID			; id string
	dc.l	DRInit			; init code

funcInit
	dc.w	$FFFF
	dc.w	AllocUnit-funcInit	;  -6 _LVOAllocUnit
	dc.w	FreeUnit-funcInit	; -12 _LVOFreeUnit
	dc.w	GetUnit-funcInit	; -18 _LVOGetUnit
	dc.w	GiveUnit-funcInit	; -24 _LVOGiveUnit
	dc.w	GetUnitID-funcInit	; -30 _LVOGetUnitID
	dc.w	ReadUnitID-funcInit	; -36 _LVOReadUnitID
	dc.w	$FFFF

*****i* System/Resources/DR/DRInit ***********************************
*
*   NAME
*       DRInit - initialize the disk resource
*
*   SYNOPSIS
*       DRInit()
*
*
*   FUNCTION
*	This routine starts the disk resource up from scratch
*
*   INPUTS
*
*   RESULTS
*
*   EXCEPTIONS
*
*   SEE ALSO
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*
DRInit
	movem.l	D3/D7/A2/A5,-(SP)
	lea	ciaName(PC),A1
	jsr	-$1F2(A6)		; OpenResource
	move.l	D0,D7
	beq.b	Error			;silent failure (but will never happen)

	lea	funcInit(PC),A0		; function vector init
	lea	structInit(PC),A1	; data space initialization
	sub.l	A2,A2			; init function
	moveq	#74,D0
	add.w	D0,D0			; data size

	jsr	-$54(A6)		; MakeLibrary
	tst.l	D0
	bne.b	Init_Addints
	move.l	#$21020000,D7		; could not make library
	jsr	-$6C(A6)		; Alert
Error
	movem.l	(SP)+,D3/D7/A2/A5
	rts

Init_Addints
	move.l	D0,A2

*		;------ We have the library.  Add the int servers/handlers

	move.l	#diskName,D3		;For tagging the Interrupt owner!
	;[D3-diskName]

	lea	$4E(A2),A1		; DR_DISCBLOCK
	move.l	D3,10(A1)		;Identify the Interrupt owner!
	move.l	#IntDiskBlock,$12(A1)
	move.l	A2,14(A1)
	moveq	#1,D0			; Disk Block done
	jsr	-$A2(A6)		; SetIntVector
	lea	$64(A2),A1		; DR_DISCSYNC
	move.l	D3,10(A1)		;Identify the Interrupt owner!
	move.l	#IntDiskSync,$12(A1)
	move.l	A2,14(A1)
	moveq	#12,D0			; Disk re-SYNChronized
	jsr	-$A2(A6)		; SetIntVector
*		;------ Initialize the 8520
	lea	$BFD100,A1
	st	(A1)			; turn "off" all bits
	st	$200(A1)		; direction of port
	and.b	#$C3,$1101(A1)
		;------ get the base of the special chips
	lea	$DFF000,A5

		;------ put in the cia resource interrupt
	move.w	#$4000,$9A(A5)
	addq.b	#1,$126(A6)
	move.l	D7,$2C(A2)		; DR_CIARESOURCE

	lea	$7A(A2),A1
	move.l	A2,14(A1)
	move.l	#IntIndexMark,$12(A1)
	move.l	D3,10(A1)		;Identify the Interrupt owner!
	moveq	#4,D0
	exg	D7,A6				; ciab base
	jsr	-6(A6)
		;[D3-scratch]
		;------ and disable the interrupt

	moveq	#$10,D0
	jsr	-$12(A6)
	exg	D7,A6				; exec base

	subq.b	#1,$126(A6)
	bge.b	SkipIn
	move.w	#$C000,$9A(A5)
SkipIn
*		;------ save SYSLIB pointer
	move.l	A6,$28(A2)			; exec base
*		;------ Put disk in its initial configuration

*		; make sure portia dma is off
	move.w	#$4000,$24(A5)

*		;------ Enable DMA
	move.w	#$8010,$96(A5)

		;------ initialize the list
	lea	$40(A2),A0
	move.l	A0,8(A0)
	addq.l	#4,A0
	clr.l	(A0)
	move.l	A0,-(A0)

		;------ now find out what type of drives are in the machine
		;------ Note: with the advent of dual-speed floppies, these
		;------ values may change!
	moveq	#2,D7			; check 3 drives (1-3) in loop
	moveq	#8,D3			; check drive 0 first
	lea	$30(A2),A1
	bsr.b	readID
	add.b	D3,D3			; bump select to drive 1
	addq.l	#1,D0			; was it -1 (no code returned)?
	bne.b	Init_readid		; returned a code, believe it

		;------ set the internal drive to type AMIGA
		;-- didn't return a code, assume 3.5" 1M drive
	move.l	D0,$30(A2)		; null
Init_readid
	bsr.b	readID
	add.b	D3,D3
	dbf	D7,Init_readid

*		;------ add the resource
	move.l	A2,A1
	movem.l	(SP)+,D3/D7/A2/A5
	jmp	-$1E6(A6)		; AddResource


*
* read the id type.  called with:
*	A1 -- where to write the type (incremented to next cell)
*	D3 -- select bit of unit
*
* internally:
*       D1 -- loop counter for reading 31 bits
*	D0 -- hold the bits
*	A0 -- ciabprb
*
readID
	not.b	D3
	lea	$BFD100,A0		; _ciab+ciaprb
	moveq	#$7F,D0			; set motor on bit
		;------ turn the motor on and off to reset the counter
	move.b	D0,(A0)
	and.b	D3,D0			; select unit
	move.b	D0,(A0)
	st	(A0)			; unselect unit
	move.b	D3,(A0)			; turn motor off
	st	(A0)			; unselect unit

		;------ now read 32 bits into D0
	moveq	#31,D1
	moveq	#0,D0
readID_loop
	add.l	D0,D0
	move.b	D3,(A0)
	btst	#5,$F01(A0)		; $bfe001-$bfd100
	beq.b	Ready
	addq.w	#1,D0			; bset #0,D0
Ready
	st	(A0)
	dbf	D1,readID_loop
	move.l	D0,(A1)+
	not.b	D3			; restore (we not-ed it up top)
	rts

******* disk.resource/ReadUnitID *********************************
*
*   NAME
*       ReadUnitID - reread and return the type of drive (V37)
*
*   SYNOPSIS
*       idtype = ReadUnitID( unitNum ), DRResource
*	D0	               D0         A6
*
*	ULONG ReadUnitID(LONG);
*
*   FUNCTION
*	Rereads the drive id for a specific unit (for handling drives
*	that change ID according to what sort of disk is in them.  You
*	MUST have done a GetUnit before calling this function!
*
*   INPUTS
*	unitNum -- a legal unit number (zero through three)
*
*   RESULTS
*	idtype -- the type of the disk drive.  Standard types are
*		defined in the resource include file.
*
*   EXCEPTIONS
*
*   SEE ALSO
*	GetUnitID
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*

; D0 - input
; A6 - resource base
; D0 - output

ReadUnitID
	movem.l	D0/D3,-(SP)
	moveq	#8,D3			; select bit for unit 0
	lsl.b	D0,D3			; make the right select bit

		;-- keep the disk resource base up to date
	lsl.w	#2,D0
	lea	$30(A6,D0.W),A1		; address to write the new ID to
	bsr.b	readID			; (d3/a1) returns ID in d0
					; A1 has been bumped 1 entry!
	tst.l	(SP)+			; unit
	bne.b	all_done
		;-- if this is unit 0 AND we get DRT_EMPTY, then it's
		;-- really DRT_AMIGA
	moveq	#-1,D1
	cmp.l	D1,D0
	bne.b	all_done
	moveq	#0,D0
	move.l	D0,-(A1)		; it was bumped 4 in readID!!!
all_done
	move.l	(SP)+,D3
	rts

structInit
*		;------ Initialize the device
	dc.w	$A008			; base offset $8
	dc.w	$800			; type
	dc.w	$800A			; base offset $A
	dc.l	diskName		; name
	dc.w	$A00E			; base offset $E
	dc.w	$0600			; flags
	dc.w	$9014			; base offset $14
	dc.w	$0026			; version
	dc.w	$9016			; base offset $16
	dc.w	$0001			; revision
	dc.w	$8022			; base offset $22
	dc.l	-1			; DR_CURRENT
	dc.w	0			; no more

******* disk.resource/GetUnit ***********************************
*
*   NAME
*       GetUnit - allocate the disk for a driver
*
*   SYNOPSIS
*       lastDriver = GetUnit( unitPointer ), DRResource
*       D0		      A1             A6
*
*	struct DiscResourceUnit *GetUnit(struct DiscResourceUnit *);
*
*   FUNCTION
*	This routine allocates the disk to a driver.  It is either
*	immediately available, or the request is saved until the disk
*	is available.  When it is available, your unitPointer is
*	sent back to you (via ReplyMsg).  You may then reattempt the
*	GetUnit.
*	
*	Allocating the disk allows you to use the disk's resources.
*	Remember however that there are four units to the disk; you are
*	only one of them.  Please be polite to the other units (by never
*	selecting them, and by not leaving interrupts enabled, etc.).
*
*	When you are done, please leave the disk in the following state:
*	    dmacon dma bit ON
*	    dsklen dma bit OFF (write a #DSKDMAOFF to dsklen)
*	    adkcon disk bits -- any way you want
*	    entena:disk sync and disk block interrupts -- Both DISABLED
*	    CIA resource index interrupt -- DISABLED
*	    8520 outputs -- doesn't matter, because all bits will be
*		set to inactive by the resource.
*	    8520 data direction regs -- restore to original state.
*
*	NOTE: GetUnit() does NOT turn on the interrupts for you.
*	      You must use AbleICR (for the index interrupt) or intena
*	      (for the diskbyte and diskblock interrupts) to turn them
*	      on.  You should turn them off before calling GiveUnit,
*	      as stated above.
*
*   INPUTS
*	unitPtr - a pointer you your disk resource unit structure.
*		Note that the message filed of the structure MUST
*		be a valid message, ready to be replied to.  Make sure
*		ln_Name points to a null-terminated string, preferably
*		one that identifies your program.
*
*		You need to set up the three interrupt structures,
*		in particular the IS_DATA and IS_CODE fields.  Set them
*		to NULL if you don't need that interrupt.  Also, set
*		the ln_Type of the interrupt structure to NT_INTERRUPT.
*		WARNING: don't turn on a disk resource interrupt unless
*		the IS_CODE for that interrupt points to executable code!
*
*		IS_CODE will be called with IS_DATA in A1 when the
*		interrupt occurs.  Preserve all regs but D0/D1/A0/A1.
*		Do not make assumptions about A0.
*
*   RESULTS
*	lastDriver - if the disk is not busy, then the last unit
*		to use the disk is returned.  This may be used to
*		see if a driver needs to reset device registers.
*		(If you were the last user, then no one has changed
*		any of the registers.  If someone else has used it,
*		then any allowable changes may have been made).  If the
*		disk is busy, then a null is returned.
*
*   EXCEPTIONS
*
*   SEE ALSO
*	GiveUnit
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*

; A1 - input
; A6 - resource base
; D0 - output

GetUnit
	;------ Do whatever possible outside DISABLE - REJ
	move.l	$22(A6),D0		; DR_CURRENT
	move.l	$28(A6),A0		; exec base
	move.w	#$4000,$DFF09A		; DISABLE
	addq.b	#1,$126(A0)
	bset	#7,$26(A6)
	bne.b	GetUnit_Busy
*		;------ update DR_CURRENT and set up return value
	move.l	A1,$22(A6)
*		;------ Save task for GiveUnit check - REJ
	move.l	$114(A0),$90(A6)
	bra.b	GetUnit_End

*		;------ user did not get it -- link him on a list
GetUnit_Busy
	move.l	A6,D1			; backup A6
	lea	$40+4+4(A6),A6		; addtail
	move.l	(A6),D0
	move.l	A1,(A6)
	subq.l	#4,A6
	move.l	A6,(A1)
	move.l	D0,4(A1)
	move.l	D0,A6
	move.l	A1,(A6)
	move.l	D1,A6			; restore A6
*		;------ return failure
	moveq	#0,D0
GetUnit_End
	subq.b	#1,$126(A0)		; ENABLE
	bge.b	QuitGET
	move.w	#$C000,$DFF09A
QuitGET
	rts


******* disk.resource/GiveUnit **********************************
*
*   NAME
*       GiveUnit - Free the disk back up
*
*   SYNOPSIS
*       GiveUnit(), DRResource
*           	    A6
*
*	void GiveUnit();
*
*   FUNCTION
*	This routine frees the disk after a driver is done with it.
*	If others are waiting, it will notify them.
*
*   INPUTS
*
*   RESULTS
*
*   EXCEPTIONS
*
*   SEE ALSO
*	GetUnit
*
*   BUGS
*	In pre-V36, GiveUnit didn't check if you owned the unit.  A patch
*	for this was part of 1.3.1 SetPatch.  Fixed in V36.
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*

; A6 - resource base

GiveUnit
	move.l	A6,-(SP)
	move.l	A6,A0			; so we can put execbase in a6

	;------ Do as much as possible outside DISABLE - REJ
	moveq	#0,D0
	move.l	$28(A0),A6		; exec base
	move.l	$114(A6),D1
	move.w	#$4000,$DFF09A		; Disable
	addq.b	#1,$126(A6)
	cmp.l	$90(A0),D1		; REJ
	bne.b	GiveUnitIgnore		; if branch, D0 == 0
		;------ make sure all the bits are turned off
	st	$BFD100
*		;------ mark the resource as available
	bclr	#7,$26(A0)
*		;------ see if someone is waiting (see before disable REJ)
	lea	$40(A0),A0		; RemHead relies on this!
	move.l	(A0),A1			; since we don't know if it's empty
	move.l	(A1),D0
	beq.b	GiveUnitIgnore
	move.l	D0,(A0)
	exg	D0,A1
	move.l	A0,4(A1)
GiveUnitIgnore
		; a6 == execbase
	subq.b	#1,$126(A6)		; Enable
	bge.b	GU_Skip
	move.w	#$C000,$DFF09A
GU_Skip
	tst.l	D0			; see branch to Ignore
	beq.b	GiveUnit_End
*		;------ someone was waiting for the unit (a6 == execbase)
	move.l	D0,A1
	jsr	-$17A(A6)		; ReplyMsg
GiveUnit_End
		;-- restore reg
	move.l	(SP)+,A6
	rts

******* disk.resource/AllocUnit *********************************
*
*   NAME
*       AllocUnit - allocate a unit of the disk
*
*   SYNOPSIS
*       Success = AllocUnit( unitNum ), DRResource
*	D0     	             D0         A6
*
*	BOOL AllocUnit(LONG);
*
*   FUNCTION
*	This routine allocates one of the units of the disk.  It should
*	be called before trying to use the disk (via GetUnit).
*
*	In reality, it is perfectly fine to use GetUnit/GiveUnit if AllocUnit
*	fails.  Do NOT call FreeUnit if AllocUnit did not succeed.  This
*	has been the case for all revisions of disk.resource.
*
*   INPUTS
*	unitNum -- a legal unit number (zero through three)
*
*   RESULTS
*	Success -- nonzero if successful.  zero on failure.
*
*   EXCEPTIONS
*
*   SEE ALSO
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*

; D0 - input
; A6 - resource base
; D0 - output

AllocUnit
	bset	D0,$26(A6)
	seq	D0			; scc sets low byte only
	rts				; however, d0 was a long passed in
					; in the range 0-3, so 8..31 are 0.

******* disk.resource/FreeUnit **********************************
*
*   NAME
*       FreeUnit - deallocate the disk
*
*   SYNOPSIS
*       FreeUnit( unitNum ), DRResource
*		  D0         A6
*
*	void FreeUnit(LONG);
*
*   FUNCTION
*	This routine deallocates one of the units of the disk.  It should
*	be called when done with the disk.  Do not call it if you did
*	no successfully allocate the disk (there is no protection -- you
*	will probably crash the disk system).
*
*   INPUTS
*	unitNum -- a legal unit number (zero through three)
*
*   RESULTS
*
*   EXCEPTIONS
*
*   SEE ALSO
*	FreeUnit
*
*   BUGS
*	Doesn't check if you own the unit, or even if anyone owns it.
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*

; D0 - input
; A6 - resource base

FreeUnit
	bclr	D0,$26(A6)
	rts

******* disk.resource/GetUnitID *********************************
*
*   NAME
*       GetUnitID - find out what type of disk is out there
*
*   SYNOPSIS
*       idtype = GetUnitID( unitNum ), DRResource
*	D0	            D0         A6
*
*	LONG GetUnitID(LONG);
*
*   FUNCTION
*	Gets the drive ID for a given unit.  Note that this value may
*	change if someone calls ReadUnitID, and the drive id changes.
*
*   INPUTS
*	unitNum -- a legal unit number (zero through three)
*
*   RESULTS
*	idtype -- the type of the disk drive.  Standard types are
*		defined in the resource include file.
*
*   EXCEPTIONS
*
*   SEE ALSO
*	ReadUnitID
*
*   BUGS
*
**********************************************************************
*
*   IMPLEMENTATION NOTES
*
*
; D0 - input
; A6 - resource base
; D0 - output

GetUnitID
	lsl.w	#2,D0
	move.l	$30(A6,D0.W),D0
	rts

*********************************************************************
*
* interrupt routines
*
*********************************************************************

;This is not a chain, A0 is _custom
IntDiskBlock
	move.w	#2,$9C(A0)		;fast index (ack interrupt)
	move.l	$22(A1),D0
	beq.b	IntNoCurrent
	move.l	D0,A1
	movem.l	$22(A1),A1/A5
	jmp	(A5)

;This is not a chain, A0 is _custom
IntDiskSync
	move.w	#$1000,$9C(A0)		;fast index (ack interrupt)
	move.l	$22(A1),D0
	beq.b	IntNoCurrent
	move.l	D0,A1
	movem.l	$38(A1),A1/A5
	jmp	(A5)

;This IS a chain, A0 is garbage
IntIndexMark
	;------ ok to have index ints if not one is current...
	move.l	$22(A1),D0
	beq.b	QuitAlert
	move.l	D0,A1
	movem.l	$4E(A1),A1/A5
	jmp	(A5)

IntNoCurrent
	movem.l	D7/A5/A6,-(SP)
	move.l	#$21000002,D7			; interrupt, no active unit
	move.l	4.W,A6
	jsr	-$6C(A6)			; Alert
	movem.l	(SP)+,D7/A5/A6
QuitAlert
	rts

diskName
	dc.b	'disk.resource',0
ciaName
	dc.b	'ciab.resource',0
diskID
	dc.b	'disk 38.1 (9.11.2014)',$D,$A,0
	cnop	0,4
EndSkip
