; New module icfind (41.0) for Amiga68k ROM 1.0

; We made it...
; OS Group: Bryce Nesbitt, Michael Sinz, Peter Cherna, Darren Greenwald, Randell Jesup, Jerry Horanoff
; GFX: Allan Havemose, Barry 'Bart' Whitebook, Spence Shanson, Steve Beats, Chris Green, Ray Brand, Jim Barkley
; Special Projects: Eric Cotton, Martin Hunt, Bill Koester, Martin Taillefer, Brian Jackson, Kaori Kuwata, David Junod, Palmyra Pawlik, Kevin Klop
; NET: Brian Jackson, Greg Miller, Kenneth Dyke
; GUI: Peter Cherna, Martin Taillefer, David Junod, Kaori Kuwata
; Others: Andy Finkel, Dale 'Duck' Luck, Jim 'Jimm' Mackraz, Bob 'Kodiak' Burns, Jeff Porter, Carolyn Scheppner, David Haynie,
; Lauren Brown, CATS (Commodore Amiga Technical Support), QA (Quality Assurance), SA (Software Assurance)
; Thanks to: Bill Hawes, Software Distillery
; Better than ever.

MatchTag
	ILLEGAL				; match word
	dc.l	MatchTag		; match tag
	dc.l	EndSkip			; end skip
	dc.b	4			; flags
	dc.b	$29			; version
	dc.b	0			; type
	dc.b	$92			; priority
	dc.l	wbfind4017693.MSG	; name
	dc.l	wbfind4017693.MSG	; id string
	dc.l	Init			; init code

Init
	movem.l	D2/D6/D7/A3-A6,-(SP)
	move.l	A6,A5			; exec base
	moveq	#4,D0			; dos library
	jsr	-$32A(A6)		; TaggedOpenLibrary
	move.l	D0,D7			; dos base
	beq.b	Error
	lea	LIBSworkbench.MSG(PC),A0
	move.l	A0,D1
	moveq	#-2,D2
	move.l	D7,A6			; dos base
	jsr	-$54(A6)		; Lock
	move.l	D0,D6
	beq.b	AllocVec
	move.l	D6,D1
	jsr	-$5A(A6)		; UnLock
	move.l	A5,A6
	bra.b	Close

AllocVec
	moveq	#(32+20+4+NewOpenLibraryEnd-NewOpenLibrary),D0	; Name + lib path + jump ptr + code
	moveq	#1,D1			; fast mem
	move.l	A5,A6
	jsr	-$2AC(A6)		; AllocVec
	tst.l	D0
	beq.b	Close
	move.l	D0,A1
	clr.l	(A1)+
	move.l	A1,A3
	lea	NewOpenLibrary(PC),A0
	moveq	#(NewOpenLibraryEnd-NewOpenLibrary),D0
	jsr	-$270(A6)		; CopyMem
	jsr	-$27C(A6)		; CacheClearU
	moveq	#9,D1
	move.l	D7,A6			; dos base
	jsr	-$28E(A6)		; LockDosList
	move.l	D0,A4
	bra.b	Next

Free
	subq.l	#4,A3
	move.l	A3,A1
	move.l	A5,A6
	jsr	-$2B2(A6)		; FreeVec
Close
	move.l	D7,A1
	jsr	-$19E(A6)		; CloseLibrary
	moveq	#0,D0
Error
	movem.l	(SP)+,D2/D6/D7/A3-A6
	rts

Loop
	lea	NewOpenLibraryEnd-NewOpenLibrary(A3),A1	; destination
	move.l	A1,D1			; for Lock
	move.l	$28(A4),A0
	add.l	A0,A0
	add.l	A0,A0
	moveq	#0,D0
	move.b	(A0)+,D0		; source
	bra.b	DoCopy

CopyName
	move.b	(A0)+,(A1)+
DoCopy
	dbf	D0,CopyName
	lea	libsworkbench.MSG(PC),A0
Copy
	move.b	(A0)+,(A1)+
	bne.b	Copy
	moveq	#-2,D2
	jsr	-$54(A6)		; Lock
	move.l	D0,D6
	beq.b	Next
	move.l	D6,D1
	jsr	-$5A(A6)		; UnLock
Next
	move.l	A4,D1
	moveq	#9,D2
	jsr	-$2B2(A6)		; NextDosEntry
	tst.l	D0
	beq.b	Unlock
	move.l	D0,A4
	tst.l	D6
	beq.b	Loop
Unlock
	moveq	#9,D1
	jsr	-$294(A6)		; UnLockDosList
	tst.l	D6
	beq.b	Free
	move.l	A5,A6			; exec base
	jsr	-$84(A6)		; Forbid
	lea	-552.W,A0		; funcOffset A0.W
	move.l	A3,D0			; funcEntry D0
	move.l	A5,A1			; library A1
	jsr	-$1A4(A6)		; SetFunction
	move.l	D0,-(A3)
	jsr	-$8A(A6)		; Permit
	bra.b	Close

; D0 - input (lib version)
; A1 - input (lib name)
; D0 - output (lib base)

NewOpenLibrary
	move.l	D0,-(SP)
	move.l	A1,-(SP)
	move.l	NewOpenLibrary-4(PC),A0
	jsr	(A0)
	move.l	(SP)+,A1
	move.l	D0,D1
	beq.b	Check
NoWBlib
	addq.l	#4,SP
	rts
Check
	moveq	#13-1,D1			; size of library name
	lea	workbenchlibr.MSG(PC),A0
CheckName
	cmpm	(A0)+,(A1)+
	bne.b	NoWBlib
	dbf	D1,CheckName
	move.l	(SP)+,D0		; version
	lea	NewOpenLibraryEnd(PC),A1
	move.l	NewOpenLibrary-4(PC),A0
	jmp	(A0)
NewOpenLibraryEnd

LIBSworkbench.MSG	dc.b	'LIBS:icon.library',0
libsworkbench.MSG	dc.b	':libs/'
workbenchlibr.MSG	dc.b	'icon.library',0

wbfind4017693.MSG	dc.b	'icfind 41.0 (1.1.2014)',$D,$A,0
	cnop	0,4
EndSkip
