; Resourced version of mathieeesingbas.library (40.4) from Amiga ROM 3.1 for Amiga68k ROM 1.0
; For easy recognition all changes are done using lower cases and ";" signs
; Original code is removed with ";" signs
; New code is added using lower cases only

; We made it...
; OS Group: Bryce Nesbitt, Michael Sinz, Peter Cherna, Darren Greenwald, Randell Jesup, Jerry Horanoff
; GFX: Allan Havemose, Barry 'Bart' Whitebook, Spence Shanson, Steve Beats, Chris Green, Ray Brand, Jim Barkley
; Special Projects: Eric Cotton, Martin Hunt, Bill Koester, Martin Taillefer, Brian Jackson, Kaori Kuwata, David Junod, Palmyra Pawlik, Kevin Klop
; NET: Brian Jackson, Greg Miller, Kenneth Dyke
; GUI: Peter Cherna, Martin Taillefer, David Junod, Kaori Kuwata
; Others: Andy Finkel, Dale 'Duck' Luck, Jim 'Jimm' Mackraz, Bob 'Kodiak' Burns, Jeff Porter, Carolyn Scheppner, David Haynie,
; Lauren Brown, CATS (Commodore Amiga Technical Support), QA (Quality Assurance), SA (Software Assurance)
; Thanks to: Bill Hawes, Software Distillery (Dave Baker, Ed Burnette, Stan Chow,
; Alan Beale, Bruce Drake, Andy Mercier, Mary Ellen Toebes, Jim Cooper, Mike Witcher,
; Jay Denebeim, John Mainwaring, Gordon Keener, Jack Rouse, John Toebes, Doug Walker)
; Better than ever.

;MatchTag
;	ILLEGAL				; match word
;	dc.l	MatchTag		; match tag
;	dc.l	EndSkip			; end skip
;	dc.b	1			; flags
;	dc.b	$28			; version
;	dc.b	9			; type
;	dc.b	0			; priority
;	dc.l	mathieeesingb.MSG	; name
;	dc.l	mathieeesingb.MSG0	; id string
;	dc.l	InitLibrary		; init code

;IEEESPFltFPU	FMOVE.L	D0,FP0
;	FMOVE.S	FP0,D0
;	RTS

;	NOP
;IEEESPFixFPU	FMOVE.S	D0,FP0
;	FMOVE.L	FP0,D0
;	RTS

;	NOP
;lbC0435CC	FMOVE.S	D0,FP0
;	FMOVE.L	FPCR,D0
;	MOVE.L	D0,D1
;	MOVE.B	#$20,D0
;	FMOVE.L	D0,FPCR
;	FINT.X	FP0,FP0
;	FMOVE.L	D1,FPCR
;	FMOVE.S	FP0,D0
;	RTS

;IEEESPFloorFPU	TST.L	D0
;	BLT.B	lbC0435CC
;	FINTRZ.S	D0,FP0
;	FMOVE.S	FP0,D0
;	RTS

;	NOP
;IEEESPAddFPU	FMOVE.S	D0,FP0
;	FADD.S	D1,FP0
;	FMOVE.S	FP0,D0
;	RTS

;	NOP
;IEEESPSubFPU	FMOVE.S	D0,FP0
;	FSUB.S	D1,FP0
;	FMOVE.S	FP0,D0
;	RTS

;	NOP
;IEEESPMulFPU	FMOVE.S	D0,FP0
;	FSGLMUL.S	D1,FP0
;	FMOVE.S	FP0,D0
;	RTS

;	NOP
;IEEESPDivFPU	FMOVE.S	D0,FP0
;	FSGLDIV.S	D1,FP0
;	FMOVE.S	FP0,D0
;	RTS

;	FMOVE.S	D0,FP0
;	FCMP.S	D1,FP0
;	FBEQ.W	lbC043652
;	FBGT.W	lbC04364E
;	MOVEQ	#-1,D0
;	RTS

;lbC04364E	MOVEQ	#1,D0
;	RTS

;lbC043652	MOVEQ	#0,D0
;	RTS

;lbC043656	MOVEQ	#$40,D0
;	FMOVE.L	D0,FPCR
;	MOVEQ	#0,D0
;	RTS

*
* general equates
*
;sign	equ	$80000000	sign bit mask
;signb	equ	31		sign bit no.
;notsign	equ	$7fffffff	everything but sign
;zero	equ	$00000000	IEEE single precision 0.0
;one	equ	$3F800000	IEEE single precision 1.0 (lower half)
;neg_one	equ	one+sign	negative one


***************************************************
***************************************************
***						***
***  DOUBLE PRECISION C ENTRY POINTS BEGIN HERE	***
***						***
***************************************************
***************************************************

* new code from Dale
* parameters are in registers

;	xref	_LVOIEEEDPAdd
;	xref	_LVOIEEEDPFloor

******* mathieeesingbas.library/IEEESPCeil ***********************************
*
*   NAME
*	IEEESPCeil -- compute Ceil function of IEEE single precision number
*
*   SYNOPSIS
*	  x   = IEEESPCeil(  y  );
*	 d0		     d0
*
*	float	x,y;
*
*   FUNCTION
*	Calculate the least integer greater than or equal to x and return it.
*	This identity is true.  Ceil(x) = -Floor(-x).
*
*   INPUTS
*	y -- IEEE single precision floating point value
*
*   RESULT
*	x -- IEEE single precision floating point value
*
*   BUGS
*
*   SEE ALSO
*	IEEESPFloor
******************************************************************************

;MIIEEESPCeil:
;	bchg	#31,d0
;	jsr	_LVOIEEEDPFloor(a6)
;	tst.l	d0	; don't turn 0.0 into -0.0
;	beq.s	QUICKZ
;		bchg	#31,d0
;QUICKZ:	rts

;nearzero:
;	tst.l	d1
;	bge.s	1$
;		move.l	#neg_one,d0	; return -1.0
;		bra.s	2$
;1$:
;		clr.l	d0	; return 0.0
;2$:
;	rts

******* mathieeesingbas.library/IEEESPFloor ***********************************
*
*   NAME
*	IEEESPFloor -- compute Floor function of IEEE single precision number
*
*   SYNOPSIS
*	  x   = IEEESPFloor(  y  );
*	  d0		      d0
*
*	float	x,y;
*
*   FUNCTION
*	Calculate the largest integer less than or equal to x and return it.
*
*   INPUTS
*	y -- IEEE single precision floating point value
*
*   RESULT
*	x -- IEEE single precision floating point value
*
*   BUGS
*
*   SEE ALSO
*	IEEESPCeil
******************************************************************************

;MIIEEESPFloor:
;	move.l	d0,d1		; is it a zero? and save in d1 for later
;	beq	QUICKZ		; yup, just return
;* check exponent, are there any fraction bits?
;	swap	d0
;	and.w	#$7f80,d0	; extract exponent
;	beq	nearzero	; unnormalized?
;	asr.w	#7,d0		; align to work with it
;	sub.w	#127,d0		; unbias it
;	blt	nearzero	; range is -1.0 < x < 1.0
* d1 is positive or 0, it tells about how many bits are to the left
* of binary point, so 0 means 1 bit left of binary point
* We have 24 total bits
* If d1 >= 24 then there are no fraction bits

;	cmp.w	#23,d0	; if #23>d0.w	; any fraction bits to eliminate?
;	bge.s	3$
*		d1 is 0 <= d1 < 23
*       	0 means clean out all 23 bits, leaving the hidden bit
*       	1 means clean out 22 bits
* 		there are some fraction bits, we eliminate these now
* 		if there were no fraction bits then we can just return with
* 		the original value
;		neg.w	d0
;		add.w	#23,d0	; how many bits to clear
				; starting from right end
*		need to save current values for later comparison
;		move.l	d1,a1
;		lsl.w	#2,d0
;		and.l	table(PC,d0.w),d1
;		move.l	d1,d0
*		have to check sign bit to round down
;		bge.s	4$	; if <	; was it negative?

*			did we really change anything?
;			cmp.l	d1,a1	; if d1=a1.l
;			bne.s	5$
;				rts
;5$:					; endif
*			something changed, so we have to decrement it by -1
;			move.l	#neg_one,d1
*			now add them, rounding to -infinity
;			jmp	_LVOIEEEDPAdd(a6)
;4$:				; endif
;	bra.s	6$	; else
;3$:
;		move.l	d1,d0		; restore original input
;6$:			; endif
;	rts

;table:				;used to clear fraction bits
;	dc.l	$ffffffff
;	dc.l	$fffffffe
;	dc.l	$fffffffc
;	dc.l	$fffffff8
;	dc.l	$fffffff0
;	dc.l	$ffffffe0
;	dc.l	$ffffffc0
;	dc.l	$ffffff80
;	dc.l	$ffffff00
;	dc.l	$fffffe00

;	dc.l	$fffffc00
;	dc.l	$fffff800
;	dc.l	$fffff000
;	dc.l	$ffffe000
;	dc.l	$ffffc000
;	dc.l	$ffff8000
;	dc.l	$ffff0000
;	dc.l	$fffe0000
;	dc.l	$fffc0000
;	dc.l	$fff80000

;	dc.l	$fff00000
;	dc.l	$ffe00000
;	dc.l	$ffc00000
;	dc.l	$ff800000
*	don't need any more bits

;IEEESPAbs
;	bclr	#$1F,D0
;	rts

;	dc.w	0

;IEEESPNeg
;	bchg	#$1F,D0
;	rts

;	dc.w	0

;lbC043734	MOVEQ	#1,D0
;	RTS

;lbC043738	MOVEQ	#-1,D0
;	RTS

;IEEESPCmp	TST.L	D0
;	BMI.B	lbC04375A
;	TST.L	D1
;	BMI.B	lbC04374E
;	CMP.L	D1,D0
;	BGT.B	lbC043734
;	BLT.B	lbC043738
;	MOVEQ	#0,D0
;	RTS

;lbC04374E	TST.L	D0
;	BNE.B	lbC043734
;	ADD.L	D1,D1
;	BNE.B	lbC043734
;	MOVEQ	#0,D0
;	RTS

;lbC04375A	TST.L	D1
;	BMI.B	lbC043768
;	BNE.B	lbC043738
;	ADD.L	D0,D0
;	BNE.B	lbC043738
;	MOVEQ	#0,D0
;	RTS

;lbC043768	CMP.L	D0,D1
;	BGT.B	lbC043734
;	BLT.B	lbC043738
;	MOVEQ	#0,D0
;	RTS

;	dc.w	0

;IEEESPTst	ADD.L	D0,D0
;	BEQ.B	lbC04377C
;	BCS.B	lbC04377E
;	MOVEQ	#1,D0
;lbC04377C	RTS

;lbC04377E	MOVEQ	#-1,D0
;	RTS

;	dc.w	0

;InitLibrary	MOVEM.L	D2/D3/A2,-(SP)
;	MOVE.L	A0,-(SP)
;	MOVEQ	#0,D2
;	MOVEQ	#0,D3			; why ?
;	LEA	VectorsFPU,A0
;	BTST	#4,$129(A6)
;	BNE.B	lbC0437A2
;	LEA	Vectors,A0
;lbC0437A2	SUBA.L	A2,A2		; init
;	LEA	Structure,A1		; structure
;	MOVEQ	#$34,D0			; dSize
;	MOVEQ	#0,D1			; segList
;	JSR	-$54(A6)		; MakeLibrary
;	MOVEA.L	D0,A2			; no error check
;	BTST	#4,$129(A6)		; FPU check
;	BNE.B	lbC0437D8
;	BTST	#1,$129(A6)		; 68020+ check
;	BEQ.B	lbC0437D8
;	LEA	IEEESPMul020,A1
;	MOVE.L	A1,-$4C(A2)
;	LEA	IEEESPDiv020,A1
;	MOVE.L	A1,-$52(A2)
;lbC0437D8	LEA	lbC043842,A1	; no FPU ver
;	BTST	#4,$129(A6)		; FPU check
;	BEQ.B	lbC0437EC
;	LEA	lbC043656,A1		; FPU ver
;lbC0437EC	MOVE.L	A1,$30(A2)
;	MOVE.B	D0,$22(A2)		; bug here
;	MOVE.L	D2,$24(A2)		; null ? why ?
;	MOVE.L	A6,$28(A2)		; exec base
;	MOVE.L	(SP)+,$2C(A2)		; why ?
;	MOVEA.L	A2,A1
;	JSR	-$18C(A6)		; AddLibrary (A1 input)
;	MOVEM.L	(SP)+,D2/D3/A2
;	RTS

;LibReserved	MOVEQ	#0,D0
;	RTS

;Structure
;	dc.w	$A008			; base offset $8
;	dc.w	$900			; type
;	dc.w	$800A			; base offset $A
;	dc.l	mathieeesingb.MSG	; name
;	dc.w	$9016			; base offset $16
;	dc.w	$0004			; revision
;	dc.w	$9014			; base offset $14
;	dc.w	$0028			; version
;	dc.w	$A00E			; base offset $E
;	dc.w	$0600			; flags
;	dc.w	$9020			; base offset $20
;	dc.w	0			; lib use counter
;	dc.w	0			; no more

;LibExpunge	MOVEQ	#0,D0
;	RTS

;LibOpen	ADDQ.W	#1,$20(A6)
;	MOVEA.L	$30(A6),A0
;	JSR	(A0)			; reset FPCR routine
;	MOVE.L	A6,D0
;	RTS

;LibClose
;	subq.w	#1,$20(A6)
;lbC043842
;	moveq	#0,D0
;	rts

;	dc.w	0
;Vectors
;	dc.w	$FFFF
;	dc.w	LibOpen-Vectors			;  -6 _LVOLibOpen
;	dc.w	LibClose-Vectors		; -12 _LVOLibClose
;	dc.w	LibExpunge-Vectors		; -18 _LVOLibExpunge
;	dc.w	LibReserved-Vectors		; -24 _LVOLibReserved
;	dc.w	IEEESPFix-Vectors		; -30 _LVOIEEESPFix
;	dc.w	IEEESPFlt-Vectors		; -36 _LVOIEEESPFlt
;	dc.w	IEEESPCmp-Vectors		; -42 _LVOIEEESPCmp
;	dc.w	IEEESPTst-Vectors		; -48 _LVOIEEESPTst
;	dc.w	IEEESPAbs-Vectors		; -54 _LVOIEEESPAbs
;	dc.w	IEEESPNeg-Vectors		; -60 _LVOIEEESPNeg
;	dc.w	IEEESPAdd-Vectors		; -66 _LVOIEEESPAdd
;	dc.w	IEEESPSub-Vectors		; -72 _LVOIEEESPSub
;	dc.w	IEEESPMul-Vectors		; -78 _LVOIEEESPMul
;	dc.w	IEEESPDiv-Vectors		; -84 _LVOIEEESPDiv
;	dc.w	IEEESPFloor-Vectors		; -90 _LVOIEEESPFloor
;	dc.w	IEEESPCeil-Vectors		; -96 _LVOIEEESPCeil
;	dc.w	$FFFF
;VectorsFPU
;	dc.w	$FFFF
;	dc.w	LibOpen-VectorsFPU		;  -6 _LVOLibOpen
;	dc.w	LibClose-VectorsFPU		; -12 _LVOLibClose
;	dc.w	LibExpunge-VectorsFPU		; -18 _LVOLibExpunge
;	dc.w	LibReserved-VectorsFPU		; -24 _LVOLibReserved
;	dc.w	IEEESPFixFPU-VectorsFPU		; -30 _LVOIEEESPFix
;	dc.w	IEEESPFltFPU-VectorsFPU		; -36 _LVOIEEESPFlt
;	dc.w	IEEESPCmp-VectorsFPU		; -42 _LVOIEEESPCmp
;	dc.w	IEEESPTst-VectorsFPU		; -48 _LVOIEEESPTst
;	dc.w	IEEESPAbs-VectorsFPU		; -54 _LVOIEEESPAbs
;	dc.w	IEEESPNeg-VectorsFPU		; -60 _LVOIEEESPNeg
;	dc.w	IEEESPAddFPU-VectorsFPU		; -66 _LVOIEEESPAdd
;	dc.w	IEEESPSubFPU-VectorsFPU		; -72 _LVOIEEESPSub
;	dc.w	IEEESPMulFPU-VectorsFPU		; -78 _LVOIEEESPMul
;	dc.w	IEEESPDivFPU-VectorsFPU		; -84 _LVOIEEESPDiv
;	dc.w	IEEESPFloorFPU-VectorsFPU	; -90 _LVOIEEESPFloor
;	dc.w	IEEESPCeil-VectorsFPU		; -96 _LVOIEEESPCeil
;	dc.w	$FFFF

;lbC043890	MOVE.W	#2,2(A0)
;	AND.W	#$FF,D7
;	CMP.W	#$32,D7
;	BNE.B	lbC0438A4
;	DIVU.W	#0,D7
;lbC0438A4	CMP.W	#$35,D7
;	BNE.B	lbC0438B0
;	ORI.B	#2,CCR
;	TRAPV
;lbC0438B0	RTS

;lbC0438B2	CMP.W	#$1C00,D7
;	BLT.B	lbC0438CA
;	CMP.W	#$1E00,D7
;	BLT.B	lbC043890
;	CMP.W	#$5C00,D7
;	BLT.B	lbC0438CA
;	CMP.W	#$5E00,D7
;	BLT.B	lbC043890
;lbC0438CA	RTS

;	MOVE.L	D7,-(SP)
;	MOVEA.L	$24(A6),A0			; null
;	LEA	$10(A0),A1
;lbC0438D6	MOVE.W	#$4000,10(A0)
;lbC0438DC	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC0438EA
;	BTST	#11,D7
;	BEQ.B	lbC04390A
;lbC0438EA	TST.W	D7
;	BMI.B	lbC0438FE
;	CMP.W	#$4900,D7
;	BEQ.B	lbC0438DC
;	CMP.W	#$900,D7
;	BLE.B	lbC0438DC
;	BSR.B	lbC0438B2
;	BRA.B	lbC0438D6

;lbC0438FE	CMP.W	#$8900,D7
;	BEQ.B	lbC0438DC
;	CMP.W	#$C900,D7
;	BEQ.B	lbC0438DC
;lbC04390A	MOVE.L	D0,(A1)
;lbC04390C	TST.W	(A0)
;	BMI.B	lbC04390C
;lbC043910	MOVE.W	#$6400,10(A0)
;lbC043916	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043924
;	BTST	#11,D7
;	BEQ.B	lbC043946
;lbC043924	TST.W	D7
;	BMI.B	lbC04393A
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043916
;	CMP.W	#$900,D7
;	BLE.B	lbC043916
;	BSR.W	lbC0438B2
;	BRA.B	lbC043910

;lbC04393A	CMP.W	#$8900,D7
;	BEQ.B	lbC043916
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043916
;lbC043946	MOVE.L	(A1),D0
;lbC043948	TST.W	(A0)
;	BMI.B	lbC043948
;	MOVE.L	(SP)+,D7
;	RTS

;	MOVE.L	D7,-(SP)
;	MOVEA.L	$24(A6),A0			; null
;	LEA	$10(A0),A1
;lbC04395A	MOVE.W	#$4400,10(A0)
;lbC043960	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC04396E
;	BTST	#11,D7
;	BEQ.B	lbC043990
;lbC04396E	TST.W	D7
;	BMI.B	lbC043984
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043960
;	CMP.W	#$900,D7
;	BLE.B	lbC043960
;	BSR.W	lbC0438B2
;	BRA.B	lbC04395A

;lbC043984	CMP.W	#$8900,D7
;	BEQ.B	lbC043960
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043960
;lbC043990	MOVE.L	D0,(A1)
;lbC043992	TST.W	(A0)
;	BMI.B	lbC043992
;lbC043996	MOVE.W	#$4422,10(A0)
;lbC04399C	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC0439AA
;	BTST	#11,D7
;	BEQ.B	lbC0439CC
;lbC0439AA	TST.W	D7
;	BMI.B	lbC0439C0
;	CMP.W	#$4900,D7
;	BEQ.B	lbC04399C
;	CMP.W	#$900,D7
;	BLE.B	lbC04399C
;	BSR.W	lbC0438B2
;	BRA.B	lbC043996

;lbC0439C0	CMP.W	#$8900,D7
;	BEQ.B	lbC04399C
;	CMP.W	#$C900,D7
;	BEQ.B	lbC04399C
;lbC0439CC	MOVE.L	D1,(A1)
;lbC0439CE	TST.W	(A0)
;	BMI.B	lbC0439CE
;lbC0439D2	MOVE.W	#$6400,10(A0)
;lbC0439D8	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC0439E6
;	BTST	#11,D7
;	BEQ.B	lbC043A08
;lbC0439E6	TST.W	D7
;	BMI.B	lbC0439FC
;	CMP.W	#$4900,D7
;	BEQ.B	lbC0439D8
;	CMP.W	#$900,D7
;	BLE.B	lbC0439D8
;	BSR.W	lbC0438B2
;	BRA.B	lbC0439D2

;lbC0439FC	CMP.W	#$8900,D7
;	BEQ.B	lbC0439D8
;	CMP.W	#$C900,D7
;	BEQ.B	lbC0439D8
;lbC043A08	MOVE.L	(A1),D0
;lbC043A0A	TST.W	(A0)
;	BMI.B	lbC043A0A
;	MOVE.L	(SP)+,D7
;	RTS

;	MOVE.L	D7,-(SP)
;	MOVEA.L	$24(A6),A0			; null
;	LEA	$10(A0),A1
;lbC043A1C	MOVE.W	#$4400,10(A0)
;lbC043A22	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043A30
;	BTST	#11,D7
;	BEQ.B	lbC043A52
;lbC043A30	TST.W	D7
;	BMI.B	lbC043A46
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043A22
;	CMP.W	#$900,D7
;	BLE.B	lbC043A22
;	BSR.W	lbC0438B2
;	BRA.B	lbC043A1C

;lbC043A46	CMP.W	#$8900,D7
;	BEQ.B	lbC043A22
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043A22
;lbC043A52	MOVE.L	D0,(A1)
;lbC043A54	TST.W	(A0)
;	BMI.B	lbC043A54
;lbC043A58	MOVE.W	#$4428,10(A0)
;lbC043A5E	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043A6C
;	BTST	#11,D7
;	BEQ.B	lbC043A8E
;lbC043A6C	TST.W	D7
;	BMI.B	lbC043A82
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043A5E
;	CMP.W	#$900,D7
;	BLE.B	lbC043A5E
;	BSR.W	lbC0438B2
;	BRA.B	lbC043A58

;lbC043A82	CMP.W	#$8900,D7
;	BEQ.B	lbC043A5E
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043A5E
;lbC043A8E	MOVE.L	D1,(A1)
;lbC043A90	TST.W	(A0)
;	BMI.B	lbC043A90
;lbC043A94	MOVE.W	#$6400,10(A0)
;lbC043A9A	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043AA8
;	BTST	#11,D7
;	BEQ.B	lbC043ACA
;lbC043AA8	TST.W	D7
;	BMI.B	lbC043ABE
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043A9A
;	CMP.W	#$900,D7
;	BLE.B	lbC043A9A
;	BSR.W	lbC0438B2
;	BRA.B	lbC043A94

;lbC043ABE	CMP.W	#$8900,D7
;	BEQ.B	lbC043A9A
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043A9A
;lbC043ACA	MOVE.L	(A1),D0
;lbC043ACC	TST.W	(A0)
;	BMI.B	lbC043ACC
;	MOVE.L	(SP)+,D7
;	RTS

;	MOVE.L	D7,-(SP)
;	MOVEA.L	$24(A6),A0			; null
;	LEA	$10(A0),A1
;lbC043ADE	MOVE.W	#$4400,10(A0)
;lbC043AE4	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043AF2
;	BTST	#11,D7
;	BEQ.B	lbC043B14
;lbC043AF2	TST.W	D7
;	BMI.B	lbC043B08
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043AE4
;	CMP.W	#$900,D7
;	BLE.B	lbC043AE4
;	BSR.W	lbC0438B2
;	BRA.B	lbC043ADE

;lbC043B08	CMP.W	#$8900,D7
;	BEQ.B	lbC043AE4
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043AE4
;lbC043B14	MOVE.L	D0,(A1)
;lbC043B16	TST.W	(A0)
;	BMI.B	lbC043B16
;lbC043B1A	MOVE.W	#$4427,10(A0)
;lbC043B20	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043B2E
;	BTST	#11,D7
;	BEQ.B	lbC043B50
;lbC043B2E	TST.W	D7
;	BMI.B	lbC043B44
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043B20
;	CMP.W	#$900,D7
;	BLE.B	lbC043B20
;	BSR.W	lbC0438B2
;	BRA.B	lbC043B1A

;lbC043B44	CMP.W	#$8900,D7
;	BEQ.B	lbC043B20
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043B20
;lbC043B50	MOVE.L	D1,(A1)
;lbC043B52	TST.W	(A0)
;	BMI.B	lbC043B52
;lbC043B56	MOVE.W	#$6400,10(A0)
;lbC043B5C	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043B6A
;	BTST	#11,D7
;	BEQ.B	lbC043B8C
;lbC043B6A	TST.W	D7
;	BMI.B	lbC043B80
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043B5C
;	CMP.W	#$900,D7
;	BLE.B	lbC043B5C
;	BSR.W	lbC0438B2
;	BRA.B	lbC043B56

;lbC043B80	CMP.W	#$8900,D7
;	BEQ.B	lbC043B5C
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043B5C
;lbC043B8C	MOVE.L	(A1),D0
;lbC043B8E	TST.W	(A0)
;	BMI.B	lbC043B8E
;	MOVE.L	(SP)+,D7
;	RTS

;	MOVE.L	D7,-(SP)
;	MOVEA.L	$24(A6),A0			; null
;	LEA	$10(A0),A1
;lbC043BA0	MOVE.W	#$4400,10(A0)
;lbC043BA6	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043BB4
;	BTST	#11,D7
;	BEQ.B	lbC043BD6
;lbC043BB4	TST.W	D7
;	BMI.B	lbC043BCA
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043BA6
;	CMP.W	#$900,D7
;	BLE.B	lbC043BA6
;	BSR.W	lbC0438B2
;	BRA.B	lbC043BA0

;lbC043BCA	CMP.W	#$8900,D7
;	BEQ.B	lbC043BA6
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043BA6
;lbC043BD6	MOVE.L	D0,(A1)
;lbC043BD8	TST.W	(A0)
;	BMI.B	lbC043BD8
;lbC043BDC	MOVE.W	#$4424,10(A0)
;lbC043BE2	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043BF0
;	BTST	#11,D7
;	BEQ.B	lbC043C12
;lbC043BF0	TST.W	D7
;	BMI.B	lbC043C06
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043BE2
;	CMP.W	#$900,D7
;	BLE.B	lbC043BE2
;	BSR.W	lbC0438B2
;	BRA.B	lbC043BDC

;lbC043C06	CMP.W	#$8900,D7
;	BEQ.B	lbC043BE2
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043BE2
;lbC043C12	MOVE.L	D1,(A1)
;lbC043C14	TST.W	(A0)
;	BMI.B	lbC043C14
;lbC043C18	MOVE.W	#$6400,10(A0)
;lbC043C1E	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043C2C
;	BTST	#11,D7
;	BEQ.B	lbC043C4E
;lbC043C2C	TST.W	D7
;	BMI.B	lbC043C42
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043C1E
;	CMP.W	#$900,D7
;	BLE.B	lbC043C1E
;	BSR.W	lbC0438B2
;	BRA.B	lbC043C18

;lbC043C42	CMP.W	#$8900,D7
;	BEQ.B	lbC043C1E
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043C1E
;lbC043C4E	MOVE.L	(A1),D0
;lbC043C50	TST.W	(A0)
;	BMI.B	lbC043C50
;	MOVE.L	(SP)+,D7
;	RTS

;	MOVE.L	D7,-(SP)
;	MOVEA.L	$24(A6),A0				; null
;	LEA	$10(A0),A1
;lbC043C62	MOVE.W	#$4400,10(A0)
;lbC043C68	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043C76
;	BTST	#11,D7
;	BEQ.B	lbC043C98
;lbC043C76	TST.W	D7
;	BMI.B	lbC043C8C
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043C68
;	CMP.W	#$900,D7
;	BLE.B	lbC043C68
;	BSR.W	lbC0438B2
;	BRA.B	lbC043C62

;lbC043C8C	CMP.W	#$8900,D7
;	BEQ.B	lbC043C68
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043C68
;lbC043C98	MOVE.L	D0,(A1)
;lbC043C9A	TST.W	(A0)
;	BMI.B	lbC043C9A
;lbC043C9E	MOVE.W	#$B000,10(A0)
;lbC043CA4	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043CB2
;	BTST	#11,D7
;	BEQ.B	lbC043CD4
;lbC043CB2	TST.W	D7
;	BMI.B	lbC043CC8
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043CA4
;	CMP.W	#$900,D7
;	BLE.B	lbC043CA4
;	BSR.W	lbC0438B2
;	BRA.B	lbC043C9E

;lbC043CC8	CMP.W	#$8900,D7
;	BEQ.B	lbC043CA4
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043CA4
;lbC043CD4	MOVE.L	(A1),-(SP)
;lbC043CD6	TST.W	(A0)
;	BMI.B	lbC043CD6
;lbC043CDA	MOVE.W	#$9000,10(A0)
;lbC043CE0	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043CEE
;	BTST	#11,D7
;	BEQ.B	lbC043D10
;lbC043CEE	TST.W	D7
;	BMI.B	lbC043D04
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043CE0
;	CMP.W	#$900,D7
;	BLE.B	lbC043CE0
;	BSR.W	lbC0438B2
;	BRA.B	lbC043CDA

;lbC043D04	CMP.W	#$8900,D7
;	BEQ.B	lbC043CE0
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043CE0
;lbC043D10	MOVE.L	#$A0,(A1)
;lbC043D16	TST.W	(A0)
;	BMI.B	lbC043D16
;	MOVE.W	#1,10(A0)
;lbC043D20	TST.W	(A0)
;	BMI.B	lbC043D20
;lbC043D24	MOVE.W	#$6400,10(A0)
;lbC043D2A	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043D38
;	BTST	#11,D7
;	BEQ.B	lbC043D5A
;lbC043D38	TST.W	D7
;	BMI.B	lbC043D4E
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043D2A
;	CMP.W	#$900,D7
;	BLE.B	lbC043D2A
;	BSR.W	lbC0438B2
;	BRA.B	lbC043D24

;lbC043D4E	CMP.W	#$8900,D7
;	BEQ.B	lbC043D2A
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043D2A
;lbC043D5A	MOVE.L	(A1),D0
;lbC043D5C	TST.W	(A0)
;	BMI.B	lbC043D5C
;lbC043D60	MOVE.W	#$9000,10(A0)
;lbC043D66	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043D74
;	BTST	#11,D7
;	BEQ.B	lbC043D96
;lbC043D74	TST.W	D7
;	BMI.B	lbC043D8A
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043D66
;	CMP.W	#$900,D7
;	BLE.B	lbC043D66
;	BSR.W	lbC0438B2
;	BRA.B	lbC043D60

;lbC043D8A	CMP.W	#$8900,D7
;	BEQ.B	lbC043D66
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043D66
;lbC043D96	MOVE.L	(SP)+,(A1)
;lbC043D98	TST.W	(A0)
;	BMI.B	lbC043D98
;	MOVE.L	(SP)+,D7
;	RTS

;	MOVE.L	D7,-(SP)
;	MOVEA.L	$24(A6),A0			; null
;	LEA	$10(A0),A1
;	MOVEQ	#0,D0
;	MOVE.W	D0,6(A0)
;	MOVE.W	6(A0),D0
;	AND.W	#$FF00,D0
;	BEQ.B	lbC043DBC
;	RTS

;lbC043DBC	TST.W	(A0)
;	BMI.B	lbC043DBC
;lbC043DC0	MOVE.W	#$9000,10(A0)
;lbC043DC6	MOVE.W	(A0),D7
;	BTST	#12,D7
;	BEQ.B	lbC043DD4
;	BTST	#11,D7
;	BEQ.B	lbC043DF6
;lbC043DD4	TST.W	D7
;	BMI.B	lbC043DEA
;	CMP.W	#$4900,D7
;	BEQ.B	lbC043DC6
;	CMP.W	#$900,D7
;	BLE.B	lbC043DC6
;	BSR.W	lbC0438B2
;	BRA.B	lbC043DC0

;lbC043DEA	CMP.W	#$8900,D7
;	BEQ.B	lbC043DC6
;	CMP.W	#$C900,D7
;	BEQ.B	lbC043DC6
;lbC043DF6	MOVE.L	#$40,(A1)
;lbC043DFC	TST.W	(A0)
;	BMI.B	lbC043DFC
;	MOVEQ	#0,D0
;	MOVE.L	(SP)+,D7
;	RTS

;	dc.w	0

;lbC043E08	MOVE.W	D1,D2
;	OR.W	#7,D2
;	SUB.W	D0,D2
;	AND.W	#$FFF8,D2
;	BGT.B	lbC043E2E
;	CMP.L	#$7F80,D0
;	BEQ.B	lbC043E22
;	BRA.W	lbC044608

;lbC043E22	CMP.W	D7,D1
;	BLT.B	lbC043E34
;	CMP.L	#$7F80,D1
;	BEQ.B	lbC043E34
;lbC043E2E	MOVE.L	D1,D0
;	BRA.W	lbC044608

;lbC043E34	TST.L	D1
;	BNE.B	lbC043E3C
;	BRA.W	lbC044600

;lbC043E3C	BRA.W	lbC0445F0

;lbC043E40	CMP.L	#$7F80,D1
;	BEQ.B	lbC043E4E
;	MOVE.L	D1,D0
;	BRA.W	lbC044608

;lbC043E4E	TST.L	D0
;	BNE.B	lbC043E56
;	BRA.W	lbC044600

;lbC043E56	BRA.W	lbC0445F0

;lbC043E5A	TST.L	D0
;	BNE.B	lbC043E62
;	BRA.W	lbC0445D8

;lbC043E62	BSR.W	lbC0443B0
;	BRA.B	lbC043EC2

;lbC043E68	TST.L	D1
;	BNE.B	lbC043E70
;	BRA.W	lbC0445D8

;lbC043E70	EXG	D0,D1
;	EXG	D6,D7
;	BSR.W	lbC0443B0
;	EXG	D0,D1
;	EXG	D6,D7
;	BRA.B	lbC043ECC

;IEEESPMul	MOVEA.L	D6,A0
;	MOVEA.L	D7,A1
;	MOVE.L	D2,-(SP)
;	BSR.B	lbC043E9C
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.L	(SP)+,D2
;	RTS

;lbC043E8E	BRA.W	lbC043E08

;lbC043E92	BRA.B	lbC043E40

;lbC043E94	BRA.B	lbC043E5A

;lbC043E96	BRA.B	lbC043E68

;lbC043E98	BRA.W	lbC0445F0

;lbC043E9C	MOVE.L	D0,D6
;	EOR.L	D1,D6
;	MOVE.W	#$7F80,D7
;	SWAP	D0
;	AND.W	#$7FFF,D0
;	SWAP	D1
;	AND.W	#$7FFF,D1
;	CMP.W	D7,D0
;	BGE.B	lbC043E8E
;	CMP.W	D7,D1
;	BGE.B	lbC043E92
;	MOVE.W	D0,D6
;	AND.W	D7,D6
;	BEQ.B	lbC043E94
;	EOR.W	D6,D0
;	EOR.B	D7,D0
;lbC043EC2	AND.W	D1,D7
;	BEQ.B	lbC043E96
;	EOR.W	D7,D1
;	OR.W	#$80,D1
;lbC043ECC	SUB.W	#$3F80,D6
;	ADD.W	D7,D6
;	BVS.B	lbC043E98
;	SWAP	D0
;	LSL.L	#7,D0
;	SWAP	D1
;	LSL.L	#7,D1
;	MOVE.W	D0,D7
;	MOVE.W	D1,D2
;	MULU.W	D2,D7
;	CLR.W	D7
;	SWAP	D7
;	SWAP	D0
;	MULU.W	D0,D2
;	ADD.L	D2,D7
;	SWAP	D1
;	SWAP	D0
;	MOVE.L	D0,D2
;	MULU.W	D1,D2
;	ADD.L	D2,D7
;	SWAP	D0
;	MULU.W	D1,D0
;	CLR.W	D7
;	SWAP	D7
;	ADD.L	D7,D0
;	BRA.W	lbC044426

;lbC043F04	MOVE.W	D1,D2
;	OR.W	#7,D2
;	SUB.W	D0,D2
;	AND.W	#$FFF8,D2
;	BGT.B	lbC043F2A
;	CMP.L	#$7F80,D0
;	BEQ.B	lbC043F1E
;	BRA.W	lbC044608

;lbC043F1E	CMP.W	D7,D1
;	BLT.B	lbC043F30
;	CMP.L	#$7F80,D1
;	BEQ.B	lbC043F30
;lbC043F2A	MOVE.L	D1,D0
;	BRA.W	lbC044608

;lbC043F30	TST.L	D1
;	BNE.B	lbC043F38
;	BRA.W	lbC044600

;lbC043F38	BRA.W	lbC0445F0

;lbC043F3C	CMP.L	#$7F80,D1
;	BEQ.B	lbC043F4A
;	MOVE.L	D1,D0
;	BRA.W	lbC044608

;lbC043F4A	TST.L	D0
;	BNE.B	lbC043F52
;	BRA.W	lbC044600

;lbC043F52	BRA.W	lbC0445F0

;lbC043F56	TST.L	D0
;	BNE.B	lbC043F5E
;	BRA.W	lbC0445D8

;lbC043F5E	BSR.W	lbC0443B0
;	BRA.B	lbC043FBE

;lbC043F64	TST.L	D1
;	BNE.B	lbC043F6C
;	BRA.W	lbC0445D8

;lbC043F6C	EXG	D0,D1
;	EXG	D6,D7
;	BSR.W	lbC0443B0
;	EXG	D0,D1
;	EXG	D6,D7
;	BRA.B	lbC043FC8

;IEEESPMul020	MOVEA.L	D6,A0
;	MOVEA.L	D7,A1
;	MOVE.L	D2,-(SP)
;	BSR.B	lbC043F98
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.L	(SP)+,D2
;	RTS

;lbC043F8A	BRA.W	lbC043F04

;lbC043F8E	BRA.B	lbC043F3C

;lbC043F90	BRA.B	lbC043F56

;lbC043F92	BRA.B	lbC043F64

;lbC043F94	BRA.W	lbC0445F0

;lbC043F98	MOVE.L	D0,D6
;	EOR.L	D1,D6
;	MOVE.W	#$7F80,D7
;	SWAP	D0
;	AND.W	#$7FFF,D0
;	SWAP	D1
;	AND.W	#$7FFF,D1
;	CMP.W	D7,D0
;	BGE.B	lbC043F8A
;	CMP.W	D7,D1
;	BGE.B	lbC043F8E
;	MOVE.W	D0,D6
;	AND.W	D7,D6
;	BEQ.B	lbC043F90
;	EOR.W	D6,D0
;	EOR.B	D7,D0
;lbC043FBE	AND.W	D1,D7
;	BEQ.B	lbC043F92
;	EOR.W	D7,D1
;	OR.W	#$80,D1
;lbC043FC8	SUB.W	#$3F80,D6
;	ADD.W	D7,D6
;	BVS.B	lbC043F94
;	SWAP	D0
;	LSL.L	#7,D0
;	SWAP	D1
;	LSL.L	#7,D1
;	MULU.L	D1,D7:D0		; 68020+ command
;	MOVE.L	D7,D0
;	BRA.W	lbC044426

;	dc.w	0

;IEEESPDiv	MOVEA.L	D6,A0
;	MOVEA.L	D7,A1
;	MOVE.L	D2,-(SP)
;	BSR.B	lbC043FF4
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.L	(SP)+,D2
;	RTS

;lbC043FF4	MOVE.L	D0,D6
;	EOR.L	D1,D6
;	MOVE.W	#$7F80,D7
;	SWAP	D0
;	AND.W	#$7FFF,D0
;	SWAP	D1
;	AND.W	#$7FFF,D1
;	CMP.W	D7,D0
;	BLT.B	lbC044054
;	MOVE.W	D1,D2
;	OR.W	#7,D2
;	SUB.W	D0,D2
;	AND.W	#$FFF8,D2
;	BGT.B	lbC044032
;	CMP.L	#$7F80,D0
;	BEQ.B	lbC044026
;	BRA.W	lbC044608

;lbC044026	CMP.W	D7,D1
;	BLT.B	lbC04403C
;	CMP.L	#$7F80,D1
;	BEQ.B	lbC044038
;lbC044032	MOVE.L	D1,D0
;	BRA.W	lbC044608

;lbC044038	BRA.W	lbC044600

;lbC04403C	TST.L	D1
;	BNE.B	lbC044050
;lbC044040	MOVE.L	D6,D0
;	AND.L	#$80000000,D0
;	EORI.L	#$7F800000,D0
;	RTS

;lbC044050	BRA.W	lbC0445F0

;lbC044054	CMP.W	D7,D1
;	BLT.B	lbC04406A
;	CMP.L	#$7F80,D1
;	BEQ.B	lbC044066
;	MOVE.L	D1,D0
;	BRA.W	lbC044608

;lbC044066	BRA.W	lbC0445D8

;lbC04406A	MOVE.W	D0,D6
;	AND.W	D7,D6
;	BNE.B	lbC044086
;	TST.L	D0
;	BNE.B	lbC044080
;	TST.L	D1
;	BNE.B	lbC04407C
;	BRA.W	lbC044600

;lbC04407C	BRA.W	lbC0445D8

;lbC044080	BSR.W	lbC0443B0
;	BRA.B	lbC04408C

;lbC044086	EOR.W	D6,D0
;	EORI.W	#$80,D0
;lbC04408C	AND.W	D1,D7
;	BNE.B	lbC0440A4
;	TST.L	D1
;	BNE.B	lbC044096
;	BRA.B	lbC044040

;lbC044096	EXG	D0,D1
;	EXG	D6,D7
;	BSR.W	lbC0443B0
;	EXG	D0,D1
;	EXG	D6,D7
;	BRA.B	lbC0440AA

;lbC0440A4	EOR.W	D7,D1
;	EORI.W	#$80,D1
;lbC0440AA	SUB.W	#$3F00,D7
;	SUB.W	D7,D6
;	BVS.W	lbC0445F0
;	SWAP	D0
;	LSL.L	#5,D0
;	SWAP	D1
;	LSL.L	#8,D1
;	SWAP	D1
;	DIVU.W	D1,D0
;	MOVE.W	D0,D2
;	CLR.W	D0
;	SWAP	D1
;	MOVE.W	D1,D7
;	MULU.W	D2,D7
;	SUB.L	D7,D0
;	BCC.B	lbC0440D2
;	SUBQ.W	#1,D2
;	ADD.L	D1,D0
;lbC0440D2	SWAP	D2
;	SWAP	D1
;	MOVE.L	D0,D7
;	DIVU.W	D1,D0
;	BVC.B	lbC0440E2
;	MOVE.W	#$FFFF,D2
;	BRA.B	lbC0440F2

;lbC0440E2	MOVE.W	D0,D2
;	CLR.W	D0
;	SWAP	D1
;	MOVE.W	D1,D7
;	MULU.W	D2,D7
;	SUB.L	D7,D0
;	BCC.B	lbC0440F2
;	SUBQ.L	#1,D2
;lbC0440F2	MOVE.L	D2,D0
;	BRA.W	lbC044426

;IEEESPDiv020	MOVEA.L	D6,A0
;	MOVEA.L	D7,A1
;	MOVE.L	D2,-(SP)
;	BSR.B	lbC044108
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.L	(SP)+,D2
;	RTS

;lbC044108	MOVE.L	D0,D6
;	EOR.L	D1,D6
;	MOVE.W	#$7F80,D7
;	SWAP	D0
;	AND.W	#$7FFF,D0
;	SWAP	D1
;	AND.W	#$7FFF,D1
;	CMP.W	D7,D0
;	BLT.B	lbC044168
;	MOVE.W	D1,D2
;	OR.W	#7,D2
;	SUB.W	D0,D2
;	AND.W	#$FFF8,D2
;	BGT.B	lbC044146
;	CMP.L	#$7F80,D0
;	BEQ.B	lbC04413A
;	BRA.W	lbC044608

;lbC04413A	CMP.W	D7,D1
;	BLT.B	lbC044150
;	CMP.L	#$7F80,D1
;	BEQ.B	lbC04414C
;lbC044146	MOVE.L	D1,D0
;	BRA.W	lbC044608

;lbC04414C	BRA.W	lbC044600

;lbC044150	TST.L	D1
;	BNE.B	lbC044164
;lbC044154	MOVE.L	D6,D0
;	AND.L	#$80000000,D0
;	EORI.L	#$7F800000,D0
;	RTS

;lbC044164	BRA.W	lbC0445F0

;lbC044168	CMP.W	D7,D1
;	BLT.B	lbC04417E
;	CMP.L	#$7F80,D1
;	BEQ.B	lbC04417A
;	MOVE.L	D1,D0
;	BRA.W	lbC044608

;lbC04417A	BRA.W	lbC0445D8

;lbC04417E	MOVE.W	D0,D6
;	AND.W	D7,D6
;	BNE.B	lbC04419A
;	TST.L	D0
;	BNE.B	lbC044194
;	TST.L	D1
;	BNE.B	lbC044190
;	BRA.W	lbC044600

;lbC044190	BRA.W	lbC0445D8

;lbC044194	BSR.W	lbC0443B0
;	BRA.B	lbC0441A0

;lbC04419A	EOR.W	D6,D0
;	EORI.W	#$80,D0
;lbC0441A0	AND.W	D1,D7
;	BNE.B	lbC0441B8
;	TST.L	D1
;	BNE.B	lbC0441AA
;	BRA.B	lbC044154

;lbC0441AA	EXG	D0,D1
;	EXG	D6,D7
;	BSR.W	lbC0443B0
;	EXG	D0,D1
;	EXG	D6,D7
;	BRA.B	lbC0441BE

;lbC0441B8	EOR.W	D7,D1
;	EORI.W	#$80,D1
;lbC0441BE	SUB.W	#$3F00,D7
;	SUB.W	D7,D6
;	BVS.W	lbC0445F0
;	SWAP	D0
;	LSL.L	#5,D0
;	SWAP	D1
;	LSL.L	#8,D1
;	MOVE.L	D0,D7
;	MOVEQ	#0,D0
;	DIVU.L	D1,D7:D0		; 68020+ command
;	BRA.W	lbC044426

;IEEESPSub	BCHG	#$1F,D1
;IEEESPAdd	MOVEA.L	D6,A0
;	MOVEA.L	D7,A1
;	MOVE.W	D2,-(SP)
;	MOVE.W	#$80,D2
;	MOVE.L	D0,D6
;	MOVE.L	D1,D7
;	MOVE.W	#$7F80,D7
;	SWAP	D0
;	AND.W	#$7FFF,D0
;	MOVE.W	D0,D6
;	AND.W	D7,D6
;	EOR.W	D6,D0
;	SWAP	D1
;	AND.W	#$7FFF,D1
;	AND.W	D1,D7
;	EOR.W	D7,D1
;	CMP.W	D7,D6
;	BNE.W	lbC0442F4
;	CMP.W	#$7F80,D6
;	BNE.B	lbC04423C
;	MOVE.W	D1,D7
;	OR.W	#7,D7
;	SUB.W	D0,D7
;	AND.W	#$FFF8,D7
;	BGT.B	lbC04422A
;	TST.L	D0
;	BNE.B	lbC04422C
;	TST.L	D1
;	BEQ.B	lbC044236
;lbC04422A	MOVE.L	D1,D0
;lbC04422C	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	BRA.W	lbC044608

;lbC044236	EOR.L	D6,D7
;	BPL.B	lbC04429A
;	BMI.B	lbC0442A6
;lbC04423C	TST.W	D6
;	BNE.B	lbC044274
;	SWAP	D0
;	BNE.B	lbC04426A
;	SWAP	D1
;	BNE.B	lbC044256
;	AND.L	D7,D6
;	MOVE.L	D6,D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	BRA.W	lbC0445DA

;lbC044256	CLR.W	D7
;	OR.L	D7,D1
;	MOVE.L	D1,D0
;lbC04425C	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	RTS

;lbC044264	CLR.W	D6
;	OR.L	D6,D0
;	BRA.B	lbC04425C

;lbC04426A	SWAP	D1
;	BEQ.B	lbC044264
;	ADD.L	D0,D0
;	ADD.L	D1,D1
;	BRA.B	lbC04427C

;lbC044274	EOR.B	D2,D0
;	EOR.B	D2,D1
;	SWAP	D0
;	SWAP	D1
;lbC04427C	EOR.L	D6,D7
;	BPL.B	lbC0442B0
;	SUB.L	D1,D0
;	BMI.B	lbC044290
;	BNE.W	lbC044450
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	RTS

;lbC044290	NEG.L	D0
;	BCHG	#$1F,D6
;	BRA.W	lbC044450

;lbC04429A	MOVE.L	D6,D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	BRA.W	lbC0445F2

;lbC0442A6	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	BRA.W	lbC044600

;lbC0442B0	ADD.L	D1,D0
;	BTST	#$18,D0
;	BEQ.W	lbC044362
;	ADDQ.L	#1,D0
;	LSR.L	#1,D0
;	ADD.W	D2,D6
;	CMP.W	#$7F80,D6
;	BLT.W	lbC044362
;	MOVE.L	D6,D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	BRA.W	lbC0445E2

;lbC0442D4	SWAP	D1
;	BNE.B	lbC0442E8
;	CLR.W	D6
;	SWAP	D0
;	OR.L	D6,D0
;	BRA.W	lbC04425C

;lbC0442E2	TST.L	D0
;	BNE.B	lbC0442EC
;	BRA.B	lbC04429A

;lbC0442E8	ADD.L	D1,D1
;	BRA.B	lbC044308

;lbC0442EC	BRA.W	lbC04422C

;lbC0442F0	ADD.W	D2,D6
;	BRA.B	lbC044330

;lbC0442F4	BGT.B	lbC0442FA
;	EXG	D0,D1
;	EXG	D6,D7
;lbC0442FA	CMP.W	#$7F80,D6
;	BEQ.B	lbC0442E2
;	TST.W	D7
;	BEQ.B	lbC0442D4
;	EOR.B	D2,D1
;	SWAP	D1
;lbC044308	EOR.B	D2,D0
;	SWAP	D0
;	SUB.W	D2,D6
;	SUB.W	D6,D7
;	NEG.W	D7
;	LSR.W	#7,D7
;	CMP.W	#$18,D7
;	BGT.B	lbC0442F0
;	ADD.L	D0,D0
;	LSR.L	D7,D1
;	EOR.L	D6,D7
;	BMI.B	lbC044386
;	ADD.L	D1,D0
;	ADDQ.L	#1,D0
;	BTST	#$19,D0
;	BNE.B	lbC044354
;	LSR.L	#1,D0
;	ADD.W	D2,D6
;lbC044330	BEQ.B	lbC044346
;	SWAP	D0
;	EOR.B	D2,D0
;	ROL.L	#1,D6
;	ROR.W	#1,D6
;	OR.W	D6,D0
;	SWAP	D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	RTS

;lbC044346	ADDQ.L	#1,D0
;	ADD.L	D6,D6
;	ROXR.L	#1,D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	RTS

;lbC044354	ADDQ.L	#1,D0
;	LSR.L	#2,D0
;	ADD.W	#$100,D6
;	CMP.W	#$7F80,D6
;	BGE.B	lbC04437A
;lbC044362	TST.W	D6
;	BEQ.B	lbC044346
;	SWAP	D0
;	EOR.B	D2,D0
;	ROL.L	#1,D6
;	ROR.W	#1,D6
;	OR.W	D6,D0
;	SWAP	D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	RTS

;lbC04437A	MOVE.L	D6,D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	BRA.W	lbC0445E2

;lbC044386	SUBX.L	D7,D7
;	SUBX.L	D1,D0
;	BTST	#$18,D0
;	BEQ.W	lbC044450
;	SUB.L	D7,D0
;	LSR.L	#1,D0
;	ADD.W	D2,D6
;	BEQ.B	lbC044346
;	SWAP	D0
;	EOR.B	D2,D0
;	ROL.L	#1,D6
;	ROR.W	#1,D6
;	OR.W	D6,D0
;	SWAP	D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	RTS

;	dc.w	0

;lbC0443B0	SWAP	D0
;	MOVE.W	#$80,D6
;	CMP.L	#$100,D0
;	BGE.B	lbC0443C4
;	SUB.W	#$800,D6
;	BRA.B	lbC0443D0

;lbC0443C4	SWAP	D0
;	TST.W	D0
;	BNE.B	lbC0443D0
;	ROL.L	#8,D0
;	SUB.W	#$400,D6
;lbC0443D0	CMP.W	#$10,D0
;	BGE.B	lbC0443DC
;	ROL.L	#4,D0
;	SUB.W	#$200,D6
;lbC0443DC	CMP.W	#$40,D0
;	BGE.B	lbC0443E8
;	ROL.L	#2,D0
;	SUB.W	#$100,D6
;lbC0443E8	TST.B	D0
;	BMI.B	lbC0443F2
;	ROL.L	#1,D0
;	SUB.W	#$80,D6
;lbC0443F2	RTS

;lbC0443F4	NEG.W	D6
;	LSR.W	#7,D6
;	ADDQ.W	#5,D6
;	CMP.W	#$1E,D6
;	BLT.B	lbC044404
;	BRA.W	lbC0445D8

;lbC044404	SUBQ.L	#1,D6
;	LSR.L	D6,D0
;	MOVEQ	#0,D7
;	ADDX.L	D7,D0
;	LSR.L	#1,D0
;	AND.L	#$80000000,D6
;	EOR.L	D6,D0
;	RTS

;lbC044418	BRA.B	lbC0443F4

;lbC04441A	LSR.L	#1,D0
;	TST.W	D6
;	BGE.B	lbC044432
;	BRA.B	lbC0443F4

;lbC044422	BRA.W	lbC0445F0

;lbC044426	BTST	#$1D,D0
;	BNE.B	lbC04441A
;	SUB.W	#$80,D6
;	BLT.B	lbC044418
;lbC044432	MOVEQ	#$10,D1
;	ADD.L	D1,D0
;	LSR.L	#5,D0
;	SWAP	D0
;	ADD.W	D6,D0
;	CMP.W	#$7F80,D0
;	BGE.B	lbC044422
;	SWAP	D6
;	AND.W	#$8000,D6
;	EOR.W	D6,D0
;	SWAP	D0
;	RTS

;	dc.w	0

;lbC044450	CMP.L	#$100,D0
;	BGE.B	lbC04445E
;	SUB.W	#$800,D6
;	BRA.B	lbC04446A

;lbC04445E	SWAP	D0
;	TST.W	D0
;	BNE.B	lbC04446A
;	ROL.L	#8,D0
;	SUB.W	#$400,D6
;lbC04446A	CMP.W	#$10,D0
;	BGE.B	lbC044476
;	ROL.L	#4,D0
;	SUB.W	#$200,D6
;lbC044476	CMP.W	#$40,D0
;	BGE.B	lbC044482
;	ROL.L	#2,D0
;	SUB.W	#$100,D6
;lbC044482	TST.B	D0
;	BMI.B	lbC04448A
;	ROL.L	#1,D0
;	SUB.W	D2,D6
;lbC04448A	TST.W	D6
;	BGT.B	lbC0444A8
;	BEQ.B	lbC0444BA
;	SWAP	D0
;	NEG.W	D6
;	LSR.W	#7,D6
;	LSR.L	D6,D0
;	ADD.L	D6,D6
;	ROXR.L	#1,D0
;	MOVEQ	#0,D1
;	ADDX.L	D1,D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	RTS

;lbC0444A8	EOR.W	D2,D0
;	ROL.L	#1,D6
;	ROR.W	#1,D6
;	OR.W	D6,D0
;	SWAP	D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	RTS

;lbC0444BA	SWAP	D0
;	ADDQ.L	#1,D0
;	ADD.L	D6,D6
;	ROXR.L	#1,D0
;	MOVE.L	A0,D6
;	MOVE.L	A1,D7
;	MOVE.W	(SP)+,D2
;	RTS

;	dc.w	0

;lbC0444CC	RTS

;IEEESPFlt	MOVE.L	D0,D1
;	BEQ.B	lbC0444CC
;	BPL.B	lbC0444D6
;	NEG.L	D0
;lbC0444D6	CMP.L	#$1000000,D0
;	BCS.B	lbC044524
;	MOVE.W	#$4A80,D1
;	CMP.L	#$8000000,D0
;	BCS.B	lbC0444F0
;	ADD.W	#$200,D1
;	LSR.L	#4,D0
;lbC0444F0	CMP.L	#$2000000,D0
;	BCS.B	lbC0444FE
;	ADD.W	#$100,D1
;	LSR.L	#2,D0
;lbC0444FE	CMP.L	#$1000000,D0
;	BCS.B	lbC04450C
;	ADD.W	#$80,D1
;	LSR.L	#1,D0
;lbC04450C	MOVEA.L	D1,A0
;	MOVEQ	#0,D1
;	ADDX.L	D1,D0
;	MOVE.L	A0,D1
;	SWAP	D0
;	ADD.W	D1,D0
;	SWAP	D1
;	AND.W	#$8000,D1
;	EOR.W	D1,D0
;	SWAP	D0
;	RTS

;lbC044524	MOVE.W	#$4B00,D1
;	CMP.L	#$100,D0
;	BGE.B	lbC044536
;	SUB.W	#$800,D1
;	BRA.B	lbC044542

;lbC044536	SWAP	D0
;	TST.W	D0
;	BNE.B	lbC044542
;	ROL.L	#8,D0
;	SUB.W	#$400,D1
;lbC044542	CMP.W	#$10,D0
;	BGE.B	lbC04454E
;	ROL.L	#4,D0
;	SUB.W	#$200,D1
;lbC04454E	CMP.W	#$40,D0
;	BGE.B	lbC04455A
;	ROL.L	#2,D0
;	SUB.W	#$100,D1
;lbC04455A	TST.B	D0
;	BMI.B	lbC044564
;	ROL.L	#1,D0
;	SUB.W	#$80,D1
;lbC044564	EORI.W	#$80,D0
;	ROL.L	#1,D1
;	ROR.W	#1,D1
;	OR.W	D1,D0
;	SWAP	D0
;	RTS

;	dc.w	0

;IEEESPFix	MOVEA.L	D2,A0
;	MOVE.L	#$7FFFFFFF,D2
;	MOVE.L	D0,D1
;	BPL.B	lbC044584
;	ADDQ.L	#1,D2
;	EOR.L	D2,D0
;lbC044584	SWAP	D0
;	MOVE.W	D0,D1
;	AND.W	#$7F80,D1
;	EOR.W	D1,D0
;	SUB.W	#$3F80,D1
;	BLT.B	lbC0445AC
;	EORI.W	#$80,D0
;	SWAP	D0
;	ASR.W	#7,D1
;	SUB.W	#$17,D1
;	BGT.B	lbC0445C2
;	NEG.W	D1
;	LSR.L	D1,D0
;	TST.L	D1
;	BMI.B	lbC0445D2
;	BRA.B	lbC0445D4

;lbC0445AC	MOVEQ	#0,D0
;	BRA.B	lbC0445D4

;lbC0445B0	CMP.W	#$69,D1
;	BLT.B	lbC0445BE
;	TST.L	D0
;	BEQ.B	lbC0445BE
;	MOVEQ	#0,D0
;	BRA.B	lbC0445D4

;lbC0445BE	MOVE.L	D2,D0
;	BRA.B	lbC0445D4

;lbC0445C2	CMP.W	#8,D1
;	BGT.B	lbC0445B0
;	LSL.L	D1,D0
;	CMP.L	D2,D0
;	BHI.B	lbC0445BE
;	TST.L	D1
;	BPL.B	lbC0445D4
;lbC0445D2	NEG.L	D0
;lbC0445D4	MOVE.L	A0,D2
;	RTS


;lbC0445D8	MOVE.L	D6,D0
;lbC0445DA	AND.L	#$80000000,D0
;	RTS

;lbC0445E2	AND.L	#$80000000,D0
;	EORI.L	#$7F800000,D0
;	RTS

;lbC0445F0	MOVE.L	D6,D0
;lbC0445F2	AND.L	#$80000000,D0
;	EORI.L	#$7F800000,D0
;	RTS

;lbC044600	MOVE.L	#$7F880000,D0
;	RTS

;lbC044608	BTST	#6,D0
;	BEQ.B	lbC044616
;	BCLR	#6,D0
;	BSET	#4,D0
;lbC044616	OR.W	#$7F88,D0
;	SWAP	D0
;	RTS

;	dc.w	0

;	ORI.B	#2,CCR
;	TRAPV
;	RTS

;	MOVE.L	D0,-(SP)
;	DIVU.W	#0,D0
;	MOVE.L	(SP)+,D0
;	RTS

;	dc.w	0

;mathieeesingb.MSG	dc.b	'mathieeesingbas.library',0
;mathieeesingb.MSG0	dc.b	'mathieeesingbas 40.4 (16.3.93)',$D,$A,0
;	dc.b	0
;EndSkip

MatchTag
	ILLEGAL				; match word
	dc.l	MatchTag		; match tag
	dc.l	EndSkip			; end skip
	dc.b	1			; flags
	dc.b	$29			; new version
	dc.b	9			; type
	dc.b	0			; priority
	dc.l	mathieeesingb.MSG	; name
	dc.l	mathieeesingb.MSG0	; id string
	dc.l	InitLibrary		; init code

InitLibrary
	move.l	A2,-(SP)
	lea	Vectors(PC),A0
	sub.l	A2,A2			; init
	lea	Structure(PC),A1	; structure
	moveq	#$22+2,D0		; dSize (new/shortest size)
	moveq	#0,D1			; segList
	jsr	-$54(A6)		; MakeLibrary
	move.l	(SP)+,A2
	move.l	D0,A1			; no error check
	moveq	#-2,D0
	and.b	$129(A6),D0
	beq.b	NoFPU
	bpl.b	No68060			; btst #7,D0
	rol.b	#1,D0			; btst #6,D0
	bmi.b	FPU060
	clr.b	D0			; skip mulu.l/divu.l 64-bit CPU version
	bra.b	NoFPU
No68060
	rol.b	#4,D0			; btst #3,D0
	bpl.b	No68040
	ror.b	#3,D0			; btst #6,D0
	bpl.b	NoFPU
	bra.b	FPU040
No68040
	ror.b	#1,D0			; btst #4,D0, 68881 FPU check
	bpl.b	NoFPU
FPU060
	lea	IEEESPFloorFPU(PC),A0
	move.l	A0,-90+2(A1)
	lea	IEEESPCeilFPU(PC),A0
	move.l	A0,-96+2(A1)
FPU040
	lea	LibOpenFPU(PC),A0
	move.l	A0,-6+2(A1)
	lea	IEEESPFixFPU(PC),A0
	move.l	A0,-30+2(A1)
	lea	IEEESPFltFPU(PC),A0
	move.l	A0,-36+2(A1)
	lea	IEEESPAddFPU(PC),A0
	move.l	A0,-66+2(A1)
	lea	IEEESPSubFPU(PC),A0
	move.l	A0,-72+2(A1)
	lea	IEEESPMulFPU(PC),A0
	move.l	A0,-78+2(A1)
	lea	IEEESPDivFPU(PC),A0
	move.l	A0,-84+2(A1)
NoFPU
	move.b	D0,$22(A1)		; CPU flag
	jmp	-$18C(A6)		; AddLibrary (A1 input)

Structure
	dc.w	$A008			; base offset $8
	dc.w	$900			; type
	dc.w	$800A			; base offset $A
	dc.l	mathieeesingb.MSG	; name
	dc.w	$9016			; base offset $16
	dc.w	1			; revision
	dc.w	$9014			; base offset $14
	dc.w	$0029			; version
	dc.w	$A00E			; base offset $E
	dc.w	$0600			; flags
	dc.w	$9020			; base offset $20
	dc.w	0			; lib use counter
	dc.w	0			; no more

Vectors
	dc.w	$FFFF
	dc.w	LibOpen-Vectors			;  -6 _LVOLibOpen
	dc.w	LibClose-Vectors		; -12 _LVOLibClose
	dc.w	LibExpunge-Vectors		; -18 _LVOLibExpunge
	dc.w	LibReserved-Vectors		; -24 _LVOLibReserved
	dc.w	IEEESPFix-Vectors		; -30 _LVOIEEESPFix
	dc.w	IEEESPFlt-Vectors		; -36 _LVOIEEESPFlt
	dc.w	IEEESPCmp-Vectors		; -42 _LVOIEEESPCmp
	dc.w	IEEESPTst-Vectors		; -48 _LVOIEEESPTst
	dc.w	IEEESPAbs-Vectors		; -54 _LVOIEEESPAbs
	dc.w	IEEESPNeg-Vectors		; -60 _LVOIEEESPNeg
	dc.w	IEEESPAdd-Vectors		; -66 _LVOIEEESPAdd
	dc.w	IEEESPSub-Vectors		; -72 _LVOIEEESPSub
	dc.w	IEEESPMul-Vectors		; -78 _LVOIEEESPMul
	dc.w	IEEESPDiv-Vectors		; -84 _LVOIEEESPDiv
	dc.w	IEEESPFloor-Vectors		; -90 _LVOIEEESPFloor
	dc.w	IEEESPCeil-Vectors		; -96 _LVOIEEESPCeil
	dc.w	$FFFF

LibOpenFPU
	moveq	#$40,D0
	fmove.l	D0,FPCR
LibOpen
	addq.w	#1,$20(A6)
	move.l	A6,D0
	rts

IEEESPFltFPU
	FMOVE.L	D0,FP0
	FMOVE.S	FP0,D0
	RTS

IEEESPFixFPU
	FMOVE.S	D0,FP0
	FMOVE.L	FP0,D0
	RTS

IEEESPCeilFPU
	pea	CeilEnd(PC)			; Ceil return routine
	bchg	#$1F,D0
IEEESPFloorFPU
	fintrz.s	D0,FP0
	tst.l	D0
	bpl.b	PutFloor
	fsub.s	#1.0,FP0
PutFloor
	fmove.s	FP0,D0
	rts

IEEESPAddFPU
	FMOVE.S	D0,FP0
	FADD.S	D1,FP0
	FMOVE.S	FP0,D0
	RTS

IEEESPSubFPU
	FMOVE.S	D0,FP0
	FSUB.S	D1,FP0
	FMOVE.S	FP0,D0
	RTS

IEEESPMulFPU
	FMOVE.S	D0,FP0
	fmul.s	D1,FP0
	FMOVE.S	FP0,D0
	RTS

IEEESPDivFPU
	FMOVE.S	D0,FP0
	fdiv.s	D1,FP0
	FMOVE.S	FP0,D0
	RTS

CeilEnd
	tst.l	D0
	beq.b	CeilNull
	bchg	#$1F,D0
CeilNull
	rts

LibClose
	subq.w	#1,$20(A6)
LibExpunge
LibReserved
null
	moveq	#0,D0
	rts

nearzero
	tst.l	D0
	bge.b	null
	move.l	#$BF800000,D0
QUICKZ
	rts

IEEESPCeil
	pea	CeilEnd(PC)			; Ceil return routine
	bchg	#$1F,D0
IEEESPFloor
	move.l	D0,D1
	beq.b	QUICKZ
	swap	D1
	and.w	#$7F80,D1
	beq.b	nearzero
	lsr.w	#7,D1			; 15th bit is zero
	sub.w	#$7F,D1
	blt.b	nearzero
	cmp.w	#$17-1,D1		; skip and.l #$FFFFFFFF,D0
	bge.b	QUICKZ			; D0 is set already
	move.l	D0,A1			; backup
	lsl.w	#2,D1
	and.l	InvertedTable(PC,D1.W),D0
	bge.b	QUICKZ
	cmp.l	D0,A1
	beq.b	QUICKZ
	move.l	#$BF800000,D1
	jmp	-$42(A6)			; IEEESPAdd

	cnop	0,4	; table must be longword aligned for better speed

InvertedTable
	dc.l	$FF800000
	dc.l	$FFC00000
	dc.l	$FFE00000
	dc.l	$FFF00000
	dc.l	$FFF80000
	dc.l	$FFFC0000
	dc.l	$FFFE0000
	dc.l	$FFFF0000
	dc.l	$FFFF8000
	dc.l	$FFFFC000
	dc.l	$FFFFE000
	dc.l	$FFFFF000
	dc.l	$FFFFF800
	dc.l	$FFFFFC00
	dc.l	$FFFFFE00
	dc.l	$FFFFFF00
	dc.l	$FFFFFF80
	dc.l	$FFFFFFC0
	dc.l	$FFFFFFE0
	dc.l	$FFFFFFF0
	dc.l	$FFFFFFF8
	dc.l	$FFFFFFFC
	dc.l	$FFFFFFFE

IEEESPAbs
	bclr	#$1F,D0
	rts

IEEESPNeg
	bchg	#$1F,D0
	rts

;   FUNCTION
;	Compare y with z. Set the condition codes for less, greater, or
;	equal. Set return value c to -1 if y<z, or +1 if y>z, or 0 if
;	y == z.

;   INPUTS
;	y -- IEEE single precision floating point value
;	z -- IEEE single precision floating point value

;   RESULT
;       c = 1   cc = gt         for (y > z)
;       c = 0   cc = eq         for (y == z)
;       c = -1  cc = lt         for (y < z)

IEEESPCmp
	tst.l	D0
	bmi.b	SPCmpMin0
	tst.l	D1
	bmi.b	SPCmpMin1
	exg	D1,D0
SPCmpBack
	cmp.l	D0,D1
	bgt.b	SPPlus1
	blt.b	SPMinus1
SPZero
	moveq	#0,D0
	rts

SPCmpMin1
	tst.l	D0
	bne.b	SPPlus1
	add.l	D1,D1
	beq.b	SPZero
SPPlus1
	moveq	#1,D0
	rts

SPCmpMin0
	tst.l	D1
	bmi.b	SPCmpBack
	bne.b	SPMinus1
	add.l	D0,D0
	beq.b	SPQuit
SPMinus1
	moveq	#-1,D0
SPQuit
	rts

IEEESPTst
	add.l	D0,D0
	bcs.b	SPMinus1
	bne.b	SPPlus1
	rts


; input D0
; output D0
;	Convert IEEE single precision argument to a 32 bit signed integer
;	and return result.
; final version

IEEESPFix
	move.l	D2,A0
	moveq	#-1,D2
	lsr.l	#1,D2
	move.l	D0,D1
	bpl.b	PlusSPF
	addq.l	#1,D2
	eor.l	D2,D0
PlusSPF
	exg	D2,A0			; restore D2

	SWAP	D0
	MOVE.W	D0,D1
	AND.W	#$7F80,D1
	EOR.W	D1,D0
	SUB.W	#$3F80,D1
	blt.b	ZeroSPF
	EORI.W	#$80,D0
	SWAP	D0
	ASR.W	#7,D1
	SUB.W	#$17,D1
	BGT.B	GreatSPF
	NEG.W	D1
	LSR.L	D1,D0
TestSPF
	TST.L	D1
	BPL.B	QuitSPF
	NEG.L	D0
QuitSPF
	rts

BackSPF
	CMP.W	#$69,D1
	BLT.B	SetSPF
	TST.L	D0
	BEQ.B	SetSPF
ZeroSPF
	moveq	#0,D0
	rts

GreatSPF
	CMP.W	#8,D1
	BGT.B	BackSPF
	LSL.L	D1,D0
	cmp.l	A0,D0
	bls.b	TestSPF
SetSPF
	move.l	A0,D0
lbC0444CC
	rts

; input D0
; output D0
;	Convert a signed 32 bit value to a single precision IEEE value
;	and return it in d0. No exceptions can occur with this
;	function.
; final version

IEEESPFlt	MOVE.L	D0,D1
	BEQ.B	lbC0444CC
	BPL.B	lbC0444D6
	NEG.L	D0
lbC0444D6	CMP.L	#$1000000,D0
	BCS.B	lbC044524
	MOVE.W	#$4A80,D1
	CMP.L	#$8000000,D0
	BCS.B	lbC0444F0
	ADD.W	#$200,D1
	LSR.L	#4,D0
lbC0444F0	CMP.L	#$2000000,D0
	BCS.B	lbC0444FE
	ADD.W	#$100,D1
	LSR.L	#2,D0
lbC0444FE	CMP.L	#$1000000,D0
	BCS.B	lbC04450C
	ADD.W	#$80,D1
	LSR.L	#1,D0
lbC04450C	MOVEA.L	D1,A0
	MOVEQ	#0,D1
	ADDX.L	D1,D0
	MOVE.L	A0,D1
	SWAP	D0
	ADD.W	D1,D0
	SWAP	D1
	AND.W	#$8000,D1
	EOR.W	D1,D0
	SWAP	D0
	RTS

lbC044524	MOVE.W	#$4B00,D1
	CMP.L	#$100,D0
	BGE.B	lbC044536
	SUB.W	#$800,D1
	BRA.B	lbC044542

lbC044536	SWAP	D0
	TST.W	D0
	BNE.B	lbC044542
	ROL.L	#8,D0
	SUB.W	#$400,D1
lbC044542	CMP.W	#$10,D0
	BGE.B	lbC04454E
	ROL.L	#4,D0
	SUB.W	#$200,D1
lbC04454E	CMP.W	#$40,D0
	BGE.B	lbC04455A
	ROL.L	#2,D0
	SUB.W	#$100,D1
lbC04455A	TST.B	D0
	BMI.B	lbC044564
	ROL.L	#1,D0
	SUB.W	#$80,D1
lbC044564	EORI.W	#$80,D0
	ROL.L	#1,D1
	ROR.W	#1,D1
	OR.W	D1,D0
	SWAP	D0
	RTS

; input D0,D1
; output D0
;	Compute x = y * z in IEEE single precision.

SPMul_1
	move.l	D1,D0
SPMul_2
	bclr	#6,D0
	beq.b	SPMul_4
	bset	#4,D0
SPMul_4
	or.w	#$7F88,D0
	swap	D0
	move.l	(SP)+,D2
	move.l	A0,D6
	move.l	A1,D7
	rts

SPDiv_1
	moveq	#7,D2
	or.w	D1,D2
	sub.w	D0,D2
	and.w	#$FFF8,D2
	bgt.b	SPDiv_2
	cmp.l	#$7F80,D0
	bne.b	SPMul_2
	cmp.w	D7,D1
	blt.b	SPMul_6
	cmp.l	#$7F80,D1
	beq.b	SPMul_5
SPDiv_2
	move.l	D1,D0
	bra.b	SPMul_2

SPMul_A
	moveq	#7,D2
	or.w	D1,D2
	sub.w	D0,D2
	and.w	#$FFF8,D2
	bgt.b	SPMul_1
	cmp.l	#$7F80,D0
	bne.b	SPMul_2
	cmp.w	D7,D1
	blt.b	SPMul_3
	cmp.l	#$7F80,D1
	bne.b	SPMul_1
SPMul_3
	tst.l	D1
	bne.b	SPMul_6
SPMul_5
	move.l	#$7F880000,D0
	move.l	(SP)+,D2
	move.l	A0,D6
	move.l	A1,D7
	rts

SPMul_B
	cmp.l	#$7F80,D1
	bne.b	SPMul_1
	tst.l	D0
	beq.b	SPMul_5
SPMul_6
	move.l	D6,D0
	and.l	#$80000000,D0
	eor.l	#$7F800000,D0
	move.l	(SP)+,D2
	move.l	A0,D6
	move.l	A1,D7
	rts

IEEESPMul
	move.l	D2,-(SP)
	move.l	D6,A0
	move.l	D7,A1
	MOVE.L	D0,D6
	EOR.L	D1,D6
	MOVE.W	#$7F80,D7
	SWAP	D0
	AND.W	#$7FFF,D0
	SWAP	D1
	AND.W	#$7FFF,D1
	CMP.W	D7,D0
	BGE.B	SPMul_A
	CMP.W	D7,D1
	BGE.B	SPMul_B
	MOVE.W	D0,D6
	AND.W	D7,D6
	BEQ.B	SPMul_C
	EOR.W	D6,D0
	EOR.B	D7,D0
SPMul_7
	AND.W	D1,D7
	BEQ.B	SPMul_D
	EOR.W	D7,D1
	OR.W	#$80,D1
SPMul_8
	SUB.W	#$3F80,D6
	ADD.W	D7,D6
	BVS.B	SPMul_6
	SWAP	D0
	LSL.L	#7,D0
	SWAP	D1
	LSL.L	#7,D1

	tst.b	$22(A6)			; CPU test
	bne.b	Mul020

	MOVE.W	D0,D7
	MOVE.W	D1,D2
	MULU.W	D2,D7
	CLR.W	D7
	SWAP	D7
	SWAP	D0
	MULU.W	D0,D2
	ADD.L	D2,D7
	SWAP	D1
	SWAP	D0
	MOVE.L	D0,D2
	MULU.W	D1,D2
	ADD.L	D2,D7
	SWAP	D0
	MULU.W	D1,D0
	CLR.W	D7
	SWAP	D7
	ADD.L	D7,D0
	bra.b	SPMulDiv_Fin

SPMul_C
	tst.l	D0
	beq.b	SPMul_9
	bsr.w	SPMulDiv
	bra.b	SPMul_7

SPMul_D
	tst.l	D1
	beq.b	SPMul_9
	exg	D0,D1
	exg	D6,D7
	bsr.b	SPMulDiv
	exg	D0,D1
	exg	D6,D7
	bra.b	SPMul_8

SPAdd_A
	and.l	D7,D6
SPMul_9
	move.l	D6,D0
	and.l	#$80000000,D0
	move.l	(SP)+,D2
	move.l	A0,D6
	move.l	A1,D7
	rts

Mul020
	mulu.l	D1,D7:D0		; 68020/030/040 command
	move.l	D7,D0
SPMulDiv_Fin
	BTST	#$1D,D0
	BNE.B	SPMD_1
	SUB.W	#$80,D6
	BLT.B	SPMD_2
SPMD_3	MOVEQ	#$10,D1
	ADD.L	D1,D0
	LSR.L	#5,D0
	SWAP	D0
	ADD.W	D6,D0
	CMP.W	#$7F80,D0
	BGE.w	SPMul_6
	SWAP	D6
	AND.W	#$8000,D6
	EOR.W	D6,D0
	SWAP	D0
	move.l	(SP)+,D2
	move.l	A0,D6
	move.l	A1,D7
	rts

SPMD_1
	LSR.L	#1,D0
	TST.W	D6
	BGE.B	SPMD_3
SPMD_2
	NEG.W	D6
	LSR.W	#7,D6
	ADDQ.W	#5,D6
	CMP.W	#$1E,D6
	bge.b	SPMul_9
	SUBQ.L	#1,D6
	LSR.L	D6,D0
	MOVEQ	#0,D7
	ADDX.L	D7,D0
	LSR.L	#1,D0
	AND.L	#$80000000,D6
	EOR.L	D6,D0
	move.l	(SP)+,D2
	move.l	A0,D6
	move.l	A1,D7
	rts

SPMulDiv
	SWAP	D0
	MOVE.W	#$80,D6
	CMP.L	#$100,D0
	BGE.B	lbC0443C4
	SUB.W	#$800,D6
	BRA.B	lbC0443D0

lbC0443C4	SWAP	D0
	TST.W	D0
	BNE.B	lbC0443D0
	ROL.L	#8,D0
	SUB.W	#$400,D6
lbC0443D0	CMP.W	#$10,D0
	BGE.B	lbC0443DC
	ROL.L	#4,D0
	SUB.W	#$200,D6
lbC0443DC	CMP.W	#$40,D0
	BGE.B	lbC0443E8
	ROL.L	#2,D0
	SUB.W	#$100,D6
lbC0443E8	TST.B	D0
	BMI.B	lbC0443F2
	ROL.L	#1,D0
	SUB.W	#$80,D6
lbC0443F2	RTS

; input D0,D1
; output D0
;	Compute x = y / z in IEEE single precision.
;	Note that the Motorola fast floating point Div routine reverses
;	the order of the arguments for the C interface, although the
;	dividend is still in d0 and the divisor is in d1.

IEEESPDiv
	move.l	D2,-(SP)
	move.l	D6,A0
	move.l	D7,A1
	MOVE.L	D0,D6
	EOR.L	D1,D6
	MOVE.W	#$7F80,D7
	SWAP	D0
	AND.W	#$7FFF,D0
	SWAP	D1
	AND.W	#$7FFF,D1
	CMP.W	D7,D0
	Bge.w	SPDiv_1

	CMP.W	D7,D1
	BLT.B	SPDiv_3
	CMP.L	#$7F80,D1
	BEQ.w	SPMul_9
	MOVE.L	D1,D0
	BRA.W	SPMul_2	


SPDiv_3	MOVE.W	D0,D6
	AND.W	D7,D6
	BNE.B	SPDiv_4
	TST.L	D0
	BNE.B	SPDiv_5
	TST.L	D1
	BNE.w	SPMul_9
	BRA.W	SPMul_5


SPDiv_5	BSR.W	SPMulDiv
	BRA.B	lbC04408C

SPDiv_4	EOR.W	D6,D0
	EORI.W	#$80,D0
lbC04408C	AND.W	D1,D7
	BNE.B	lbC0440A4
	TST.L	D1
	BEq.w	SPMul_6
	EXG	D0,D1
	EXG	D6,D7
	BSR.W	SPMulDiv
	EXG	D0,D1
	EXG	D6,D7
	BRA.B	lbC0440AA

lbC0440A4	EOR.W	D7,D1
	EORI.W	#$80,D1
lbC0440AA
	SUB.W	#$3F00,D7
	SUB.W	D7,D6
	BVS.W	SPMul_6
	SWAP	D0
	LSL.L	#5,D0
	SWAP	D1
	LSL.L	#8,D1

	tst.b	$22(A6)			; CPU test
	bne.b	Div020
	moveq	#-1,D2			; set high word as -1

	SWAP	D1
	DIVU.W	D1,D0
	MOVE.W	D0,D2
	CLR.W	D0
	SWAP	D1
	MOVE.W	D1,D7
	MULU.W	D2,D7
	SUB.L	D7,D0
	BCC.B	lbC0440D2
	SUBQ.W	#1,D2
	ADD.L	D1,D0
lbC0440D2	SWAP	D2
	SWAP	D1
	MOVE.L	D0,D7
	DIVU.W	D1,D0
	bvs.b	lbC0440F2
	MOVE.W	D0,D2
	CLR.W	D0
	SWAP	D1
	MOVE.W	D1,D7
	MULU.W	D2,D7
	SUB.L	D7,D0
	BCC.B	lbC0440F2
	SUBQ.L	#1,D2
lbC0440F2	MOVE.L	D2,D0
	BRA.W	SPMulDiv_Fin

Div020
	MOVE.L	D0,D7
	MOVEQ	#0,D0
	DIVU.L	D1,D7:D0		; 68020/030/040 command
	BRA.W	SPMulDiv_Fin

; input D0,D1
; output D0
;	Compute x = y - z in IEEE single precision.
;	Compute x = y + z in IEEE single precision.

IEEESPSub
	BCHG	#$1F,D1
IEEESPAdd
	MOVE.l	D2,-(SP)
	MOVEA.L	D6,A0
	MOVEA.L	D7,A1
	MOVE.W	#$80,D2
	MOVE.L	D0,D6
	MOVE.L	D1,D7
	MOVE.W	#$7F80,D7
	SWAP	D0
	AND.W	#$7FFF,D0
	MOVE.W	D0,D6
	AND.W	D7,D6
	EOR.W	D6,D0
	SWAP	D1
	AND.W	#$7FFF,D1
	AND.W	D1,D7
	EOR.W	D7,D1
	CMP.W	D7,D6
	BNE.W	SPAdd_1
	CMP.W	#$7F80,D6
	BNE.B	SPAdd_2
	MOVE.W	D1,D7
	OR.W	#7,D7
	SUB.W	D0,D7
	AND.W	#$FFF8,D7
	BGT.w	SPMul_1
	TST.L	D0
	BNE.w	SPMul_2
	TST.L	D1
	Bne.w	SPMul_1
	EOR.L	D6,D7
	BPL.w	SPMul_6
	BMI.w	SPMul_5
SPAdd_2
	TST.W	D6
	BNE.B	SPAdd_3
	SWAP	D0
	BNE.B	SPAdd_4
	SWAP	D1
	Beq.w	SPAdd_A
	CLR.W	D7
	OR.L	D7,D1
	MOVE.L	D1,D0
	BRA.B	SPAdd_6


SPAdd_4	SWAP	D1
	BEQ.B	SPAdd_5
	ADD.L	D0,D0
	ADD.L	D1,D1
	BRA.B	SPAdd_7

SPAdd_3	EOR.B	D2,D0
	EOR.B	D2,D1
	SWAP	D0
	SWAP	D1
SPAdd_7	EOR.L	D6,D7
	Bmi.w	SPAdd_B

	ADD.L	D1,D0
	BTST	#$18,D0
	BEQ.W	lbC044362
	ADDQ.L	#1,D0
	LSR.L	#1,D0
	ADD.W	D2,D6
	CMP.W	#$7F80,D6
	BLT.W	lbC044362
	bra.w	SPMul_6


lbC0442E2	TST.L	D0
	BNE.w	SPMul_2
	BRA.w	SPMul_6

lbC0442D4	SWAP	D1
	BNE.B	lbC0442E8
	SWAP	D0
SPAdd_5
	CLR.W	D6
	OR.L	D6,D0
SPAdd_6
	MOVE.l	(SP)+,D2
	MOVE.L	A0,D6
	MOVE.L	A1,D7
	RTS


lbC0442E8	ADD.L	D1,D1
	BRA.B	lbC044308


SPAdd_1	BGT.B	lbC0442FA
	EXG	D0,D1
	EXG	D6,D7
lbC0442FA	CMP.W	#$7F80,D6
	BEQ.B	lbC0442E2
	TST.W	D7
	BEQ.B	lbC0442D4
	EOR.B	D2,D1
	SWAP	D1
lbC044308	EOR.B	D2,D0
	SWAP	D0
	SUB.W	D2,D6
	SUB.W	D6,D7
	NEG.W	D7
	LSR.W	#7,D7
	CMP.W	#$18,D7
	BGT.B	lbC0442F0
	ADD.L	D0,D0
	LSR.L	D7,D1
	EOR.L	D6,D7
	BMI.B	lbC044386
	ADD.L	D1,D0
	ADDQ.L	#1,D0
	BTST	#$19,D0
	BNE.B	lbC044354
	LSR.L	#1,D0
lbC0442F0
	ADD.W	D2,D6
	Bne.B	SPAdd_9
	ADDQ.L	#1,D0
	ADD.L	D6,D6
	ROXR.L	#1,D0
	MOVE.l	(SP)+,D2
	MOVE.L	A0,D6
	MOVE.L	A1,D7
	RTS

lbC044354	ADDQ.L	#1,D0
	LSR.L	#2,D0
	ADD.W	#$100,D6
	CMP.W	#$7F80,D6
	BGE.w	SPMul_6
lbC044362	TST.W	D6
	BEQ.B	lbC044346
SPAdd_9
	SWAP	D0
	EOR.B	D2,D0
	ROL.L	#1,D6
	ROR.W	#1,D6
	OR.W	D6,D0
	SWAP	D0
	MOVE.l	(SP)+,D2
	MOVE.L	A0,D6
	MOVE.L	A1,D7
	RTS

lbC044386	SUBX.L	D7,D7
	SUBX.L	D1,D0
	BTST	#$18,D0
	BEQ.b	lbC044450
	SUB.L	D7,D0
	LSR.L	#1,D0
	ADD.W	D2,D6
	Bne.B	SPAdd_9
	ADDQ.L	#1,D0
	ADD.L	D6,D6
	ROXR.L	#1,D0
	MOVE.l	(SP)+,D2
	MOVE.L	A0,D6
	MOVE.L	A1,D7
	RTS

lbC0444BA	SWAP	D0
lbC044346	ADDQ.L	#1,D0
	ADD.L	D6,D6
	ROXR.L	#1,D0
SPAdd_8
	MOVE.l	(SP)+,D2
	MOVE.L	A0,D6
	MOVE.L	A1,D7
	RTS

lbC044290	NEG.L	D0
	BCHG	#$1F,D6
	bra.b	lbC044450

SPAdd_B
	SUB.L	D1,D0
	BMI.B	lbC044290
	Beq.b	SPAdd_8

lbC044450	CMP.L	#$100,D0
	BGE.B	lbC04445E
	SUB.W	#$800,D6
	BRA.B	lbC04446A

lbC04445E	SWAP	D0
	TST.W	D0
	BNE.B	lbC04446A
	ROL.L	#8,D0
	SUB.W	#$400,D6
lbC04446A	CMP.W	#$10,D0
	BGE.B	lbC044476
	ROL.L	#4,D0
	SUB.W	#$200,D6
lbC044476	CMP.W	#$40,D0
	BGE.B	lbC044482
	ROL.L	#2,D0
	SUB.W	#$100,D6
lbC044482	TST.B	D0
	BMI.B	lbC04448A
	ROL.L	#1,D0
	SUB.W	D2,D6
lbC04448A
	TST.W	D6
	BGT.B	lbC0444A8
	BEQ.B	lbC0444BA
	SWAP	D0
	NEG.W	D6
	LSR.W	#7,D6
	LSR.L	D6,D0
	ADD.L	D6,D6
	ROXR.L	#1,D0
	MOVEQ	#0,D1
	ADDX.L	D1,D0
	MOVE.l	(SP)+,D2
	MOVE.L	A0,D6
	MOVE.L	A1,D7
	RTS

lbC0444A8	EOR.W	D2,D0
	ROL.L	#1,D6
	ROR.W	#1,D6
	OR.W	D6,D0
	SWAP	D0
	MOVE.l	(SP)+,D2
	MOVE.L	A0,D6
	MOVE.L	A1,D7
	RTS

mathieeesingb.MSG	dc.b	'mathieeesingbas.library',0
mathieeesingb.MSG0	dc.b	'mathieeesingbas 41.1 (8.6.2014)',$D,$A,0
	cnop	0,4
EndSkip
