; Resourced version of utility.library (40.1) from Amiga ROM 3.1 for Amiga68k ROM 1.0
; For easy recognition all changes are done using lower cases and ";" signs
; Original code is removed with ";" signs
; New code is added using lower cases only

; Originally written by:
; vertex
; mks (Michael Sinz)
; jesup (Randell Jesup)
; peter (Peter Cherna)
; jimm (Jim Mackraz)
; rsbx

; We made it...
; OS Group: Bryce Nesbitt, Michael Sinz, Peter Cherna, Darren Greenwald, Randell Jesup, Jerry Horanoff
; GFX: Allan Havemose, Barry 'Bart' Whitebook, Spence Shanson, Steve Beats, Chris Green, Ray Brand, Jim Barkley
; Special Projects: Eric Cotton, Martin Hunt, Bill Koester, Martin Taillefer, Brian Jackson, Kaori Kuwata, David Junod, Palmyra Pawlik, Kevin Klop
; NET: Brian Jackson, Greg Miller, Kenneth Dyke
; GUI: Peter Cherna, Martin Taillefer, David Junod, Kaori Kuwata
; Others: Andy Finkel, Dale 'Duck' Luck, Jim 'Jimm' Mackraz, Bob 'Kodiak' Burns, Jeff Porter, Carolyn Scheppner, David Haynie,
; Lauren Brown, CATS (Commodore Amiga Technical Support), QA (Quality Assurance), SA (Software Assurance)
; Thanks to: Bill Hawes, Software Distillery (Dave Baker, Ed Burnette, Stan Chow,
; Alan Beale, Bruce Drake, Andy Mercier, Mary Ellen Toebes, Jim Cooper, Mike Witcher,
; Jay Denebeim, John Mainwaring, Gordon Keener, Jack Rouse, John Toebes, Doug Walker)
; Better than ever.

ROMTAG
	ILLEGAL				; match word
	dc.l	ROMTAG			; match tag
	dc.l	EndSkip			; end skip
	dc.b	$81			; Flags -> RTF_AUTOINIT!RTF_COLDSTART
	dc.b	$28+1			; version
	dc.b	9			; type -> NT_LIBRARY
	dc.b	$67			; priority
	dc.l	LibName			; name
	dc.l	LibId			; id string
	dc.l	LibInitTable		; init
LibInitTable
	dc.l	$30			; UtilityLib_SIZEOF
	dc.l	LibFuncTable
	dc.l	0
	dc.l	LibInit
LibFuncTable
	dc.w	$FFFF
	dc.w	LibOpen-LibFuncTable			; * -6
	dc.w	LibClose-LibFuncTable			; * -12
	dc.w	LibExpunge-LibFuncTable			; * -18
	dc.w	LibReserved-LibFuncTable		; * -24
	dc.w	FindTagItem-LibFuncTable		; * -30
	dc.w	GetTagData-LibFuncTable			; * -36
	dc.w	PackBoolTags-LibFuncTable		; * -42
	dc.w	NextTagItem-LibFuncTable		; * -48
	dc.w	FilterTagChanges-LibFuncTable		; * -54
	dc.w	MapTags-LibFuncTable			; * -60
	dc.w	AllocateTagItems-LibFuncTable		; * -66
	dc.w	CloneTagItems-LibFuncTable		; * -72
	dc.w	FreeTagItems-LibFuncTable		; * -78
	dc.w	RefreshTagItemClones-LibFuncTable	; * -84
	dc.w	TagInArray-LibFuncTable			; * -90
	dc.w	FilterTagItems-LibFuncTable		; * -96
	dc.w	CallHookPkt-LibFuncTable		; * -102
	dc.w	LibReserved-LibFuncTable		; * -108
	dc.w	LibReserved-LibFuncTable		; * -114
	dc.w	Amiga2Date-LibFuncTable			; * -120
	dc.w	Date2Amiga-LibFuncTable			; * -126
	dc.w	CheckDate-LibFuncTable			; * -132
	dc.w	UMult32S-LibFuncTable			; * -138
	dc.w	UMult32S-LibFuncTable			; * -144
	dc.w	SDivMod32S-LibFuncTable			; * -150
	dc.w	UDivMod32S-LibFuncTable			; * -156
	dc.w	Stricmp-LibFuncTable			; * -162
	dc.w	Strnicmp-LibFuncTable			; * -168
	dc.w	ToUpper-LibFuncTable			; * -174
	dc.w	ToLower-LibFuncTable			; * -180
	dc.w	ApplyTagChanges-LibFuncTable		; * -186
	dc.w	LibReserved-LibFuncTable		; * -192 for MergeTagItems
	dc.w	SMult64S-LibFuncTable			; * -198
	dc.w	UMult64S-LibFuncTable			; * -204
	dc.w	PackStructureTags-LibFuncTable		; * -210
	dc.w	UnpackStructureTags-LibFuncTable	; * -216
; NameSpace functions!
	dc.w	AddNamedObject-LibFuncTable		; * -222
	dc.w	AllocNamedObjectA-LibFuncTable		; * -228
	dc.w	AttemptRemNamedObject-LibFuncTable	; * -234
	dc.w	FindNamedObject-LibFuncTable		; * -240
	dc.w	FreeNamedObject-LibFuncTable		; * -246
	dc.w	NamedObjectName-LibFuncTable		; * -252
	dc.w	ReleaseNamedObject-LibFuncTable		; * -258
	dc.w	RemNamedObject-LibFuncTable		; * -264
; Unique sequence number routine...
	dc.w	GetUniqueID-LibFuncTable		; * -270
; empty functions for setpatch!
	dc.w	LibReserved-LibFuncTable		; * -276
	dc.w	LibReserved-LibFuncTable		; * -282
	dc.w	LibReserved-LibFuncTable		; * -288
	dc.w	LibReserved-LibFuncTable		; * -294
	dc.w	$FFFF

	cnop	0,4

; code moved

SMult32H:
	muls.l	d1,d0
	rts

;---------------------------------------------------------------------------

UMult32H:
	mulu.l	d1,d0
	rts

;---------------------------------------------------------------------------

SDivMod32H:
	divsl.l	d1,d1:d0
	rts

;---------------------------------------------------------------------------

UDivMod32H:
	divul.l	d1,d1:d0
	rts

;---------------------------------------------------------------------------

SMult64H:
	muls.l	d1,d1:d0
	rts


;---------------------------------------------------------------------------

UMult64H:
	mulu.l	d1,d1:d0
	rts

;---------------------------------------------------------------------------

FunctionMap
	dc.w	$FF76		; -138
	dc.l	SMult32H
	dc.w	$FF70		; -144
	dc.l	UMult32H
	dc.w	$FF6A		; -150
	dc.l	SDivMod32H
	dc.w	$FF64		; -156
	dc.l	UDivMod32H
	dc.w	$FF3A		; -198
	dc.l	SMult64H
	dc.w	$FF34		; -204
	dc.l	UMult64H

;-----------------------------------------------------------------------

; Library Init entry point called when library is first loaded in memory
; On entry, D0 points to library base, A0 has lib seglist, A6 has SysBase
; Returns 0 for failure or the library base for success.

LibInit
	movem.l	D0/D2/A0-A3,-(SP)
	move.l	D0,A3
	move.l	A6,$24(A3)		; SysBase
;	move.w	#1,$16(A3)		; lib_revision

	clr.w	$16(A3)
	lea	NullS(PC),A0		; Null string...
	lea	MyTags(PC),A1		; My tags...
	exg	A6,A3			; Our library now...
;	jsr	-$E4(A6)		; Create the root namespace...

	bsr.w	AllocNamedObjectA
	move.l	D0,$28(A6)		; Store it (MasterSpace)
	exg	A6,A3			; Back to normal

; replace the 68000 math functions by the 68060 versions

	moveq	#1,D2
	moveq	#-114,D0		; AFF_68020!AFF_68030!AFF_68040!AFF_68060
	and.b	$128+1(A6),D0		; AttnFlags

;	move.w	$128(A6),D0		; AttnFlags
;	and.w	#14,D0			; AFF_68020!AFF_68030!AFF_68040
	beq.b	FMQuit
	bmi.b	FM060

; replace the 68000 math functions by the 68020 versions

	moveq	#5,D2
FM060
	lea	FunctionMap(PC),A2
FMLoop
	move.l	A3,A1			; load UtilityBase
	move.w	(A2)+,A0		; load a function offset
	move.l	(A2)+,D0		; load a the replacement function POINTER
	jsr	-$1A4(A6)		; do the magic
	dbf	D2,FMLoop		; next one please...
FMQuit
	movem.l	(SP)+,D0/D2/A0-A3
	rts

;-----------------------------------------------------------------------

; Library open entry point called every OpenLibrary()
; On entry, A6 has UtilityBase, task switching is disabled
; Returns 0 for failure, or UtilityBase for success.

LibOpen
	addq.w	#1,$20(A6)		; LIB_OPENCNT
	move.l	A6,D0
	rts

MyTags	dc.l	$FA0			; ANO_NameSpace
	dc.l	1
NullS	dc.l	0

******* utility.library/GetUniqueID *******************************************
*
*   NAME
*	GetUniqueID -- return a relatively unique number. (V39)
*
*   SYNOPSIS
*	id = GetUniqueID();
*	D0
*
*	ULONG GetUniqueID(VOID);
*
*   FUNCTION
*	Returns a unique value each time it is called. This is useful for
*	things that need unique ID such as the GadgetHelp ID, etc.
*	Note that this is only unique for 4,294,967,295 calls to this
*	function. Under normal use this is not a problem.
*	This function is safe in interrupts.
*
*   RESULT
*	id - a 32-bit value that is unique.
*
*******************************************************************************

GetUniqueID
	move.l	$24(A6),A0		; Get execbase...
	move.w	#$4000,$DFF09A		; Disable for a moment...
	addq.b	#1,$126(A0)
	addq.l	#1,$2C(A6)		; Do the bump... (ub_Sequence)
	move.l	$2C(A6),D0		; Get the long...
	subq.b	#1,$126(A0)		; Enable again...
	bge.b	SkipGUI
	move.w	#$C000,$DFF09A
SkipGUI
	rts				; return...

;	dc.w	0

;---------------------------------------------------------------------------

;	tagList = AllocateTagItems( numItems )
;	D0		            D0
;
;	struct TagItem *AllocateTagItems( ULONG numItems);

AllocateTagItems
;	ASL.L	#3,D0			; numitems * sizeof(struct TagItem)

	lsl.l	#3,D0			; numitems * sizeof(struct TagItem)
	move.l	#$10001,D1		; memory requirements
	move.l	A6,-(SP)		; save UtilityBase
	move.l	$24(A6),A6		; load ExecBase
	jsr	-$2AC(A6)		; allocate the memory (AllocVec)
	move.l	(SP)+,A6		; restore UtilityBase
	rts				; bye

;---------------------------------------------------------------------------

;	FreeTagItems( tagList )
;			A0
;
;	void FreeTagItems( struct TagItem *tagList );

FreeTagItems
	move.l	A0,A1			; tag list in a1
	move.l	A6,-(SP)		; save UtilityBase
	move.l	$24(A6),A6		; load ExecBase
	jsr	-$2B2(A6)		; free the memory (FreeVec)
	move.l	(SP)+,A6		; restore UtilityBase
	rts

;---------------------------------------------------------------------------

;	RefreshTagItemClones( cloneTagItems, originalTagItems )
;			      A0	     A1
;
;	void RefreshTagItemClones( struct TagItem *cloneTagItems,
;				  struct TagItem *originalTagItems );

RefreshTagItemClones
	move.l	A2,-(SP)	; save this guy
	move.l	A0,A2		; point to first tag in clone's list
	move.l	A1,-(SP)	; save original's list pointer on stack
	move.l	SP,A0		; where the list pointer is
RTICLoop
	bsr.b	NextTagItem	; get next tag available (CCR is set)
	beq.b	RTICExit	; no more tags so split
	move.l	D0,A1		; tag pointer in a1
	move.l	(A1)+,(A2)+	; copy the tag!
	move.l	(A1),(A2)+	; copy the data!
	bra.b	RTICLoop	; do next one

RTICExit
	clr.l	(A2)		; set last tag's ti_Tag to TAG_DONE
	addq.l	#4,SP		; remove list pointer from stack
	move.l	(SP)+,A2	; hi guy
	rts

;---------------------------------------------------------------------------

;	newTagList = CloneTagItems( tagList )
;	D0			    A0
;
;	struct TagItem *CloneTagItems( struct TagItem *tagList );


;CloneTagItems
;	MOVE.L	D2,-(SP)	; save this guy
;	MOVE.L	A0,-(SP)	; save list pointer on stack
;	MOVE.L	A0,-(SP)	; save list pointer on stack
;	MOVEQ	#0,D2		; initialize counter
;lbC000240
;	ADDQ.L	#1,D2		; count an item
;	MOVEA.L	SP,A0		; where the list pointer is
;	JSR	(-$30,A6)	; get next tag available (NextTagItem)
;	TST.L	D0		; did we get something?
;	BNE.B	lbC000240	; if so, keep looping
;	MOVE.L	D2,D0		; number of items to allocate
;	JSR	(-$42,A6)	; AllocateTagItems
;	TST.L	D0		; did it work?
;	BEQ.B	lbC000264
;	MOVE.L	D0,D2		; new tag list in d2
;	MOVEA.L	D0,A0		; new tag list in a0
;	MOVEA.L	(4,SP),A1	; old tag list in a1
;	JSR	(-$54,A6)	; RefreshTagItemClones
;	MOVE.L	D2,D0		; return new tag list
;lbC000264
;	ADDQ.L	#8,SP		; remove list pointers from stack
;	MOVE.L	(SP)+,D2	; good to see you back!
;	RTS

CloneTagItems
	movem.l	A0/A2/A6,-(SP)	; save list pointer on stack
	move.l	A0,A2		; backup
	moveq	#0,D1		; initialize counter
	move.l	$24(A6),A0	; Get ExecBase
	addq.b	#1,$127(A0)	; Protect this... (Forbid)
CTILoop
	addq.l	#1,D1		; count an item
	move.l	SP,A0		; where the list pointer is
	bsr.b	NextTagItem	; get next tag available (CCR is set)
	bne.b	CTILoop		; if so, keep looping
	move.l	D1,D0		; number of items to allocate
	bsr.b	AllocateTagItems	; AllocateTagItems
	move.l	D0,(SP)		; did it work?
	beq.b	CTIExit
	move.l	D0,A0		; new tag list in a0
	move.l	A2,A1		; old tag list in a1
	bsr.b	RefreshTagItemClones	; RefreshTagItemClones
CTIExit
	move.l	$24(A6),A6	; Get ExecBase
	jsr	-$8A(A6)	; Permit
	movem.l	(SP)+,D0/A2/A6	; return new tag list
	rts

;---------------------------------------------------------------------------

;	next_tag = NextTagItem( tagItemPtr )
;	D0			A0
;
;	struct TagItem *NextTagItem( struct TagItem **tagItemPtr );

;NextTagItem
;	MOVE.L	(A0),D0		; load address of first tag
;	BEQ.B	lbC0001AC	; if 0, then we didn't find anything this time
;lbC000170
;	MOVEA.L	D0,A1		; load address of current tag
;	MOVE.L	(A1),D1		; load the tag type
;	BMI.B	lbC0001A2	; if bit 31 is set then this is a user tag, so we got our man!
;	BEQ.B	lbC0001A8	; if it is 0, then its TAG_DONE so exit
;	CMP.L	#3,D1		; second-level check
;	BHI.B	lbC0001A2	; if greater than TAG_SKIP, then its a user tag
;	ADD.B	D1,D1		; calculate index into jump table
;	JMP	(lbC000186,PC,D1.W)	; evil ASM jump table!

;lbC000186
;	BRA.B	lbC0001A8	; never called, but used to keep the jump table happy

;	BRA.B	lbC000194

;	BRA.B	lbC000198

;	bra.s	NTITagSkip	; ** sneaky, last entry in jump table is the actual code!

;	MOVE.L	(4,A1),D1	; # of tags to skip
;	ASL.L	#3,D1		; convert # of tags into total byte size
;	ADD.L	D1,D0		; skip all these bytes
;lbC000194	ADDQ.L	#8,D0	; load address of next tag
;	BRA.B	lbC000170	; try again

;lbC000198
;	MOVE.L	(4,A1),D0	; go to a new tag list
;	BNE.B	lbC000170	; if more tags, loop back
;	MOVE.L	D0,(A0)		; no more tags, so leave
;	RTS

;lbC0001A2
;	ADDQ.L	#8,A1		; address of next tag
;	MOVE.L	A1,(A0)		; store it in the "next tag" pointer
;	RTS

;lbC0001A8	MOVEQ	#0,D0	; nothing left in life...
;	MOVE.L	D0,(A0)		; store it in the "next tag" pointer
;lbC0001AC	RTS

; CCR for D0 output is set
; D1 is unused
; A0 is not changed

NextTagItem
	move.l	(A0),D0		; load address of first tag
	beq.b	NTIExit		; if 0, then we didn't find anything this time
NTILoop
	move.l	D0,A1		; load address of current tag
NTILoop2
	move.l	(A1)+,D0	; load the tag type
	beq.b	NTIFailure	; if it is 0, then its TAG_DONE so exit
	subq.l	#3,D0		; second-level check
	bhi.b	NTISuccess	; if greater than TAG_SKIP, then its a user tag
	beq.b	NTITagSkip	; if it is 3, then its TAG_SKIP
	addq.l	#1,D0	
	bne.b	NTITagIgnore	; if it was 1, then its TAG_IGNORE
NTITagMore			; if it was 2, then its TAG_MORE
	move.l	(A1),D0		; go to a new tag list
	bne.b	NTILoop		; if more tags, loop back
NTIFailure
	move.l	D0,(A0)		; no more tags, so leave
NTIExit
	rts

NTITagSkip
	move.l	(A1),D0		; # of tags to skip
	lsl.l	#3,D0		; convert # of tags into total byte size
	add.l	D0,A1		; skip all these bytes
NTITagIgnore
	addq.l	#4,A1		; load address of next tag
	bra.b	NTILoop2	; try again

NTISuccess
	addq.l	#4,A1		; address of next tag
	move.l	A1,(A0)		; store it in the "next tag" pointer
	moveq	#-8,D0
	add.l	A1,D0
	rts

;---------------------------------------------------------------------------

;	boolflags = PackBoolTags( initialFlags, tagList, boolMap )
;	D0			  D0	        A0       A1
;
;	ULONG PackBoolTags( ULONG initialFlags, struct TagItem *tagList,
;                           struct TagItem *boolMap);

;PackBoolTags
;	MOVEM.L	D2/A2/A3,-(SP)
;	MOVE.L	A0,-(SP)	; save tag list pointer on stack
;	MOVE.L	D0,D2		; d2 has current flags
;	MOVEA.L	A1,A2		; a2 has boolMap
;lbC000274
;	MOVEA.L	SP,A0		; where the list pointer is
;	JSR	(-$30,A6)	; get next tag available
;	TST.L	D0		; did we get something?
;	BEQ.B	lbC00029A	; no more tags so split
;	MOVEA.L	D0,A3		; tag pointer in a3
;	MOVE.L	(A3),D0		; tag value to look for in boolMap
;	MOVEQ	#0,D1		; default will be 0
;	MOVEA.L	A2,A0		; load boolMap address
;	JSR	(-$24,A6)	; find the tag in boolMap (GetTagData)
;	TST.L	(4,A3)		; if data is 0...
;	BEQ.B	lbC000294
;	OR.L	D0,D2		; or in tag data with current flags
;	BRA.B	lbC000274	; do next item

;lbC000294
;	NOT.L	D0
;	AND.L	D0,D2		; remove tag data bits from current flags
;	BRA.B	lbC000274	; do next one

;lbC00029A
;	MOVE.L	D2,D0		; return flags
;	ADDQ.L	#4,SP		; remove list pointer
;	MOVEM.L	(SP)+,D2/A2/A3
;	RTS


PackBoolTags
	movem.l	D2/A2/A3,-(SP)
	move.l	A0,-(SP)	; save tag list pointer on stack
	move.l	D0,D2		; d2 has current flags
	move.l	A1,A2		; a2 has boolMap
	bra.b	PBTLoop		; do next one
PBTRemove
	not.l	D0
	and.l	D0,D2		; remove tag data bits from current flags
PBTLoop
	move.l	SP,A0		; where the list pointer is
	bsr.b	NextTagItem	; get next tag available (CCR is set)
	beq.b	PBTExit		; no more tags so split
	move.l	D0,A3		; tag pointer in a3
	move.l	(A3)+,D0	; tag value to look for in boolMap
	moveq	#0,D1		; default will be 0
	move.l	A2,A0		; load boolMap address
	bsr.w	GetTagData	; find the tag in boolMap
	tst.l	(A3)		; if data is 0...
	beq.b	PBTRemove
	or.l	D0,D2		; or in tag data with current flags
	bra.b	PBTLoop		; do next item

PBTExit
	move.l	D2,D0		; return flags
	movem.l	(SP)+,D1/D2/A2/A3
	rts

;---------------------------------------------------------------------------

;	nvalid = FilterTagItems(tagList, tagArray, logic)
;	D0		       A0	A1	  D0
;
;	ULONG FilterTagItems(struct TagItem *tagList, Tag *tagArray,
;			     LONG logic);

;FilterTagItems
;	MOVEM.L	D2/A2/A3,-(SP)
;	MOVE.L	A0,-(SP)	; save tag list pointer on stack
;	MOVEQ	#0,D2		; d2 has item counter
;	MOVEA.L	A1,A2		; a2 has tagArray
;	TST.B	D0		; what filtering is needed?
;	BNE.B	lbC0002D4
;lbC0002B2
;	MOVEA.L	SP,A0		; where the list pointer is
;	JSR	(-$30,A6)	; get next tag available (NextTagItem)
;	TST.L	D0		; did we get something?
;	BEQ.B	lbC0002F6	; no more tags so split
;	MOVEA.L	D0,A3		; tag pointer in a3
;	MOVE.L	(A3),D0		; tag value to look for in tagArray
;	MOVEA.L	A2,A0		; tagArray in a0
;	JSR	(-$5A,A6)	; find the tag in tagArray (TagInArray)
;	TST.W	D0		; if the tag is in the array
;	BNE.B	lbC0002D0
;	MOVEQ	#1,D0		; TAG_IGNORE
;	MOVE.L	D0,(A3)
;	BRA.B	lbC0002B2

;lbC0002D0
;	ADDQ.L	#1,D2		; increment item counter
;	BRA.B	lbC0002B2

;lbC0002D4
;	MOVEA.L	SP,A0		; where the list pointer is
;	JSR	(-$30,A6)	; get next tag available (NextTagItem)
;	TST.L	D0		; did we get something?
;	BEQ.B	lbC0002F6	; no more tags so split
;	MOVEA.L	D0,A3		; tag pointer in a3
;	MOVE.L	(A3),D0		; tag value to look for in tagArray
;	MOVEA.L	A2,A0		; tagArray in a0
;	JSR	(-$5A,A6)	; find the tag in tagArray (TagInArray)
;	TST.W	D0		; if the tag is in the array
;	BEQ.B	lbC0002F2
;	MOVEQ	#1,D0		; TAG_IGNORE
;	MOVE.L	D0,(A3)
;	BRA.B	lbC0002D4

;lbC0002F2
;	ADDQ.L	#1,D2		; increment item counter
;	BRA.B	lbC0002D4

;lbC0002F6
;	MOVE.L	D2,D0		; return counter
;	ADDQ.L	#4,SP		; remove list pointer from stack
;	MOVEM.L	(SP)+,D2/A2/A3
;	RTS

FilterTagItems
	movem.l	D2/D3/A2,-(SP)
	move.l	A0,-(SP)	; save tag list pointer on stack
	moveq	#0,D2		; d2 has item counter
	move.l	A1,A2		; a2 has tagArray
	moveq	#0,D3
	tst.b	D0		; what filtering is needed?
	bne.b	FLTILoop
	moveq	#1,D3
	bra.b	FLTILoop
FLTICount
	addq.l	#1,D2		; increment item counter
FLTILoop
	move.l	SP,A0		; where the list pointer is
	bsr.b	NextTagItem	; get next tag available (CCR is set)
	beq.b	FLTIExit	; no more tags so split
	move.l	D0,A1		; tag pointer in a1
	move.l	(A1),D0		; tag value to look for in tagArray
	move.l	A2,A0		; tagArray in a0
	bsr.b	TagInArray	; find the tag in tagArray
	eor.w	D3,D0		; if the tag is in the array
	beq.b	FLTICount
	move.l	D0,(A1)		; always 1 here -> TAG_IGNORE
	bra.b	FLTILoop

FLTIExit
	move.l	D2,D0		; return counter
	movem.l	(SP)+,D1/D2/D3/A2
	rts

;---------------------------------------------------------------------------

;	BOOL TagInArray( tag, tagArray )
;	D0	         D0   A0
;
;	BOOL TagInArray( Tag tag, Tag *tagArray);

; CCR for D0 output is set
; A1 is unused

TagInArray
	move.l	(A0)+,D1	; get a tag value from the array
	beq.b	TIAFailure	; if 0 (TAG_END), then exit
	cmp.l	D0,D1		; does this match what we want?
	bne.b	TagInArray	; not what we want, look again
	moveq	#1,D0		; found it, set to TRUE
	rts			; bye

;-----------------------------------------------------------------------

; Library close entry point called every CloseLibrary()
; On entry, A6 has UtilityBase, task switching is disabled
; Returns 0 normally, or the library seglist when lib should be expunged
;   due to delayed expunge bit being set, which won't happen for a ROM
;   module

; code moved

LibClose
	subq.w	#1,$20(A6)

*** FALLS THROUGH !!!

;-----------------------------------------------------------------------

; Library expunge entry point called whenever system memory is lacking
; On entry, A6 has UtilityBase, task switching is disabled
; Returns the library seglist if the library open count is 0, returns 0
; otherwise and sets the delayed expunge bit. Won't happen since this is
; a ROM module
LibExpunge
LibReserved
TIAFailure
	moveq	#0,D0		; not found, set to FALSE
	rts			; bye

;---------------------------------------------------------------------------

;	FilterTagChanges( changeList, oldValues, apply)
;			  A0	      A1	 D0
;
;	void FilterTagChanges( struct TagItem *changeList,
;			       struct TagItem *oldValues, LONG apply );

;FilterTagChanges
;	MOVEM.L	D2/A2/A3,-(SP)
;	MOVE.L	A0,-(SP)	; save tag list pointer on stack
;	MOVE.L	D0,D2		; d2 has "apply" flag
;	MOVEA.L	A1,A2		; a2 has oldValues
;lbC00030A
;	MOVEA.L	SP,A0		; where the list pointer is
;	JSR	(-$30,A6)	; get next tag available
;	TST.L	D0		; did we get something?
;	BEQ.B	lbC000340	; no more tags so split
;	MOVEA.L	D0,A3		; tag pointer in a3
;	MOVE.L	(A3),D0		; tag value to look for in oldValues
;	MOVEA.L	A2,A0		; oldValues in a0
;	JSR	(-$1E,A6)	; find the tag in oldValue
;	TST.L	D0		; if the tag is in the array
;	BEQ.B	lbC00030A	; not in oldValue, get next tag
;	MOVEA.L	D0,A0		; oldValue tag in a0
;	MOVE.L	(4,A0),D0	; oldValue tag data in d0
;	CMP.L	(4,A3),D0	; does it match?
;	BNE.B	lbC000334	; no match, so do other part
;	MOVEQ	#1,D0
;	MOVE.L	D0,(A3)
;	BRA.B	lbC00030A

;lbC000334
;	TST.L	D2
;	BEQ.B	lbC00030A
;	MOVE.L	(4,A3),(4,A0)
;	BRA.B	lbC00030A

;lbC000340
;	ADDQ.L	#4,SP		; remove list pointer from stack
;	MOVEM.L	(SP)+,D2/A2/A3
;	RTS

FilterTagChanges
	movem.l	A0/A2-A4,-(SP)	; save tag list pointer on stack
	move.l	D0,A4		; A4 has "apply" flag
	move.l	A1,A2		; a2 has oldValues
	bra.b	FTCLoop
FTCOther
	move.l	A4,D1
	beq.b	FTCLoop
	move.l	D0,(A0)
FTCLoop
	move.l	SP,A0		; where the list pointer is
	bsr.w	NextTagItem	; get next tag available (CCR is set)
	beq.b	FTCExit		; no more tags so split
	move.l	D0,A3		; tag pointer in a3
	move.l	(A3)+,D0	; tag value to look for in oldValues
	move.l	A2,A0		; oldValues in a0
	bsr.b	FindTagItem	; find the tag in oldValue (CCR is set)
	beq.b	FTCLoop		; not in oldValue, get next tag
	move.l	D0,A0		; oldValue tag in a0
	addq.l	#4,A0
	move.l	(A3),D0		; tag data in d0
	cmp.l	(A0),D0		; does it match?
	bne.b	FTCOther	; no match, so do other part
	moveq	#1,D0
	move.l	D0,-(A3)
	bra.b	FTCLoop

FTCExit
	movem.l	(SP)+,A0/A2-A4	; remove list pointer from stack
	rts

;---------------------------------------------------------------------------

;	MapTags(tagList, mapList, includeMiss)
;	        A0	    A1       D0
;
;	VOID MapTags(struct TagItem *tagList, struct TagItem mapList,
;		     LONG includeMiss);

;MapTags
;	MOVEM.L	D2/A2/A3,-(SP)
;	MOVE.L	A0,-(SP)	; save tag list pointer on stack
;	MOVE.L	D0,D2		; d2 has "incluseMiss" flag
;	MOVEA.L	A1,A2		; a2 has map
;lbC000352
;	MOVEA.L	SP,A0		; where the list pointer is
;	JSR	(-$30,A6)	; get next tag available
;	TST.L	D0		; did we get something?
;	BEQ.B	lbC000382	; no more tags so split
;	MOVEA.L	D0,A3		; tag pointer in a3
;	MOVE.L	(A3),D0		; tag value to look for in map
;	MOVEA.L	A2,A0		; map in a0
;	JSR	(-$1E,A6)	; find the tag in map
;	TST.L	D0		; if the tag is in the array
;	BEQ.B	lbC000378	; not in map
;	MOVEA.L	D0,A0		; mapping in a0
;	MOVE.L	(4,A0),(A3)
;	BNE.B	lbC000352
;	MOVEQ	#1,D0
;	MOVE.L	D0,(A3)
;	BRA.B	lbC000352

;lbC000378
;	TST.L	D2		; do we include the non-mapping tags?
;	BNE.B	lbC000352
;	MOVEQ	#1,D0
;	MOVE.L	D0,(A3)		; don't want to see this one
;	BRA.B	lbC000352	; all done, loop back

;lbC000382
;	ADDQ.L	#4,SP		; remove list pointer from stack
;	MOVEM.L	(SP)+,D2/A2/A3
;	RTS

MapTags
	movem.l	A0/A2-A4,-(SP)	; save tag list pointer on stack
	move.l	D0,A4		; A4 has "incluseMiss" flag
	move.l	A1,A2		; a2 has map
	bra.b	MTLoop
MTLoop2
	move.l	A4,D1		; do we include the non-mapping tags?
	beq.b	MTOther
MTLoop
	move.l	SP,A0		; where the list pointer is
	bsr.w	NextTagItem	; get next tag available (CCR is set)
	beq.b	MTExit		; no more tags so split
	move.l	D0,A3		; tag pointer in a3
	move.l	(A3),D0		; tag value to look for in map
	move.l	A2,A0		; map in a0
	bsr.b	FindTagItem	; find the tag in map (CCR is set)
	beq.b	MTLoop2		; not in map
	move.l	D0,A0		; mapping in a0
	move.l	4(A0),(A3)
	bne.b	MTLoop
MTOther
	moveq	#1,D0
	move.l	D0,(A3)		; don't want to see this one
	bra.b	MTLoop		; all done, loop back

MTExit
	movem.l	(SP)+,A0/A2-A4	; remove list pointer from stack
	rts

;---------------------------------------------------------------------------

;	tag = FindTagItem( tagVal, tagList)
;	D0		   D0	   A0
;
;	struct TagItem *FindTagItem( Tag tagVal, struct TagItem *tagList );

;FindTagItem
;	MOVE.L	D2,-(SP)
;	MOVE.L	D0,D2		; desired tag value in d2
;	MOVE.L	A0,-(SP)	; save list pointer on stack
;lbC0001B4
;	MOVEA.L	SP,A0		; where the list pointer is
;	JSR	(-$30,A6)	; get next tag available (NextTagItem)
;	TST.L	D0		; did we get something?
;	BEQ.B	lbC0001C4	; no more tags so split
;	MOVEA.L	D0,A0		; tag pointer in a0
;	CMP.L	(A0),D2		; is this what we want?
;	BNE.B	lbC0001B4	; nope, so look some more
;lbC0001C4
;	ADDQ.L	#4,SP		; remove list pointer from stack
;	MOVE.L	(SP)+,D2	; good to see you back!
;	RTS

; CCR for D0 output is set

FindTagItem
	move.l	D0,D1		; desired tag value in d1
	move.l	A0,-(SP)	; save list pointer on stack
	move.l	SP,A0		; where the list pointer is
FTILoop
	bsr.w	NextTagItem	; get next tag available (CCR is set)
	beq.b	FTIExit		; no more tags so split
	move.l	D0,A1		; tag pointer in a1
	cmp.l	(A1),D1		; is this what we want?
	bne.b	FTILoop		; nope, so look some more
FTIExit
	addq.l	#4,SP		; remove list pointer from stack
	tst.l	D0		; for easy CCR handling
	rts

;---------------------------------------------------------------------------

;	ApplyTagChanges(list,changeList);
;			A0   A1
;
;	VOID ApplyTagChanges(struct TagItem *,struct TagItem *);

;ApplyTagChanges
;	MOVE.L	A2,-(SP)
;	MOVE.L	A3,-(SP)
;	MOVE.L	A0,-(SP)	; save tag list pointer on stack
;	MOVEA.L	A1,A2		; a2 has changeList
;lbC000392
;	MOVEA.L	SP,A0		; where the list pointer is
;	JSR	(-$30,A6)	; get next tag available
;	TST.L	D0		; did we get something?
;	BEQ.B	lbC0003B4	; no more tags so split
;	MOVEA.L	D0,A3		; tag pointer in a3
;	MOVE.L	(A3),D0		; tag value to look for in changeList
;	MOVEA.L	A2,A0		; changeList in a0
;	JSR	(-$1E,A6)	; find the tag in changeList
;	TST.L	D0		; if the tag is in the array
;	BEQ.B	lbC000392	; not in changeList, get next tag
;	MOVEA.L	D0,A0		; changeList tag in a0
;	MOVE.L	(4,A0),(4,A3)	; update original tag
;	BRA.B	lbC000392

;lbC0003B4
;	ADDQ.L	#4,SP		; remove list pointer from stack
;	MOVEA.L	(SP)+,A3
;	MOVEA.L	(SP)+,A2
;	RTS

ApplyTagChanges
	movem.l	A0/A2/A3,-(SP)	; save tag list pointer on stack
	move.l	A1,A2		; a2 has changeList
ATCLoop
	move.l	SP,A0		; where the list pointer is
	bsr.w	NextTagItem	; get next tag available (CCR is set)
	beq.b	ATCExit		; no more tags so split
	move.l	D0,A3		; tag pointer in a3
	move.l	(A3)+,D0	; tag value to look for in changeList
	move.l	A2,A0		; changeList in a0
	bsr.b	FindTagItem	; find the tag in changeList (CCR is set)
	beq.b	ATCLoop		; not in changeList, get next tag
	move.l	D0,A0		; changeList tag in a0
	move.l	4(A0),(A3)	; update original tag
	bra.b	ATCLoop

ATCExit
	movem.l	(SP)+,A0/A2/A3	; remove list pointer from stack
	rts

;---------------------------------------------------------------------------

;	value = GetTagData(tagVal, default, tagList)
;	D0		   D0	   D1	    A0
;
;	ULONG GetTagData(Tag TagVal, ULONG Default, struct TagItem *TagList)

;GetTagData
;	MOVE.L	D1,-(SP)		; save default value
;	JSR	(-$1E,A6)		; find the tag we want (FindTagItem)
;	TST.L	D0			; did we get a tag back?
;	BEQ.B	lbC0001EE		; if no tag, go return default
;	MOVEA.L	D0,A0			; tag pointer in a0
;	MOVE.L	(4,A0),D0		; got a tag, return its data
;	ADDQ.L	#4,SP			; remove default value from stack
;	RTS				; bye

;lbC0001EE	MOVE.L	(SP)+,D0	; remove default value from stack
;	RTS				; bye

; CCR for D0 output is set

GetTagData
	move.l	D1,-(SP)		; save default value
	bsr.b	FindTagItem		; find the tag we want (CCR is set)
	beq.b	GTDDefault		; if no tag, go return default
	addq.l	#4,SP			; remove default value from stack
	move.l	D0,A0			; tag pointer in a0
	move.l	4(A0),D0		; got a tag, return its data
	rts				; bye

GTDDefault
	move.l	(SP)+,D0		; remove default value from stack
	rts				; bye

CallHookPkt
	move.l	8(A0),-(SP)
	rts

;	dc.w	0

;---------------------------------------------------------------------------

;	struct ClockData
;		{
;		UWORD	sec;
;		UWORD	min;
;		UWORD	hour;
;		UWORD	mday;
;		UWORD	month;
;		UWORD	year;
;		UWORD	wday;
;		};
;
;
;	/*
;	 * an interesting and useful macro I designed (the 'function' form
;	 * is much simpler, but for constants everthing is resolved at compile
;	 * time).
;	 */
;	#define CALC_DATE(YEAR,MONTH,DAY) \
;	  ( \
;	  ((YEAR)-1+((MONTH)+9)/12)*365L \
;	  +((YEAR)-1+((MONTH)+9)/12)/4 \
;	  -((YEAR)-1+((MONTH)+9)/12)/100 \
;	  +((YEAR)-1+((MONTH)+9)/12)/400 \
;	  +((((MONTH)+9)%12)*306+5)/10 \
;	  +(DAY) \
;	  -1 \
;	 )
;

;	ULONG __asm CalcDate(register __d0 ULONG year, register __d1 ULONG month, register __d2 ULONG day)
;		{
;		month += 9;
;		year = year-1 + (month/12);
;		month %= 12;
;		month = month*306 +5;
;
;		return (year*365) + (year/4) - (year/100) + (year/400)
;			+ (month/10) + day -1;
;		}

;CalcDate:
;	MOVE.L  D2,-(A7)
;	MOVE.L  D0,D2		; d2=year
;	MOVEQ   #09,D0
;	ADD.L   D1,D0		; d0=month+9
;	MOVEQ   #12,D1
;	JSR	-$9C(A6)	; d1=(month+9)%12	UDivMod32
;	ADD.L   D0,D2		; d2=year+(month+9)/12
;	MOVE.L  #306,D0
;	JSR	-$90(A6)	; d0=((month+9)%12)*306	UMult32
;	ADDQ.L  #5,D0		; d0=((month+9)%12)*306+5
;	MOVEQ   #10,D1
;	JSR	-$9C(A6)	; d0=(((month+9)%12)*306+5)/10	UDivMod32
;	MOVE.L  D0,-(SP)
;	SUBQ.L  #1,D2		; d2=year+(month+9)/12 -1
;	MOVE.L  D2,D0		; d0=year+(month+9)/12 -1
;	MOVEQ   #100,D1
;	LSL.L   #2,D1
;	JSR	-$9C(A6)	; d0=(year+(month+9)/12-1)/400	UDivMod32
;	MOVE.L  D0,-(SP)
;	MOVE.L  D2,D0		; d0=year+(month+9)/12 -1
;	MOVEQ   #100,D1
;	JSR	-$9C(A6)	; d0=(year+(month+9)/12-1)/100	UDivMod32
;	MOVE.L  D0,-(SP)
;	MOVE.L  D2,D1		; d1=year+(month+9)/12-1
;	LSR.L   #2,D2		; d2=(year+(month+9)/12-1)/4
;	MOVE.L  #365,D0
;	JSR	-$90(A6)	; d0=(year+(month+9)/12-1)*365	UMult32
;	ADD.L   D2,D0		; d0=d0 + (year+(month+9)/12-1)/4
;	SUB.L   (SP)+,D0	; d0=d0 - (year+(month+9)/12-1)/100
;	ADD.L   (SP)+,D0	; d0=d0 + (year+(month+9)/12-1)/400
;	ADD.L   (SP)+,D0	; d0=d0 + (((month+9)%12)*306+5)/10
;	MOVE.L  (A7)+,D2
;	ADD.L   D2,D0		; d0=d0 + day
;	SUBQ.L  #1,D0		; d0=d0 -1
;	RTS

;---------------------------------------------------------------------------

;	void __asm Amiga2Date(register __d0 ULONG amiga, register __a0 struct ClockData *cd)
;	  {
;	   LONG year;
;	   LONG month;
;	   LONG day;
;	   LONG hour;
;	   LONG minute;
;	   LONG second;
;	   LONG absday;
;	   LONG work;
;
;
;	   second  = amiga % 60;
;	   minute  = amiga / 60;
;	   hour    = minute / 60;
;	   minute %= 60;
;	   hour   %= 24;
;
;	   absday  = amiga / (60 * 60 * 24);
;	   absday += CALC_DATE(1978,1,1);      /* add the Amiga date offset */
;
;	   cd->wday  = (absday+3)%7
;
;	   /*
;	    * the following date logic took a great deal of time to develop and prove
;	    * so please give credit if you use it. That also includes the macro
;	    * in AmigArc.h.
;	    * NOTE: the following were split into separate lines for aestetic(sp?)
;	    * reasons as well as to prevent the (sometimes very stupid!) 'C'
;	    * optimizer from changing the math (implicit floor function is very
;	    * important!).
;	    */
;
;	   /* find year */
;	   work = absday;
;	   work -= (absday + 1) / 146097;   /* subtract quadcentury leap days */
;	   work += work / 36524;            /* add century leap days */
;	   work -= (work + 1) / 1461;       /* subtract all leap days */
;	   year = work / 365;
;
;	   /* find day of year */
;	   work = absday;
;	   work -= year * 365;
;	   work -= year / 4;
;	   work += year / 100;
;	   work -= year / 400;
;
;	   /* find month */
;	   month = work / 153;
;	   month *= 5;
;	   month += 10 * (work % 153) / 305;
;
;	   /* find day */
;	   day = 1 + work;
;	   day -= (long)((month * 306 + 5) / 10);
;
;	   /* adjust to Gregorian calendar */
;	   month += 2;
;	   year += month / 12;
;	   month %= 12;
;	   month++;
;
;	   cd->sec   = second;
;	   cd->min   = minute;
;	   cd->hour  = hour;
;	   cd->day   = day;
;	   cd->month = month;
;	   cd->year  = year;
;	  }

sec	= 0
min 	= 2
hour	= 4
mday	= 6
month	= 8
year	= 10
wday	= 12

;Amiga2Date:
;	MOVEM.L D2-D3,-(A7)
;	MOVEQ   #60,D1
;	JSR	-$9C(A6)	; UDivMod32
;	MOVE.W  D1,(A0)		; d1=amiga%60  (sec)
;	MOVEQ   #60,D1		; d0=amiga/60
;	JSR	-$9C(A6)	; UDivMod32
;	MOVE.W  D1,min(A0)	; d1=(amiga/60)%60
;	MOVEQ   #24,D1		; d0=amiga/3600
;	JSR	-$9C(A6)	; UDivMod32
;	MOVE.W  D1,hour(A0)	; d1=(amiga/3600)%24
;	ADDI.L  #722390,D0	; d0=absday
;	MOVE.L  D0,-(SP)
;	MOVE.L  D0,D2
;	ADDQ.L  #3,D0		; offset so sunday = 0
;	MOVEQ.L #7,d1
;	JSR	-$9C(A6)	; d1=dayofweek	UDivMod32
;	MOVE.W  d1,wday(A0)
;	MOVE.L  D2,D0
;	ADDQ.L  #1,D0
;	MOVE.L  #146097,D1
;	JSR	-$9C(A6)	; d0=(absday+1)/146097	UDivMod32
;	SUB.L   D0,D2		; work=absday - (absday+1)/146097
;	MOVE.L  D2,D0
;	MOVE.L  #36524,D1
;	JSR	-$9C(A6)	; UDivMod32
;	ADD.L   D0,D2		; work += work/36524
;	MOVE.L  D2,D0
;	ADDQ.L  #1,D0
;	MOVE.L  #1461,D1
;	JSR	-$9C(A6)	; UDivMod32
;	SUB.L   D0,D2		; work -= (work+1)/1461
;	MOVE.L  D2,D0
;	MOVE.L  #365,D1
;	JSR	-$9C(A6)	; UDivMod32
;	MOVE.L  (SP)+,D2	; work = absday
;	MOVE.L  D0,-(SP)	; save year
;	MOVE.L  D0,D3
;	MOVEQ   #100,D1
;	LSL.L   #2,D1
;	JSR	-$9C(A6)	; d0=year/400	UDivMod32
;	SUB.L   D0,D2		; work-=year/400
;	MOVE.L  D3,D0
;	MOVEQ   #100,D1
;	JSR	-$9C(A6)	; d0=year/100	UDivMod32
;	ADD.L   D0,D2		; work+=year/100
;	MOVE.L  D3,D0
;	LSR.L   #2,D0
;	SUB.L   D0,D2		; work-=year/4
;	MOVE.L  D3,D0
;	MOVE.L  #365,D1
;	JSR	-$90(A6)	; d0=year*365	UMult32
;	SUB.L   D0,D2		; d2=work-=year*365
;	MOVE.L  D2,D0
;	MOVEQ   #102,D1
;	NOT.B   D1
;	JSR	-$9C(A6)	; d1=work%153	UDivMod32
;	MOVEQ   #10,D0
;	JSR	-$90(A6)	; d0=10*(work%153)	UMult32
;	MOVE.L  #305,D1
;	JSR	-$9C(A6)	; d0=10*(work%153)/305	UDivMod32
;	MOVE.L  D0,D3
;	MOVE.L  D2,D0
;	MOVEQ   #102,D1
;	NOT.B   D1
;	JSR	-$9C(A6)	; d0=work/153	UDivMod32
;	MOVE.L  D0,D1
;	LSL.L   #2,D1
;	ADD.L   D0,D1		; d1=5*(work/153)
;	ADD.L   D1,D3		; d2==work; d3==month
;	MOVE.L  #306,D0
;	MOVE.L  D3,D1
;	JSR	-$90(A6)	; d0=month*306		UMult32
;	ADDQ.L  #5,D0		; d0=month*306+5
;	MOVEQ   #10,D1
;	JSR	-$9C(A6)	; d0=(month*306+5)/10	UDivMod32
;	ADDQ.L  #1,D2
;	SUB.L   D0,D2		; d2=day=1+work-(month*306+5)/10
;	MOVE.W  D2,mday(A0)
;	MOVE.L  D3,D0
;	ADDQ.L  #2,D0
;	MOVEQ   #12,D1
;	JSR	-$9C(A6)	; d0=(month+2)/12	UDivMod32
;	ADDQ.L  #1,D1		; d1=(month+2)%12 +1
;	MOVE.W  D1,month(A0)
;	ADD.L   (SP)+,D0	; year+=(month+2)/12
;	MOVE.W  D0,year(A0)
;	MOVEM.L (A7)+,D2-D3
;	RTS


Amiga2Date
	move.l	D2,-(SP)
	lsr.l	#1,D0		; odd sec
	subx.l	D1,D1		; 0 or  -1
	divu.w	#60*60*24/2,D0	; number of all days
	move.l	D0,D2		; backup
	clr.w	D0
	eor.l	D0,D2		; number of all days
	swap	D0
	add.l	D0,D0
	sub.l	D1,D0		; rest of secs
	divu.w	#60*60,D0
	move.w	D0,hour(A0)
	clr.w	D0
	swap	D0
	divu.w	#60,D0
	move.l	D0,(A0)		; sec and min
	move.l	D2,D0		; number of all days
	divu.w	#7,D0
	swap	D0
	move.w	D0,wday(A0)	; day of week

	cmp.w	#44925,D2	; 01.01.2101
	blo.b	y2k1
	addq.w	#1,D2		; +1jour : 2100 non bissextile
y2k1
; il faut que la 1ere anne soit une bissextile (arrondi /365.25 au 1er coup)
	add.w	#366+365,D2	; +2 ans, donc
	lsl.l	#2,D2
	divu.w	#365*4+1,D2	; /365.25
	add.w	#1976,D2		; anne
	move.w	D2,10(A0)	; anne
	moveq	#28,D1		; II
	cmp.w	#2100,D2
	beq.b	FebruarySet
	and.w	#3,D2
	bne.b	FebruarySet
	moveq	#29,D1		; II
FebruarySet
	swap	D1
	moveq	#16+2,D0
	lsr.l	D0,D2		; et jour de l'anne
	moveq	#1,D0		; first month
	move.w	#31,D1
	sub.w	D1,D2
	bcs.b	Month		; I
	swap	D1
	bra.b	CalcMonth
NextMonth
	move.b	MonthsTable(PC,D0.W),D1
CalcMonth
	addq.w	#1,D0
	sub.w	D1,D2
	bcc.b	NextMonth
Month
	add.w	D1,D2
	addq.w	#1,D2
	move.w	D2,mday(A0)
	move.w	D0,month(A0)
	move.l	(SP)+,D2
	rts

MonthsTable
	dc.b	31		; I
	dc.b	28		; II
	dc.b	31		; III
	dc.b	30		; IV
	dc.b	31		; V
	dc.b	30		; VI
	dc.b	31		; VII
	dc.b	31		; VIII
	dc.b	30		; IX
	dc.b	31		; X
	dc.b	30		; XI
	dc.b	31		; XII

;---------------------------------------------------------------------------

;	ULONG __asm Date2Amiga(register __a0 struct ClockData *cd)
;	  {
;	   return (((CalcDate(cd->year,cd->month,cd->day) - CALC_DATE(1978,1,1))
;	         * 24 + cd->hour) * 60 + cd->min) * 60 + cd->sec;
;	  }

;Date2Amiga:
;	MOVEM.L D2-D3,-(A7)
;	MOVEQ   #00,D0
;	MOVE.W  year(A0),D0
;	MOVEQ   #00,D1
;	MOVE.W  month(A0),D1
;	MOVEQ   #00,D2
;	MOVE.W  mday(A0),D2
;	BSR     CalcDate
;	MOVEQ   #00,D1
;	MOVE.W  (A0),D1		; sec
;	MOVEQ   #00,D2
;	MOVE.W  min(A0),D2
;	MOVEQ   #00,D3
;	MOVE.W  hour(A0),D3
;	SUBI.L  #722390,D0
;	MOVE.L  D1,-(A7)
;	MOVEQ   #24,D1
;	JSR	-$90(A6)	; UMult32
;	ADD.L   D3,D0
;	MOVEQ   #60,D1
;	JSR	-$90(A6)	; UMult32
;	ADD.L   D2,D0
;	MOVEQ   #60,D1
;	JSR	-$90(A6)	; UMult32
;	MOVE.L  (A7)+,D1
;	ADD.L   D1,D0
;	MOVEM.L (A7)+,D2-D3
;	RTS

Date2Amiga
	move.l	D2,-(SP)
	moveq	#-1,D2		; minus one day
	move.w	month(A0),D0
	moveq	#0,D1
	bra.b	GetDays
NewMonth
	move.b	MonthsTable-1(PC,D0.W),D1
	add.w	D1,D2		; number of days in year
GetDays
	subq.w	#1,D0
	bne.b	NewMonth

	move.w	year(A0),D0
	move.w	D0,D1		; backup year
	sub.w	#1977,D0
	mulu.w	#365*4+1,D0	; *365.25
	sub.l	#365*4,D0
	lsr.l	#2,D0		; number of days
	add.w	mday(A0),D2	; add month days

	cmp.w	#2,month(A0)
	ble.b	NormalYear
	and.w	#3,D1
	bne.b	NormalYear
	addq.w	#1,D2
NormalYear
	add.w	D2,D0		; number of all days

	cmp.w	#44620,D0	; 01.03.2100
	blo.b	y2100
	subq.w	#1,D0
y2100
	mulu.w	#60*60*24/2,D0
	add.l	D0,D0		; number of secs of all days
	moveq	#60,D1
	mulu.w	min(A0),D1
	add.l	D1,D0
	move.w	(A0),D1		; sec
	add.l	D1,D0
	move.w	hour(A0),D1
	mulu.w	#60*60,D1
	add.l	D1,D0
	move.l	(SP)+,D2
	rts

;---------------------------------------------------------------------------

;CheckDate:
;	lea	-14(SP),SP
;	move.l	a0,-(SP)	; save it
;	JSR	-$7E(A6)	; get AmigaTime
;	move.l	(SP)+,A1	; ClockData
;	move.l	SP,A0		; temp ClockData
;	movem.l	D0/A1,-(SP)
;	JSR	-$78(A6) 	; convert back
;;	bra.s	CDCommon

;---------------------------------------------------------------------------

*** ABOVE ROUTINE FALLS THROUGH HERE

;CDCommon:
;	movem.l	(SP)+,D0/A1
;	move.l	SP,A0

; a1 -> ClockData struct passed in
; a0 -> ClockData struct created by converting the passed CD to AmigaTime
;	then converting back to CD
; d0 AmigaTime from passed ClockData struct

; if they are both the same, then the date/time is good

;	MOVEQ	#11,D1		; check the date (but not wday field)
;CDls
;	cmpm.b	(A0)+,(A1)+
;	bne.s	BadDate		; BZZZZZZZZT, you loose!
;	dbf	d1,CDls
;CDe
;	lea	14(SP),SP
;	rts

;BadDate
;	moveq.l	#0,D0
;	bra.s	CDe

CheckDate:
	lea	-14(SP),SP
	move.l	A0,A1		; save it (ClockData)
	bsr.b	Date2Amiga	; get AmigaTime
	move.l	SP,A0		; temp ClockData
	move.l	D0,-(SP)
	bsr.w	Amiga2Date 	; convert back

;---------------------------------------------------------------------------

*** ABOVE ROUTINE FALLS THROUGH HERE

CDCommon:
	move.l	(SP)+,D0
	move.l	SP,A0

; a1 -> ClockData struct passed in
; a0 -> ClockData struct created by converting the passed CD to AmigaTime
;	then converting back to CD
; d0 AmigaTime from passed ClockData struct

; if they are both the same, then the date/time is good

	moveq	#3-1,D1		; check the date (but not wday field)
CDls
	cmpm.l	(A0)+,(A1)+
	bne.b	BadDate		; BZZZZZZZZT, you loose!
	dbf	D1,CDls
CDe
	lea	14(SP),SP
	rts

BadDate
	moveq	#0,D0
	bra.b	CDe

SMult32S:
UMult32S:
;	move.l	d2,-(sp)	; need these
;	move.l	d3,-(sp)
;	move.l	d0,d2		; d0=Al
;	move.l	d1,d3		; d1=Bl
;	swap	d2		; d2=Ah
;	swap	d3		; d3=Bh
;	mulu.w	d1,d2		; d2=Ah*Bl
;	mulu.w	d0,d3		; d3=Al*Bh
;	mulu.w	d1,d0		; d0=Al*Bl
;	add.w	d3,d2		; ignore overflow
;	swap.w	d2		; shift to where it belongs
;	clr.w	d2
;	add.l	d2,d0		; ignore overflow
;	move.l	(sp)+,d3
;	move.l	(sp)+,d2	;
;	rts

	move.l	D2,-(SP)	; 
	move.l	D0,-(SP)	; A
	mulu.w	D1,D0		; D0=Al*Bl
	move.l	D1,D2		; B
	mulu.w	(SP)+,D1	; D1=Ah*Bl
	swap	D2		; D2=Bh
	mulu.w	(SP)+,D2	; D2=Al*Bh
	add.w	D2,D1		;
	swap	D1		;
	move.l	(SP)+,D2	;
	clr.w	D1		;
	add.l	D1,D0		;
	rts

; 12 cycles fastest, 3 commands left, 6 bytes less :)

;---------------------------------------------------------------------------

SDivMod32S:
	tst.l	d0
	bpl.s	NumPos
	neg.l	d0
	tst.l	d1
	bpl.s	DenomPos
	neg.l	d1
	bsr.s	UDivMod32S
	neg.l	d1
	rts
DenomPos
	bsr.s	UDivMod32S
	neg.l	d0
	neg.l	d1
	rts
NumPos
	tst.l	d1
	bpl.s	UDivMod32S
	neg.l	d1
	bsr.s	UDivMod32S
	neg.l	d0
	rts

;---------------------------------------------------------------------------

UDivMod32S:
;	move.l	d3,-(sp)
;	swap	d1
;	tst.w	d1		; can we do this easily? (is number < 65536)
;	bne.s	BigDenom	; no, we have to work for it
;	swap	d1
;	move.l	d1,d3
;	swap.w	d0
;	move.w	d0,d3
;	beq.s	SmallNum
;	divu.w	d1,d3
;	move.w	d3,d0
;SmallNum
;	swap.w	d0
;	move.w	d0,d3
;	divu.w	d1,d3
;	move.w	d3,d0
;	swap.w	d3
;	move.w	d3,d1
;	move.l	(sp)+,d3
;	rts

;BigDenom:
;	swap	d1
;	move.w	d2,-(sp)
;	moveq	#15,d3		; 16 times through the loop
;	move.w	d3,d2
;	move.l	d1,d3
;	move.l	d0,d1
;	clr.w	d1
;	swap	d1
;	swap	d0
;	clr.w	d0
;DMls	add.l	d0,d0
;	addx.l	d1,d1
;	cmp.l	d1,d3
;	bhi.s	DMle
;	sub.l	d3,d1
;	addq.w	#1,d0
;DMle	dbf	d2,DMls
;	move.w	(sp)+,d2
;	move.l	(sp)+,d3
;	rts

	move.l	D1,-(SP)
	tst.w	(SP)+		; can we do this easily? (is number < 65536)
	bne.s	BigDenom	; no, we have to work for it
	swap.w	D0
	move.w	D0,D1
	beq.s	SmallNum
	divu.w	(SP),D1
	move.w	D1,D0
SmallNum
	swap.w	D0
	move.w	D0,D1
	divu.w	(SP)+,D1
	move.w	D1,D0
	clr.w	D1
	swap	D1
	rts

BigDenom:
	move.w	D2,(SP)
	move.l	D3,-(SP)
	moveq	#15,D3		; 16 times through the loop
	move.w	D3,D2

;	move.l	d1,d3
;	move.l	d0,d1		; $12345678
;	clr.w	d1		; $12340000
;	swap	d1		; $00001234
;	swap	D0		; $56781234
;	clr.w	D0		; $56780000

	exg	D3,D1		; D3 is set
	swap	D0		; $56781234
	move.w	D0,D1		; $00001234
	clr.w	D0		; $56780000

DMls	add.l	d0,d0
	addx.l	d1,d1
	cmp.l	d1,d3
	bhi.s	DMle
	sub.l	d3,d1
	addq.w	#1,d0
DMle	dbf	d2,DMls

	move.l	(SP)+,D3
	move.w	(SP)+,D2
	rts

;---------------------------------------------------------------------------
; Multiply two signed 32 bit integers and return the 64 bit result
;
; What it will do is take the values, make them "right", do the multiply
; routine below and then make the sign correct...
;
SMult64S:
	move.l	d2,-(sp)	; We need a scrap...
	moveq.l	#0,d2		; No sign...
	tst.l	d0		; Check arg1...
	bpl.s	One		; If not negative, skip...
	neg.l	d0		; Make d0 positive...
;	addq.l	#1,d2		; Set d0 as negative flag...

	moveq	#1,D2

One	tst.l	d1		; Check arg2...
	bpl.s	Two		; If not negative, skip...
	neg.l	d1		; Make it positive...
;	subq.l	#1,d2		; Set d1 as negative flag...

	subq.w	#1,D2

Two	bsr.s	UMult64S	; Do the multiply...
	tst.l	d2		; Are we needed?
	beq.s	Three		; If not negative result, skip...

	moveq.l	#0,d2		; We need a register with 0...
	not.l	d0		; Invert...
	not.l	d1		; binary (1's complement negative)
	addq.l	#1,d0		; add 1 (2's complement negative)
	addx.l	d2,d1		; (add in the carry)

Three	move.l	(sp)+,d2	; Clean up...
	rts

;---------------------------------------------------------------------------
; Multiply two unsigned 32 bit integers and return the 64 bit result
;
;   REGISTER USAGE
;	D4 -- scratch (restored)
;	D3 -- scratch (restored)
;	D2 -- scratch (restored)
;	D1 -- arg 1 (given), result 32:63
;	D0 -- arg 0 (given), result 0:31
;
UMult64S:
;	movem.l	d2-d4,-(sp)

;	move.l	d1,d3
;	mulu.w	d0,d3		; 24
;	move.l	d1,d2
;	swap.w	d2
;	swap.w	d0
;	mulu.w	d0,d2		; 13

;	swap.w	d3

;	move.l	d1,d4
;	mulu.w	d0,d4		; 14
;	add.w	d4,d3
;	clr.w	d4
;	swap.w	d4
;	addx.l	d4,d2

;	swap.w	d0
;	swap.w	d1

;	move.l	d1,d4
;	mulu.w	d0,d4		; 23
;	add.w	d4,d3
;	clr.w	d4
;	swap.w	d4
;	addx.l	d4,d2

;	swap.w	d3

;	move.l	d2,d0
;	move.l	d3,d1

;	movem.l	(sp)+,d2-d4
;	rts			; 26 commands
				; 432 cycles

	move.l	D2,-(SP)	; 12c
	move.w	D0,-(SP)	; 8c D0W
	move.l	D1,D2		; 4c D1H/D1W
	swap	D2		; 4c D1W/D1H
	move.l	D2,-(SP)	; 12c D1W/D1H
	mulu.w	D0,D1		; 70c D1=D0.W*D1.W
	swap	D0		; 4c D0W/D0H
	mulu.w	D0,D2		; 70c D2=D0.H*D1.H
	swap	D1		; 4c D1.W*D0.W
	mulu.w	(SP)+,D0	; 74c D0=D0.H*D1.W
	add.w	D0,D1		; 4c
	clr.w	D0		; 4c
	swap.w	D0		; 4c
	addx.l	D2,D0		; 6c
	move.w	(SP)+,D2	; 8c D2=D1.H
	mulu.w	(SP)+,D2	; 74c D2=D0.W*D1.H
	add.w	D2,D1		; 4c
	clr.w	D2		; 4c
	swap.w	D2		; 4c
	addx.l	D2,D0		; 6c
	move.l	(SP)+,D2	; 12c
	swap	D1		; 4c
	rts			; 22 commands
				; 396 cycles
				; 12 bytes less



;Stricmp	MOVE.L	#$7FFFFFFF,D0		; infinite length
;	;-- fall through!


;---------------------------------------------------------------------------

	;-- note: stricmp falls through to here
;Strnicmp
;	MOVEM.L	D2-D4,-(SP)	; d4 for check_sub use
;	MOVE.L	D0,D3		; save length
;	BEQ.B	lbC0006F8	; if length == 0, return SAME
;	MOVEQ	#0,D0		; clear high 3 bytes, set equal if len=0
;lbC0006D0
;	SUBQ.L	#1,D3		; done yet?
;	BMI.B	lbC0006F4	; if done, make result
;	MOVE.B	(A0)+,D1	; Deal with either string ending first
;	MOVE.B	(A1)+,D2	; must fetch both for comparison, even if d0==0
;	BEQ.B	lbC0006F4	; exit if *s2 == 0
;	MOVE.B	D1,D0
;	BEQ.B	lbC0006F4	; exit if *s1 == 0
;	BSR.B	lbC00070A
;	BEQ.B	lbC0006E6
;	SUB.B	#$20,D1		; 'a'-'A'
;lbC0006E6	MOVE.B	D2,D0
;	BSR.B	lbC00070A
;	BEQ.B	lbC0006F0
;	SUB.B	#$20,D2		; 'a'-'A'
;lbC0006F0
;	CMP.B	D2,D1		; do the comparison (must
;	BEQ.B	lbC0006D0	; check next character (after checking size)
;lbC0006F4	MOVE.B	D1,D0
;	SUB.B	D2,D0		; generate return value
;lbC0006F8	EXT.W	D0
;	EXT.L	D0		; return LONG!!!
;	MOVEM.L	(SP)+,D2-D4
;	RTS

*
* returns d0 = 0 if no sub needed, = 1 if needed (cc's set!!!!)
* can't touch d1/d2/d3, d4 is scratch, d0 has character/return
*

;lbC000702
;	MOVE.L	#$5E405A41,D4	; load up 4 characters for compares
;	BRA.B	lbC000710	; @ <- , ^ <- 

;lbC00070A
;	MOVE.L	#$7E607A61,D4	; load up 4 characters for compares
;lbC000710
;	CMP.B	#$F7,D0		; these are special (can be first !!!)
;	BEQ.B	lbC00072C
				; Z/z and A/a in low 16 bits
;	BCLR	#7,D0		; clear high bit
;	BEQ.B	lbC00071E
;	SWAP	D4		; / and / are the highest in the upper area
				; (~ = , ' =  minus bit 7)
;lbC00071E
;	CMP.B	D4,D0		; a or (`)  (or A or )
;	BLT.B	lbC00072C
;	LSR.L	#8,D4		; get upper bound
;	CMP.B	D4,D0		; z or (~)  (or Z or )
;	BGT.B	lbC00072C
;	MOVEQ	#1,D0
;	RTS

;lbC00072C	MOVEQ	#0,D0
;	RTS

;ToUpper	MOVEM.L	D2-D4,-(SP)
;	MOVE.B	#$E0,D3		; amount to add (negative in this case) 'A'-'a'
;	LEA	(lbC00070A,PC),A0

	;-- common routine

;lbC00073C	MOVE.L	D0,D2	; save character
;	JSR	(A0)		; check_sub_xxxx
;	BEQ.B	lbC000744	; returns cc's, hits d4
;	ADD.B	D3,D2		; + or - ('a'-'A')
;lbC000744
;	MOVEQ	#0,D0
;	MOVE.B	D2,D0		; make sure the return is good
;	MOVEM.L	(SP)+,D2-D4
;	RTS

;ToLower	MOVEM.L	D2-D4,-(SP)
;	LEA	(lbC000702,PC),A0
;	MOVE.B	#$20,D3		; amount to add ('a'-'A')
;	BRA.B	lbC00073C

; CCR is set for D0

Stricmp
	moveq	#-1,D0
	lsr.l	#1,D0		; infinite length
	;-- fall through!

;---------------------------------------------------------------------------

; CCR is set for D0

	;-- note: stricmp falls through to here
Strnicmp
	movem.l	D2-D4,-(SP)	; d4 for check_sub use
	move.l	D0,D3		; save length
	beq.b	SCExit		; if length == 0, return SAME
caseloop
	subq.l	#1,D3		; done yet?
	bmi.b	make_res	; if done, make result
	move.b	(A0)+,D4	; Deal with either string ending first
	move.b	(A1)+,D2	; must fetch both for comparison, even if d0==0
	beq.b	make_res	; exit if *s2 == 0
	move.b	D4,D0
	beq.b	make_res	; exit if *s1 == 0
	bsr.b	check_sub_toupper
	sub.b	D0,D4		; 'a'-'A' or 0
	move.b	D2,D0
	bsr.b	check_sub_toupper
	sub.b	D0,D2		; 'a'-'A' or 0
	cmp.b	D2,D4		; do the comparison (must
	beq.b	caseloop	; check next character (after checking size)
make_res
	move.b	D4,D0
	sub.b	D2,D0		; generate return value
	ext.w	D0
	ext.l	D0		; return LONG!!!
SCExit
	movem.l	(SP)+,D2-D4
	rts

ToLower
	pea	ToLowerReturn(PC)
	move.l	D0,A0		; backup sign
check_sub_tolower
	move.l	#$5E5A4041*2,D1	; load up 4 characters for compares
	bra.b	check_common	; @ <- , ^ <- 

ToUpper
	pea	ToUpperReturn(PC)
	move.l	D0,A0		; backup sign
check_sub_toupper
	move.l	#$7E7A6061*2,D1	; load up 4 characters for compares
check_common
	cmp.b	#$F7,D0		; these are special (can be first !!!)
	beq.b	CSno
				; Z/z and A/a in low 16 bits
	add.b	D0,D0		; clear high bit
	bcc.b	normal_char
	lsr.l	#8,D1		; / and / are the highest in the upper area
				; (~ = , ' =  minus bit 7)
normal_char
	cmp.b	D1,D0		; a or (`)  (or A or )
	bcs.b	CSno
	swap	D1		; get upper bound
	cmp.b	D1,D0		; z or (~)  (or Z or )
	bhi.b	CSno
	moveq	#$20,D0		; for fast chars handling
	rts
CSno
	moveq	#0,D0
	rts

ToLowerReturn
	move.l	A0,D1		; restore sign
	add.b	D1,D0		; make lower case
	rts

ToUpperReturn
	move.l	A0,D1		; restore sign
	sub.b	D0,D1		; make upper case
	move.b	D1,D0		; output value
	rts

******* utility.library/PackStructureTags *************************************
*
*   NAME
*	PackStructureTags -- pack a structure with values from taglist. (V39)
*
*   SYNOPSIS
*	num = PackStructureTags(pack,packTable,tagList);
*	D0                      A0   A1        A2
*
*	ULONG PackStructureTags(APTR,ULONG *,struct TagItem *);
*
*   FUNCTION
*	For each table entry, a FindTagItem() will be done and if the
*	matching tag is found in the taglist, the data field will be
*	packed into the given structure based on the packtable
*	definition.
*
*   INPUTS
*	pack - a pointer to the data area to fill in.
*	packTable - a pointer to the packing information table.
*		    See <utility/pack.h> for definition and macros.
*	tagList - a pointer to the taglist to pack into the structure
*
*   RESULTS
*	num - the number of tag items packed
*
*   SEE ALSO
*	<utility/pack.h>, FindTagItem(), UnpackStructureTags()
*
*******************************************************************************
*
*
* Registers:
*	a2 - Tag list (as passed in)
*	a3 - Structure (a0 parameter)
*	a4 - Current table location
*	d2 - Base tag value
*	d3 - Data offset (from table)
*	d4 - Count of packed values
*

;PackStructureTags
;	MOVEM.L	D2-D4/A2-A4,-(SP)	; Save these
;	MOVEQ	#0,D4			; Clear count
;	MOVEA.L	A0,A3			; Get structure
;	MOVEA.L	A1,A4			; Get table...
;lbC000766
;	MOVE.L	(A4)+,D2		; Base tag value...
;lbC000768
;	MOVE.L	(A4)+,D3		; Get next table entry
;	BEQ.B	lbC0007E0		; branch to exit if NULL
;	ADDQ.L	#1,D3			; Check for -1
;	BEQ.B	lbC000766		; If -1, get new base tag
;	SUBQ.L	#1,D3			; back up again...
;	BTST	#$1D,D3			; Check if we can pack this
;	BNE.B	lbC000768		; Nope, so skip it...
;	MOVE.L	D3,D0			; Get table value into d0
;	SWAP	D0			; Get high word at bottom
;	AND.L	#$3FF,D0		; Mask out unused bits
;	ADD.L	D2,D0			; Add in base tag
;	MOVEA.L	A2,A0			; Get tag list
;	JSR	(-$1E,A6)		; Search for the tag (FindTagItem)
;	TST.L	D0			; Did we get it?
;	BEQ.B	lbC000768		; No tag in list, so next...
;	ADDQ.L	#1,D4			; Count match...
;	MOVEA.L	D0,A0			; Pointer to tag item...
;	ADDQ.L	#4,A0			; Point at ti_Data...
;	MOVE.L	(A0),D1			; Get ti_Data...
;	MOVE.L	D3,D0			; Get table value again
;	ROL.L	#6,D0			; Move up and around into low
;	AND.W	#6,D0			; Mask everything else
;	JMP	(lbC0007A2,PC,D0.W)	; Do jumptable...

*
* Table of size operators in PackStructureTags
*

;lbC0007A2
;	BRA.B	lbC0007CE	; 2 bytes (00 0)

;	BRA.B	lbC0007D4	; 2 bytes (01 0)

;	BRA.B	lbC0007DA	; 2 bytes (10 0)
				; fall-in (11 0)
;	MOVE.W	D3,D0			; Get value...
;	ROL.W	#3,D0			; Get bit number into bits 0-2
; 	and.w	#7,d0			; Mask it (ignore this, CPU does it)
;	AND.W	#$1FFF,D3		; Mask out bit number
;	BTST	#$1A,D3			; Check for EXISTS hack thingy
;	BNE.B	lbC0007BA		; If EXISTS hack, assume TRUE...
;	TST.L	D1			; False=clear bit (inverted if signed)
;	BEQ.B	lbC0007C0
;lbC0007BA	BSET	D0,(A3,D3.W)	; Set the bit
;	BRA.B	lbC0007C4		; Check for inverted boolean

;lbC0007C0	BCLR	D0,(A3,D3.W)	; Clear the bit
;lbC0007C4	TST.L	D3		; Check for SIGNED bit
;	BPL.B	lbC000768		; If signed we will invert the meaning
;	BCHG	D0,(A3,D3.W)		; Invert the bit
;	BRA.B	lbC000768

;lbC0007CE	MOVE.B	D1,(A3,D3.W)	; Write the byte
;	BRA.B	lbC000768

;lbC0007D4	MOVE.W	D1,(A3,D3.W)	; Write the word
;	BRA.B	lbC000768

;lbC0007DA	MOVE.L	D1,(A3,D3.W)	; Write the long
;	BRA.B	lbC000768

; Same code, so save some ROM...
;lbC0007E0	MOVE.L	D4,D0		; Get result
;	MOVEM.L	(SP)+,D2-D4/A2-A4	; Restore
;	RTS				; Exit!

PackStructureTags
	movem.l	D2-D5/A3-A4,-(SP)	; Save these
	moveq	#0,D4			; Clear count
	move.l	A0,A3			; Get structure
	move.l	A1,A4			; Get table...
	moveq	#-1,D5
pst_BaseTag
	move.l	(A4)+,D2		; Base tag value...
pst_Main
	move.l	(A4)+,D3		; Get next table entry
	beq.b	pst_Done		; branch to exit if NULL
	cmp.l	D5,D3			; Check for -1
	beq.b	pst_BaseTag		; If -1, get new base tag
	btst	#$1D,D3			; Check if we can pack this
	bne.b	pst_Main		; Nope, so skip it...
	move.l	D3,D0			; Get table value into d0
	swap	D0			; Get high word at bottom
	and.l	#$3FF,D0		; Mask out unused bits
	add.l	D2,D0			; Add in base tag
	move.l	A2,A0			; Get tag list
	bsr.w	FindTagItem		; Search for the tag (CCR is set)
	beq.b	pst_Main		; No tag in list, so next...
	addq.l	#1,D4			; Count match...
	move.l	D0,A0			; Pointer to tag item...
	move.l	4(A0),D1		; Get ti_Data...
	move.l	A3,A1
	add.w	D3,A1			; set destination
	moveq	#27,D0
	btst	#28,D3
	beq.b	pst_Word
	btst	D0,D3
	beq.b	pst_Long
pst_Bit
	and.w	#$E000,D3		; mask bits 13-15
	sub.w	D3,A1			; correct destination
	rol.w	#3,D3			; Get bit number into bits 0-2
	btst	#$1A,D3			; Check for EXISTS hack thingy
	bne.b	pst_BSET		; If EXISTS hack, assume TRUE...
	tst.l	D1			; False=clear bit (inverted if signed)
	beq.b	pst_BCLR
pst_BSET
	bset	D3,(A1)			; Set the bit
	bra.b	pst_BitInvert		; Check for inverted boolean

pst_BCLR
	bclr	D3,(A1)			; Clear the bit
pst_BitInvert
	tst.l	D3			; Check for SIGNED bit
	bpl.b	pst_Main		; If signed we will invert the meaning
	bchg	D3,(A1)			; Invert the bit
	bra.b	pst_Main

pst_Byte
	move.b	D1,(A1)			; Write the byte
	bra.b	pst_Main

pst_Word
	btst	D0,D3
	beq.b	pst_Byte
	move.w	D1,(A1)			; Write the word
	bra.b	pst_Main

pst_Long
	move.l	D1,(A1)			; Write the long
	bra.b	pst_Main

; Same code, so save some ROM...
pst_Done
	move.l	D4,D0			; Get result
	movem.l	(SP)+,D2-D5/A3-A4	; Restore
	rts				; Exit!

*
******* utility.library/UnpackStructureTags ***********************************
*
*   NAME
*	UnpackStructureTags -- unpack a structure to values in taglist. (V39)
*
*   SYNOPSIS
*	num = UnpackStructureTags(pack,packTable,tagList);
*	D0                        A0   A1        A2
*
*	ULONG UnpackStructureTags(APTR,ULONG *,struct TagItem *);
*
*   FUNCTION
*	For each table entry, a FindTagItem() will be done and if the
*	matching tag is found in the taglist, the data in the structure
*	will be placed into the memory pointed to by the tag's ti_Data.
*	ti_Data *must* point to a LONGWORD.
*
*   INPUTS
*	pack - a pointer to the data area to be unpacked
*	packTable - a pointer to the packing information table.
*		    See <utility/pack.h> for definition and macros
*	tagList - a pointer to the taglist to unpack into
*
*   RESULTS
*	num - the number of tag items unpacked
*
*   SEE ALSO
*	<utility/pack.h>, FindTagItem(), PackStructureTags()
*
*******************************************************************************
*
*
* Registers:
*	a2 - Tag list (as passed in)
*	a3 - Structure (a0 parameter)
*	a4 - Current table location
*	d2 - Base tag value
*	d3 - Data offset (from table)
*	d4 - Count of packed values
*

;UnpackStructureTags
;	MOVEM.L	D2-D4/A2-A4,-(SP)	; Save these
;	MOVEQ	#0,D4			; Clear count
;	MOVEA.L	A0,A3			; Get structure
;	MOVEA.L	A1,A4			; Get table...
;lbC0007F2
;	MOVE.L	(A4)+,D2		; Get base tage value...
;lbC0007F4
;	MOVE.L	(A4)+,D3		; Get table value...
;	BEQ.B	lbC0007E0		; If NULL, we are done...
;	ADDQ.L	#1,D3			; Check for -1
;	BEQ.B	lbC0007F2		; If -1, get new base tag
;	SUBQ.L	#1,D3			; back to normal
;	BTST	#$1E,D3			; Check if we can unpack this
;	BNE.B	lbC0007F4		; Nope, so skip it...
;	MOVE.L	D3,D0			; Get table value into d0
;	SWAP	D0			; Get high word at bottom
;	AND.L	#$3FF,D0		; Mask out unused bits
;	ADD.L	D2,D0			; Add in base tag
;	MOVEA.L	A2,A0			; Get tag list
;	JSR	(-$1E,A6)		; Search for the tag
;	TST.L	D0			; Did we get it?
;	BEQ.B	lbC0007F4		; No tag in list, so next...
;	ADDQ.L	#1,D4			; Count match...
;	MOVEA.L	D0,A0			; Get into address register
;	MOVEA.L	(4,A0),A0		; Get pointer to real answer (ti_Data)
;	MOVEQ	#0,D1			; Clear d1
;	MOVE.L	D3,D0			; Get table value again
;	ROL.L	#6,D0			; Move up and around into low
;	AND.W	#6,D0			; Mask everything else
;	JMP	(lbC000830,PC,D0.W)	; Do jumptable...

*
* Table of size operators in PackStructureTags
*

;lbC000830
;	BRA.B	lbC00084E		; 2 bytes (00 0)

;	BRA.B	lbC00085C		; 2 bytes (01 0)

;	BRA.B	lbC000868		; 2 bytes (10 0)

					; fall-in (11 0)
;	MOVE.W	D3,D0			; Get value...
;	ROL.W	#3,D0			; Get bit number into bits 0-2
;	AND.W	#$1FFF,D3		; Mask out bit number
;	BTST	D0,(A3,D3.W)		; Check the bit
;	BEQ.B	lbC000846		; Bit off?
;	NOT.L	D1			; Bit on...  Set result to TRUE
;lbC000846	TST.L	D3		; Check for signed bit
;	BPL.B	lbC00086C		; All ok, so just store it
;	NOT.L	D1			; Invert boolean
;	BRA.B	lbC00086C		; Store result

;lbC00084E
;	MOVE.B	(A3,D3.W),D1		; Write the byte
;	TST.L	D3			; Check for signed
;	BPL.B	lbC00086C		; If unsigned, just go
;	EXT.W	D1			; Sign extend
;	EXT.L	D1			; since this is signed
;	BRA.B	lbC00086C

;lbC00085C
;	MOVE.W	(A3,D3.W),D1		; Write the word
;	TST.L	D3			; Check for signed
;	BPL.B	lbC00086C		; If unsigned, just go
;	EXT.L	D1			; Sign extend it
;	BRA.B	lbC00086C

;lbC000868	MOVE.L	(A3,D3.W),D1	; Write the long
					; Fall into the store operation
;lbC00086C	MOVE.L	D1,(A0)		; Store the result
;	BRA.B	lbC0007F4

UnpackStructureTags
	movem.l	D2-D5/A3-A4,-(SP)	; Save these
	moveq	#0,D4			; Clear count
	move.l	A0,A3			; Get structure
	move.l	A1,A4			; Get table...
	moveq	#-1,D5
ust_BaseTag
	move.l	(A4)+,D2		; Get base tage value...
ust_Main
	move.l	(A4)+,D3		; Get table value...
	beq.b	pst_Done		; If NULL, we are done...
	cmp.l	D5,D3			; Check for -1
	beq.b	ust_BaseTag		; If -1, get new base tag
	btst	#$1E,D3			; Check if we can unpack this
	bne.b	ust_Main		; Nope, so skip it...
	move.l	D3,D0			; Get table value into d0
	swap	D0			; Get high word at bottom
	and.l	#$3FF,D0		; Mask out unused bits
	add.l	D2,D0			; Add in base tag
	move.l	A2,A0			; Get tag list
	bsr.w	FindTagItem		; Search for the tag (CCR is set)
	beq.b	ust_Main		; No tag in list, so next...
	addq.l	#1,D4			; Count match...
	move.l	D0,A0			; Get into address register
	move.l	4(A0),A0		; Get pointer to real answer (ti_Data)
	moveq	#0,D1			; Clear d1
	move.l	A3,A1
	add.w	D3,A1			; set destination
	moveq	#27,D0
	btst	#28,D3
	beq.b	ust_Word
	btst	D0,D3
	beq.b	ust_Long

ust_Bit
	and.w	#$E000,D3		; mask bits 13-15
	sub.w	D3,A1			; correct destination
	rol.w	#3,D3			; Get bit number into bits 0-2
	btst	D3,(A1)			; Check the bit
	beq.b	ust_False		; Bit off?
	not.l	D1			; Bit on...  Set result to TRUE
ust_False
	tst.l	D3			; Check for signed bit
	bpl.b	ust_Store		; All ok, so just store it
	not.l	D1			; Invert boolean
	bra.b	ust_Store		; Store result

ust_Byte
	move.b	(A1),D1			; Write the byte
	tst.l	D3			; Check for signed
	bpl.b	ust_Store		; If unsigned, just go
	ext.w	D1			; Sign extend
ust_Extend
	ext.l	D1			; since this is signed
	bra.b	ust_Store

ust_Word
	btst	D0,D3
	beq.b	ust_Byte
	move.w	(A1),D1			; Write the word
	tst.l	D3			; Check for signed
	bmi.b	ust_Extend		; If signed, just sign extend it
ust_Store				; Fall into the store operation
	move.l	D1,(A0)			; Store the result
	bra.b	ust_Main

ust_Long
	move.l	(A1),(A0)		; Write the long
	bra.b	ust_Main

******* utility.library/NamedObjectName ***************************************
*
*   NAME
*	NamedObjectName -- return the name of the object. (V39)
*
*   SYNOPSIS
*	name = NamedObjectName(object);
*	D0                     A0
*
*	STRPTR NamedObjectName(struct NamedObject *);
*
*   FUNCTION
*	Returns the name of the object passed in...
*	Note that the name string is passed back as just a pointer to
*	a read-only name. If the object goes away, so does the name.
*
*   INPUTS
*	object - the object, may be NULL in which case this function
*		 returns NULL.
*
*   RESULT
*	name - pointer to the name string, or NULL if 'object' is NULL.
*
*   SEE ALSO
*	FindNamedObject(), RemNamedObject()
*
*******************************************************************************

NamedObjectName
	move.l	A0,D0		; Check for NULL object
	beq.b	NONExit		; Exit if no object
	move.l	-6(A0),D0	; Get name pointer
NONExit
	rts

******* utility.library/FindNamedObject ***************************************
*
*   NAME
*	FindNamedObject -- find the next object of a given name. (V39)
*
*   SYNOPSIS
*	object = FindNamedObject(nameSpace, name, lastObject);
*	D0                       A0         A1    A2
*
*	struct NamedObject *FindNamedObject(struct NamedObject *, STRPTR,
*					    struct NamedObject *);
*
*   FUNCTION
*	Finds an object and adds to the open count of the object. The
*	object is guaranteed not to be freed until ReleaseNamedObject() is
*	called. The name comparison is caseless, using the current
*	locale string comparison routines.
*
*	If name is NULL, then all objects will be matched.
*
*	If lastObject is non-NULL, it must be an object from the same
*	NameSpace found on a previous call to FindNamedObject(). It
*	will not be freed by this call. The search will start at the
*	node after lastobject, if non-NULL.
*
*	nameSpace is the name space from the named object given
*	or the root name space if NULL is given.
*
*   INPUTS
*	nameSpace - the name space to search
*	name - the name of the object to search for
*	lastObject - the starting point for the search or NULL
*
*   RESULT
*	object - the first match found, or NULL for no match
*
*   SEE ALSO
*	ReleaseNamedObject(), <utility/name.h>
*
*******************************************************************************

;FindNamedObject	MOVEM.L	D2/A2-A5,-(SP)
;	MOVEA.L	($24,A6),A5		; Get execbase into a5...
;	BSR.B	lbC000900		; Get namespace
;	EXG	A5,A6			; a5/a6 are swapped...
;	BEQ.B	lbC0008BA		; We have no name space, exit
;	MOVEA.L	D0,A3			; Get namespace...
;	MOVEA.L	A1,A4			; name
; so no one modifies the namespace while we're scanning
;	LEA	(12,A3),A0		; ns_Semaphore
;	JSR	(-$2A6,A6)		; Obtain the semaphore... (ObtainSemaphoreShared)
; find object to start search at
;	MOVE.L	A2,D0			; if lastobject
;	BEQ.B	lbC00089E
;	MOVEA.L	(-$10,A2),A2		; nos_Node+LN_SUCC
;	BRA.B	lbC0008A2

;lbC00089E	MOVEA.L	(0,A3),A2	; ns_Entries+LH_HEAD

; At this point a2 is a pointer to the real name object stuff
; (That is, it no longer is the black-box nos object)
; search the namespace (if needed) for an object

;lbC0008A2	BSR.B	lbC0008C2	; a2/a3/a4/a6, returns a2!
;	MOVE.L	A2,D0			; object or NULL
;	BEQ.B	lbC0008B0

; OK! we have a node to return
; no race condition because this is 1 instruction!!!!
; if this were more, a FORBID would be needed

;	ADDQ.W	#1,(14,A2)
;	LEA	($10,A2),A2		; Move down to the object
;lbC0008B0	LEA	(12,A3),A0
;	JSR	(-$23A,A6)		; ReleaseSemaphore
;	MOVE.L	A2,D0			; return object or NULL
;lbC0008BA	EXG	A5,A6		; Get utilitybase back
;	MOVEM.L	(SP)+,D2/A2-A5		; Restore...
;	RTS

;==============================================================================
; object = search_ns (initial_object, namespace, name, utilitybase, execbase)
;   a2		          a2             a3       a4      a5           a6
;
; Search a namespace for a name match.  return the node or NULL in a2!!!
; The search starts at initial_object.  If name is NULL returns the next
; object if any or NULL.  (trashes d2!!!)
;==============================================================================

;lbC0008C2	MOVE.L	A4,D0		; no name, match anything
;	BEQ.B	lbC0008F6
;	BTST	#1,($3D,A3)
;	BEQ.B	lbC0008DE		; Check if not case sensitive

* Simple findname...

;	MOVEA.L	A4,A1
;	MOVEA.L	(4,A2),A0		; Get one before me...
;	JSR	(-$114,A6)		; Find the next node...
;	MOVEA.L	D0,A2			; Here it is...
;	RTS

;lbC0008DC	MOVEA.L	D2,A2		; Get next node...
;lbC0008DE	MOVE.L	(0,A2),D2	; save next node for later
;	BEQ.B	lbC0008FC		; failed, exit

; compare without case

;	MOVEA.L	(10,A2),A0
;	MOVEA.L	A4,A1			; String to match...
;	EXG	A5,A6			; Get utilitybase...
;	JSR	(-$A2,A6)		; Stricmp
;	EXG	A5,A6			; Restore execbase...
;	TST.L	D0
;	BNE.B	lbC0008DC		; not the same, loop
;lbC0008F6	TST.L	(0,A2)		; is this a real node?
;	BNE.B	lbC0008FE		; yes, we found it.  return
; Failure - return NULL
;lbC0008FC	SUBA.L	A2,A2		; a2 is return code!
;lbC0008FE	RTS

*******************************************************************************
*
* Internal use:  Pass an object in a0, returns the namespace in d0
* If a0 is NULL, returns a root name space...
* Flags set on exit...
* a6 *must* be utilitybase

;lbC000900	MOVE.L	A0,D0		; Check for object...
;	BNE.B	lbC000908		; We have a live one (non-NULL)
;	MOVEA.L	($28,A6),A0		; Root space
;lbC000908	MOVE.L	(4,A0),D0
;	RTS				; Return with namespace in d0

*
******* utility.library/AddNamedObject ****************************************
*
*   NAME
*	AddNamedObject -- add a named object to the given namespace. (V39)
*
*   SYNOPSIS
*	success = AddNamedObject(nameSpace, object);
*	D0			 A0         A1
*
*	BOOL AddNamedObject(struct NamedObject *, struct NamedObject *);
*
*   FUNCTION
*	Adds a new item to a NameSpace.  If the NameSpace doesn't support
*	duplicate names, a search for a duplicate will be made, and
*	0 (failure) will be returned.  Otherwise, the entry will be
*	Enqueue()ed to the NameSpace.
*
*   INPUTS
*	nameSpace - the name space to add to (NULL for root namespace)
*	object - the object to add  (If NULL, will return failure)
*
*   RESULT
*	success - whether the operation succeeded.  Check this always!
*
*   SEE ALSO
*	AttemptRemNamedObject(), RemNamedObject()

;AddNamedObject	MOVEM.L	D2-D4/A2-A5,-(SP)
;	BSR.B	lbC000900		; Get the namespace
;	BEQ.B	lbC000966		; No namespace?
;	MOVEA.L	D0,A3			; Get namespace...
;	MOVE.L	A1,D0			; Check object...
;	BEQ.B	lbC000966		; False if NULL object...
;	LEA	(-$10,A1),A2		; object to add
;	MOVEA.L	($24,A6),A5		; Get execbase...
;	EXG	A5,A6
;	LEA	(12,A3),A0
;	JSR	(-$234,A6)		; Get the semaphore...

; do we need to check for dups?

;	BTST	#0,($3D,A3)
;	BEQ.B	lbC00094A
; search for dups

;	MOVEA.L	(10,A2),A4		; name of object we're adding
;	MOVE.L	A2,D3			; save object ptr
;	MOVEA.L	(0,A3),A2		; first entry to search
;	BSR.B	lbC0008C2		; a2/a3/a4/a5, returns a2!!!!
;	MOVEQ	#0,D4			; default result = FALSE
;	MOVE.L	A2,D0			; Check failure...
;	BNE.B	lbC00095A		; cleanup & exit on failure
;	MOVEA.L	D3,A2			; get object back

; enqueue the object into the namespace

;lbC00094A	LEA	(0,A3),A0	; Get entries list...
;	MOVEA.L	A2,A1
;	JSR	(-$10E,A6)		; Enqueue onto list...
;	MOVE.L	A3,($14,A2)		; remember which namespace
;	MOVEQ	#-1,D4			; success
;lbC00095A	LEA	(12,A3),A0
;	JSR	(-$23A,A6)		; Release our lock...
;	MOVE.L	D4,D0			; result
;	EXG	A5,A6			; Get utility base back...
;lbC000966	MOVEM.L	(SP)+,D2-D4/A2-A5
;	RTS

FindNamedObject
	bsr.b	getNameSpace		; Get namespace
	beq.b	fno_Exit		; We have no name space, exit
	movem.l	D4/A2-A4/A6,-(SP)
	move.l	$24(A6),A6		; Get execbase into a6...
	move.l	D0,A3			; Get namespace...
	move.l	A1,A4			; name
; so no one modifies the namespace while we're scanning
	lea	12(A3),A0		; ns_Semaphore
	jsr	-$2A6(A6)		; Obtain the semaphore... (ObtainSemaphoreShared)
; find object to start search at
	move.l	A2,D0			; if lastobject
	beq.b	fno_Last
	move.l	-$10(A2),A2		; nos_Node+LN_SUCC
	bra.b	fno_Skip

fno_Last
	move.l	(A3),A2			; ns_Entries+LH_HEAD

; At this point a2 is a pointer to the real name object stuff
; (That is, it no longer is the black-box nos object)
; search the namespace (if needed) for an object

fno_Skip
	bsr.b	search_ns		; a2/a3/a4/a6, returns a2!
	move.l	A2,D0			; object or NULL
	beq.b	release_sem

; OK! we have a node to return
; no race condition because this is 1 instruction!!!!
; if this were more, a FORBID would be needed

	addq.w	#1,14(A2)
	lea	$10(A2),A2		; Move down to the object
release_sem
	lea	12(A3),A0
	jsr	-$23A(A6)		; ReleaseSemaphore
	move.l	A2,D0			; return object or NULL
	movem.l	(SP)+,D4/A2-A4/A6	; Restore...
fno_Exit
	rts

search_ns
	move.l	A4,D0			; no name, match anything
	beq.b	match
	btst	#1,$3D(A3)
	beq.b	object_loop		; Check if not case sensitive

* Simple findname...

	move.l	A4,A1
	move.l	4(A2),A0		; Get one before me...
	jsr	-$114(A6)		; Find the next node...
	move.l	D0,A2			; Here it is...
	rts

no_match
	move.l	D4,A2			; Get next node...
object_loop
	move.l	(A2),D4			; save next node for later
	beq.b	not_found		; failed, exit

; compare without case

	move.l	10(A2),A0
	move.l	A4,A1			; String to match...
	bsr.w	Stricmp
	bne.b	no_match		; not the same, loop
match
	tst.l	(A2)			; is this a real node?
	bne.b	found			; yes, we found it.  return
; Failure - return NULL
not_found
	sub.l	A2,A2			; a2 is return code!
found
	rts

getNameSpace
	move.l	A0,D0			; Check for object...
	bne.b	gns_LiveOne		; We have a live one (non-NULL)
	move.l	$28(A6),A0		; Root space
gns_LiveOne
	move.l	4(A0),D0
	rts				; Return with namespace in d0

AddNamedObject
	bsr.b	getNameSpace		; Get the namespace
	beq.b	ano_Null		; No namespace?
	movem.l	D4/A2-A6,-(SP)
	move.l	D0,A3			; Get namespace...
	move.l	A1,D0			; Check object...
	beq.b	ano_Exit		; False if NULL object...
	lea	-$10(A1),A5		; object to add
	move.l	$24(A6),A6		; Get execbase...
	lea	12(A3),A0
	jsr	-$234(A6)		; Get the semaphore...

; do we need to check for dups?

	btst	#0,$3D(A3)
	beq.b	enqueue_it
; search for dups

	move.l	10(A5),A4		; name of object we're adding
	move.l	(A3),A2			; first entry to search
	bsr.b	search_ns		; a2/a3/a4/a6, returns a2!!!!
	moveq	#0,D4			; default result = FALSE
	move.l	A2,D0			; Check failure...
	bne.b	cleanup			; cleanup & exit on failure

; enqueue the object into the namespace

enqueue_it
	move.l	A3,A0			; Get entries list...
	move.l	A5,A1
	jsr	-$10E(A6)		; Enqueue onto list...
	move.l	A3,$14(A5)		; remember which namespace
	moveq	#-1,D4			; success
cleanup
	lea	12(A3),A0
	jsr	-$23A(A6)		; Release our lock...
	move.l	D4,D0			; result
ano_Exit
	movem.l	(SP)+,D4/A2-A6
ano_Null
	rts

******* utility.library/AttemptRemNamedObject *********************************
*
*   NAME
*	AttemptRemNamedObject -- attempt to remove a named object. (V39)
*
*   SYNOPSIS
*	result = AttemptRemNamedObject(object);
*	D0                             A0
*
*	LONG AttemptRemNamedObject(struct NamedObject *);
*
*   FUNCTION
*	Attempts to remove an object from whatever NameSpace it's in.
*	You must have found the object first (in order to get a use count)
*	before trying to remove it.  If the object is in use or is
*	in the process of being removed, this function will return
*	a failure code.  If the object is fully removed, the object will
*	then be available to be FreeNamedObject().
*
*   INPUTS
*	object - the object to attempt to remove  The object must be valid
*
*   RESULT
*	success - FALSE if object is still in use (somewhere)
*	          TRUE if object was removed
*
*   SEE ALSO
*	RemNamedObject(), AddNamedObject(), ReleaseNamedObject()
*
*******************************************************************************

AttemptRemNamedObject
	sub.l	A1,A1			; no message

; fall through...

******* utility.library/RemNamedObject ****************************************
*
*   NAME
*	RemNamedObject -- remove a named object. (V39)
*
*   SYNOPSIS
*	RemNamedObject(object, message);
*	               A0      A1
*
*	VOID RemNamedObject(struct NamedObject *, struct Message *);
*
*   FUNCTION
*	This function will post a request to release the object
*	from whatever NameSpace it is in.  It will reply the message
*	when the object is fully removed.  The message.mn_Node.ln_Name
*	field will contain the object pointer or NULL if the object
*	was removed by another process.
*
*	This function will effectively do a ReleaseNamedObject()
*	thus you must have "found" the object first.
*
*   INPUTS
*	object - the object to remove: Must be a valid NamedObject.
*	message - message to ReplyMsg() (must be supplied)
*
*   RESULT
*	The message is replied with the ln_Name field either being
*	the object or NULL. If it contains the object, the object
*	is completely removed.
*
*   SEE ALSO
*	AttemptRemNamedObject(), AddNamedObject(), ReleaseNamedObject()
*
*******************************************************************************

;RemNamedObject
;	MOVEM.L	D2/A2-A4/A6,-(SP)	; Save
;	MOVEA.L	($24,A6),A6		; Get ExecBase
;	ADDQ.B	#1,($127,A6)		; Protect this... (Forbid)
;	MOVEA.L	A1,A4			; Save message
;	MOVEA.L	A0,A2			; Get node...
;	MOVE.L	(4,A2),D0		; Get NameSpace
;	BEQ.B	lbC000992		; If null, NameSpace is gone...
;	MOVEA.L	D0,A3			; Save namespace in a3
;	MOVE.L	A4,D0			; Check for message
;	BNE.B	lbC0009AA		; Do the remove if message...
;	CMPI.W	#1,(-2,A2)		; Check if last user
;	BEQ.B	lbC0009AA		; If last one, we remove...
;lbC000992	MOVE.L	A4,D0		; Check if message
;	BEQ.B	lbC0009A0		; No message, just exit...
;	CLR.L	(10,A4)			; Clear LN_NAME
;	MOVEA.L	A4,A1			; Get message into right reg
;	JSR	(-$17A,A6)		; Return it with NULL LN_NAME (ReplyMsg)
; Note that d0 is 0 if there is no message  ;^)
;lbC0009A0	JSR	(-$8A,A6)	; Permit
;	MOVEM.L	(SP)+,D2/A2-A4/A6	; Return failure!
;	RTS

;lbC0009AA	CLR.L	(4,A2)		; Clear namespace backpointer
;	LEA	(12,A3),A0		; Get the semaphore
;	JSR	(-$234,A6)		; (lock the namespace) ObtainSemaphore
;	LEA	(-$10,A2),A1		; Get node...
;	JSR	(-$FC,A6)		; Remove it...
;	MOVE.L	A4,(8,A2)		; Set and check message...
;	BEQ.B	lbC0009C8		; If none, we are almost done
;	MOVE.L	A2,(10,A4)		; Set LN_NAME of message
;lbC0009C8	LEA	(12,A3),A0	; Get semaphore
;	JSR	(-$23A,A6)		; Let it go...
;	JSR	(-$8A,A6)		; System free... (Permit)
;	MOVEA.L	A2,A0			; Get object into a0
;	MOVEM.L	(SP)+,D2/A2-A4/A6	; Restore registers...
; Drop into releasenamedobject...  (below)

RemNamedObject
	move.l	A6,-(SP)		; Save
	move.l	$24(A6),A6		; Get ExecBase
	addq.b	#1,$127(A6)		; Protect this... (Forbid)
	move.l	4(A0),D1		; Get NameSpace
	beq.b	rno_NameSpace		; If null, NameSpace is gone...
	move.l	A1,D0			; Check for message
	bne.b	rno_DoRemove		; Do the remove if message...
	cmp.w	#1,-2(A0)		; Check if last user
	beq.b	rno_DoRemove		; If last one, we remove...
rno_NameSpace
	move.l	A1,D0			; Check if message
	beq.b	rno_FailOut		; No message, just exit...
	clr.l	10(A1)			; Clear LN_NAME
	jsr	-$17A(A6)		; Return it with NULL LN_NAME (ReplyMsg)
; Note that d0 is 0 if there is no message  ;^)
rno_FailOut
	jsr	-$8A(A6)		; Permit
	move.l	(SP)+,A6		; Return failure!
	rts

rno_DoRemove
	movem.l	A0/A2-A4,-(SP)		; Save
	move.l	A0,A2			; Get node...
	move.l	A1,A4			; Save message
	move.l	D1,A3			; Save namespace in a3
	clr.l	4(A2)			; Clear namespace backpointer
	lea	12(A3),A0		; Get the semaphore
	jsr	-$234(A6)		; (lock the namespace) ObtainSemaphore
	lea	-$10(A2),A1		; Get node...
	jsr	-$FC(A6)		; Remove it...
	move.l	A4,8(A2)		; Set and check message...
	beq.b	rno_NoMessage		; If none, we are almost done
	move.l	A2,10(A4)		; Set LN_NAME of message
rno_NoMessage
	lea	12(A3),A0		; Get semaphore
	jsr	-$23A(A6)		; Let it go...
	jsr	-$8A(A6)		; System free... (Permit)
	movem.l	(SP)+,A0/A2-A4/A6	; Restore registers... & Get object into a0
; Drop into releasenamedobject...  (below)

******* utility.library/ReleaseNamedObject ************************************
*
*   NAME
*	ReleaseNamedObject -- free a named object. (V39)
*
*   SYNOPSIS
*	ReleaseNamedObject(object);
*			   A0
*
*	VOID ReleaseNamedObject(struct NamedObject *);
*
*   FUNCTION
*	Decrements the open count of the object. If the object has been
*	removed, and the count goes to 0, the remover will be notified
*	that the object is now free.
*
*   INPUTS
*	object - the object to release.  (No action if NULL)
*
*   SEE ALSO
*	FindNamedObject(), RemNamedObject()
*
*******************************************************************************

;ReleaseNamedObject
;	MOVE.L	A6,-(SP)		; Save on stack
;	MOVEA.L	($24,A6),A6		; Get ExecBase
;	ADDQ.B	#1,($127,A6)		; Forbid
;	MOVE.L	A0,D0			; Check for silly case
;	BEQ.B	lbC0009FA		; (Silly... NULL)
;	SUBQ.W	#1,(-2,A0)
;	BNE.B	lbC0009FA		; If not 0, exit...
;	MOVE.L	(8,A0),D0
;	BEQ.B	lbC0009FA		; Check for message
;	MOVEA.L	D0,A1			; Ready for ReplyMsg
;	JSR	(-$17A,A6)		; Do it!
;lbC0009FA	JSR	(-$8A,A6)	; Permit
;	MOVEA.L	(SP)+,A6		; Restore utilitybase
;	MOVEQ	#1,D0			; Return TRUE for Attempt...
;lbC000A02	RTS			; exit...

ReleaseNamedObject
	move.l	A0,D0			; Check for silly case
	beq.b	rno_Null		; (Silly... NULL)
	move.l	A6,-(SP)		; Save on stack
	move.l	$24(A6),A6		; Get ExecBase
	addq.b	#1,$127(A6)		; Forbid
	subq.w	#1,-2(A0)
	bne.b	rno_Exit		; If not 0, exit...
	move.l	8(A0),D0
	beq.b	rno_Exit		; Check for message
	move.l	D0,A1			; Ready for ReplyMsg
	jsr	-$17A(A6)		; Do it!
rno_Exit
	jsr	-$8A(A6)		; Permit
	move.l	(SP)+,A6		; Restore utilitybase
rno_Null
	moveq	#1,D0			; Return TRUE for Attempt...
any_rts
	rts				; exit...

******* utility.library/AllocNamedObjectA *************************************
*
*   NAME
*	AllocNamedObjectA -- allocate a named object. (V39)
*
*   SYNOPSIS
*	object = AllocNamedObjectA(name, tagList);
*	D0                         A0    A1
*
*	struct NamedObject *AllocNamedObjectA(STRPTR, struct TagItem *);
*
*	object = AllocNamedObject(name, Tag1, ...);
*
*	struct NamedObject *AllocNamedObject(STRPTR, ULONG, ...);
*
*   FUNCTION
*	Allocates a NamedObject and initializes it as needed to the
*	name given. This object can then be used as an object in the
*	namespaces. Tags can be given to make an object contain a
*	namespace such that nested namespaces can be built.
*	When the object is allocated, it automatically has one use.
*	If you later wish to release this object such that others may
*	remove it from the namespace you must do a ReleaseNamedObject().
*
*   INPUTS
*	name - name for the object (must not be NULL)
*	tagList - tags with additional information for the allocation or NULL
*
*   TAGS
*	ANO_NameSpace - BOOL tag, default FALSE.  If this tag is
*	                TRUE, the named object will also have a
*	                name space attached to it.
*	ANO_UserSpace - ULONG tag, default 0.  If this tag is non-NULL
*	                it defines the size (in bytes) of the user
*	                space to be allocated with the named object
*	                and that will be pointed to by the no_Object
*	                pointer.  This memory is long-word aligned.
*	                If no space is defined, no_Object will be NULL.
*	ANO_Priority  - BYTE tag, default 0.  This tag lets you pick
*	                a priority for the named object for when it is
*	                placed into a name space.
*	ANO_Flags     - ULONG tag, default 0.  This tag lets you set
*	                the flags of the NameSpace (if you allocated
*	                one)  There currently are only TWO flags.
*	                Do *NOT* set *any* other bits as they are for
*	                future use!!!  (You can't read them anyway)
*	                The flags are:
*	                NSF_NODUPS	- Name space must be unique.
*	                NSF_CASE	- Name space is case sensitive
*
*   RESULT
*	object - the object allocated, or NULL for failure. The object
*	         is defined as a pointer to a pointer.  You can do what you
*	         wish with the pointer. (It may be NULL or contain a pointer
*	         to memory that you had asked for in the tags.)
*
*   SEE ALSO
*	FreeNamedObject(), <utility/name.h>
*
*******************************************************************************

;AllocNamedObjectA
;	MOVE.L	A0,D0			; Check for NULL name
;	BEQ.B	lbC000A02		; exit it NULL...
;	MOVEM.L	D2/D3/A2/A3/A5,-(SP)	; Save as needed
;	MOVEA.L	($24,A6),A5		; Get execbase
;	MOVEA.L	A0,A2			; Get string pointer...
;	MOVEA.L	A1,A3			; Get tags...
;	MOVE.L	#$FA0,D0		; Check for namespace (ANO_NameSpace)
;	MOVEQ	#0,D1			; Default value
;	MOVEA.L	A3,A0			; Taglist
;	JSR	(-$24,A6)		; Get the data
;	MOVE.L	D0,D3			; Check if real...
;	BEQ.B	lbC000A2C		; If FALSE, skip...
;	MOVE.L	#$3E,D3			; Get namespace size
;lbC000A2C	MOVE.L	#$FA1,D0	; Check for user space
;	MOVEQ	#0,D1			; default none...
;	MOVEA.L	A3,A0			; Tag list
;	JSR	(-$24,A6)		; Get the data...
;	MOVE.L	D0,D2			; save it...
;	BEQ.B	lbC000A40		; If none, we skip...
;	ADDQ.L	#3,D2			; Bump to long align it...
;lbC000A40	MOVE.L	#$1C,D0		; Root object size
;	MOVEA.L	A2,A0			; Get string again...
;lbC000A48	ADDQ.L	#1,D0		; Count one...
;	TST.B	(A0)+			; Check next byte...
;	BNE.B	lbC000A48		; Count it (+1 for NULL)
;	ADD.L	D3,D0			; Add in the namespace
;	ADD.L	D2,D0			; Add in the user data
;	MOVE.L	#$10001,D1		; MEMF_PUBLIC|MEMF_CLEAR
;	EXG	A6,A5			; Execbase now...
;	JSR	(-$2AC,A6)		; Get the memory (AllocVec)
;	EXG	A6,A5			; swap back...
;	TST.L	D0			; Check for memory
;	BEQ.B	lbC000ADC		; Exit if no memory...

* Check for namespace...

;	MOVEA.L	D0,A0			; Get pointer...
;	MOVEQ	#$1C,D0			; Get size of root object
;	ADD.L	A0,D0			; Point past root object
;	TST.L	D3			; Check for name space
;	BEQ.B	lbC000A74		; Skip if no name space
;	MOVE.L	D0,($14,A0)		; Store it...
;	ADD.L	D3,D0			; Get address of namespace

* Install and copy the name string

;lbC000A74	MOVE.L	D0,(10,A0)	; Store name...
;	MOVEA.L	D0,A1			; Get string pointer...
;lbC000A7A	MOVE.B	(A2)+,(A1)+	; Copy the string...
;	BNE.B	lbC000A7A
;	LEA	($10,A0),A2		; Get return result...
;	TST.L	D2			; Do we have user data?
;	BEQ.B	lbC000A94		; If not, skip...
;	MOVEQ	#3,D0			; Get mask...
;	ADDA.L	D0,A1			; bump up...
;	NOT.L	D0			; Flip it
;	MOVE.L	A1,D1			; Into data reg...
;	AND.L	D1,D0			; (wish we could do AND A1,D0)
;	MOVE.L	D0,(0,A2)		; Store object pointer...

* Now, if namespace, we will init it...

;lbC000A94	MOVEA.L	A3,A0		; Get tag list
;	MOVEQ	#0,D1			; Get default flags
;	MOVE.L	#$FA3,D0		; Get flags tag
;	JSR	(-$24,A6)		; Get the data into d0
;	MOVE.L	(4,A2),D1		; Get namespace?
;	BEQ.B	lbC000AC4		; Skip this if none...
;	MOVEA.L	D1,A0			; Get pointer to object
;	MOVE.L	D0,($3A,A0)		; Set the flags...
;	MOVE.L	A0,(8,A0)		; NameSpace LIST at top
;	ADDQ.L	#4,A0
;	CLR.L	(A0)
;	MOVE.L	A0,-(A0)
;	LEA	(12,A0),A0		; Get semaphore
;	EXG	A5,A6			; Get execbase...
;	JSR	(-$22E,A6)		; initialize (InitSemaphore)
;	EXG	A5,A6			; swap utilitybase back...
;lbC000AC4	MOVEA.L	A3,A0		; Get tag list
;	MOVEQ	#0,D1			; Default priority
;	MOVE.L	#$FA2,D0		; Priority tag
;	JSR	(-$24,A6)		; Get the data
;	MOVE.B	D0,(-7,A2)		; Set the priority...
;	ADDQ.W	#1,(-2,A2)		; Bump use count...
;	MOVE.L	A2,D0			; Get return result...
;lbC000ADC
;	MOVEM.L	(SP)+,D2/D3/A2/A3/A5	; Restore
;	RTS				; exit...

AllocNamedObjectA
	move.l	A0,D0			; Check for NULL name
	beq.b	any_rts		; exit it NULL...
	movem.l	D2/D3/A2/A3/A4/A6,-(SP)	; Save as needed
	move.l	$24(A6),A6		; Get execbase
	move.l	A0,A2			; Get string pointer...
	move.l	A1,A3			; Get tags...
	lea	$FA0.W,A4
	move.l	A4,D0			; Check for namespace (ANO_NameSpace)
	moveq	#0,D1			; Default value
	move.l	A3,A0			; Taglist
	bsr.w	GetTagData		; Get the data
	move.l	D0,D3			; Check if real...
	beq.b	alloc_nns		; If FALSE, skip...
	moveq	#$3E,D3			; Get namespace size
alloc_nns
	move.l	A4,D0
	addq.w	#1,D0			; Check for user space
	moveq	#0,D1			; default none...
	move.l	A3,A0			; Tag list
	bsr.w	GetTagData		; Get the data...
	move.l	D0,D2			; save it...
	beq.b	alloc_nud		; If none, we skip...
	addq.l	#3,D2			; Bump to long align it...
alloc_nud
	moveq	#$1C,D0			; Root object size
	move.l	A2,A0			; Get string again...
alloc_Count
	addq.l	#1,D0			; Count one...
	tst.b	(A0)+			; Check next byte...
	bne.b	alloc_Count		; Count it (+1 for NULL)
	add.l	D3,D0			; Add in the namespace
	add.l	D2,D0			; Add in the user data
	move.l	#$10001,D1		; MEMF_PUBLIC|MEMF_CLEAR
	jsr	-$2AC(A6)		; Get the memory (AllocVec)
	tst.l	D0			; Check for memory
	beq.b	alloc_exit		; Exit if no memory...

* Check for namespace...

	move.l	D0,A0			; Get pointer...
	moveq	#$1C,D0			; Get size of root object
	add.l	A0,D0			; Point past root object
	tst.l	D3			; Check for name space
	beq.b	alloc_no_ns		; Skip if no name space
	move.l	D0,$14(A0)		; Store it...
	add.l	D3,D0			; Get address of namespace

* Install and copy the name string

alloc_no_ns
	move.l	D0,10(A0)		; Store name...
	move.l	D0,A1			; Get string pointer...
alloc_strcopy
	move.b	(A2)+,(A1)+		; Copy the string...
	bne.b	alloc_strcopy

	lea	$10(A0),A2		; Get return result...
	tst.l	D2			; Do we have user data?
	beq.b	alloc_no_user		; If not, skip...
	moveq	#-4,D0			; Get mask...
	addq.l	#3,A1			; bump up...
	move.l	A1,D1			; Into data reg...
	and.l	D1,D0			; (wish we could do AND A1,D0)
	move.l	D0,(A2)			; Store object pointer...

* Now, if namespace, we will init it...

alloc_no_user
	move.l	A3,A0			; Get tag list
	moveq	#0,D1			; Get default flags
	move.l	A4,D0
	addq.w	#3,D0			; Get flags tag
	bsr.w	GetTagData		; Get the data into d0
	move.l	4(A2),D1		; Get namespace?
	beq.b	alloc_done		; Skip this if none...
	move.l	D1,A0			; Get pointer to object
	move.l	D0,$3A(A0)		; Set the flags...
	move.l	A0,8(A0)		; NameSpace LIST at top
	addq.l	#4,A0
	clr.l	(A0)
	move.l	A0,-(A0)
	lea	12(A0),A0		; Get semaphore
	jsr	-$22E(A6)		; initialize (InitSemaphore)
alloc_done
	move.l	A3,A0			; Get tag list
	moveq	#0,D1			; Default priority
	move.l	A4,D0
	addq.w	#2,D0			; Priority tag
	bsr.w	GetTagData		; Get the data
	move.b	D0,-7(A2)		; Set the priority...
	addq.w	#1,-2(A2)		; Bump use count...
	move.l	A2,D0			; Get return result...
alloc_exit
	movem.l	(SP)+,D2/D3/A2/A3/A4/A6	; Restore
	rts				; exit...

******* utility.library/FreeNamedObject ***************************************
*
*   NAME
*	FreeNamedObject -- frees a name object. (V39)
*
*   SYNOPSIS
*	FreeNamedObject(object);
*			A0
*
*	VOID FreeNamedObject(struct NamedObject *);
*
*   FUNCTION
*	Free one of a number of structures used by utility.library.
*	The item must not be a member of any NameSpace, and no one
*	may have it open other than yourself. If the object also
*	contained a NameSpace, that namespace must be empty.
*	Any additional space allocated via the datasize parameter
*	for AllocNamedObject() is also released.
*
*   INPUTS
*	object - the object to be freed
*
*   SEE ALSO
*	AllocNamedObjectA()
*
*******************************************************************************

FreeNamedObject
;	MOVE.L	A6,-(SP)
;	MOVEA.L	($24,A6),A6
;	MOVE.L	A0,D0
;	BEQ.B	lbC000AF4
;	LEA	(-$10,A0),A0			; Adjust to real start...
;	JSR	(-$2B2,A6)			; FreeVec
;lbC000AF4	MOVEA.L	(SP)+,A6
;	RTS

	move.l	A0,D0
	beq.b	FNO_Quit
	move.l	A6,-(SP)
	move.l	$24(A6),A6
	lea	-$10(A0),A0			; Adjust to real start...
	jsr	-$2B2(A6)			; FreeVec
	move.l	(SP)+,A6
FNO_Quit
	rts

LibName	dc.b	'utility.library',0
LibId	dc.b	'utility 41.0 (18.10.2014)',$D,$A,0
	cnop	0,4
EndSkip
